(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    196404,       5517]
NotebookOptionsPosition[    182115,       5064]
NotebookOutlinePosition[    182493,       5081]
CellTagsIndexPosition[    182450,       5078]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["S = 1/2  Heisenberg model", "Section",
 CellChangeTimes->{{3.508786172194064*^9, 3.508786182305313*^9}, {
  3.508788750786186*^9, 3.508788750882126*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["H", "Heisenberg"], "=", " ", 
  RowBox[{"J", " ", 
   RowBox[{
    SubscriptBox["\[Sum]", 
     RowBox[{
      RowBox[{"<", "i"}], ",", 
      RowBox[{"j", ">"}]}]], 
    RowBox[{
     SubscriptBox["S", "i"], ".", 
     SubscriptBox["S", "j"]}]}]}]}]], "Text",
 CellChangeTimes->{{3.508788774779942*^9, 3.508788814118443*^9}}],

Cell["\<\
Basis representation : Direct product of spinors  for both sites\
\>", "Text",
 CellChangeTimes->{{3.5099647516573553`*^9, 3.5099647672152348`*^9}, {
  3.509964803425087*^9, 3.509964833873074*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"S12basis", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.508788879637247*^9, 3.508788898991542*^9}, {
  3.508788932053474*^9, 3.50878893450756*^9}, {3.508788970691636*^9, 
  3.508789016790594*^9}, {3.508789132006886*^9, 3.508789167693777*^9}, {
  3.5087895524623213`*^9, 3.508789574787383*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HS12", "[", 
   RowBox[{"f_", ",", "i_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   FractionBox["J", "4"], " ", 
   RowBox[{"Sum", "[", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ".", 
       RowBox[{"PauliMatrix", "[", "\[Alpha]", "]"}], ".", 
       RowBox[{"i", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "*", 
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"[", "2", "]"}], "]"}], ".", 
       RowBox[{"PauliMatrix", "[", "\[Alpha]", "]"}], ".", 
       RowBox[{"i", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "3"}], "}"}]}], " ", 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HS12matrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HS12", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "S12basis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "S12basis"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HS12matrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.508789248939413*^9, 3.508789423575313*^9}, {
  3.509079076323452*^9, 3.509079094436656*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["J", "4"], "0", "0", "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["J", "4"]}], 
      FractionBox["J", "2"], "0"},
     {"0", 
      FractionBox["J", "2"], 
      RowBox[{"-", 
       FractionBox["J", "4"]}], "0"},
     {"0", "0", "0", 
      FractionBox["J", "4"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090791028068733`*^9, 3.509173187234962*^9, 
  3.5099658620160637`*^9, 3.5100302887507687`*^9, 3.5103256240675163`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sectors", "Subsection",
 CellChangeTimes->{{3.5099648816219482`*^9, 3.509964883105729*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "The", " ", "total", " ", "spin", " ", "component", " ", "along", " ", 
   "one", " ", "direction", " ", "is", " ", "conserved"}], ",", " ", 
  RowBox[{
   RowBox[{
   "hence", " ", "we", " ", "can", " ", "split", " ", "the", " ", 
    "Hamiltonian", " ", "into", " ", "sectors", " ", 
    SubsuperscriptBox["S", "z", 
     RowBox[{"(", "tot", ")"}]]}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}], "."}]}]}]], "Text",
 CellChangeTimes->{{3.509966389957258*^9, 3.509966491396262*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"basis", ",", "H", ",", "evals", ",", "evecs"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SubscriptBox[\(S\), \(z\)]\)=\>\"", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"basis", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ".", 
            RowBox[{"PauliMatrix", "[", "3", "]"}], ".", 
            RowBox[{
             RowBox[{"basis", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "+", 
           RowBox[{
            RowBox[{
             RowBox[{"basis", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ".", 
            RowBox[{"PauliMatrix", "[", "3", "]"}], ".", 
            RowBox[{
             RowBox[{"basis", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], ")"}], "/", "2"}], ",", 
        "\"\<:\>\""}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\\tStates: \>\"", ",", " ", "basis"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"H", " ", "=", " ", 
       RowBox[{"Table", "[", " ", 
        RowBox[{
         RowBox[{"HS12", "[", 
          RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"f", ",", "basis"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "basis"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\\tH:\>\"", ",", 
        RowBox[{"MatrixForm", "[", "H", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"evals", ",", "evecs"}], "}"}], " ", "=", " ", 
       RowBox[{"Eigensystem", "[", "H", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", "\"\<\\tEigenstates:\>\"", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"\"\<\\t\\tE=\>\"", ",", 
          RowBox[{"evals", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<: \>\"", ",", 
          RowBox[{"evecs", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"Length", "[", "evals", "]"}]}], "}"}]}], "]"}], ";"}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"basis", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"S12basis", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"S12basis", "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"S12basis", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"S12basis", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "}"}]}], "}"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.509965143823481*^9, 3.509965191117568*^9}, {
  3.509965264742386*^9, 3.509965358552906*^9}, {3.509965390504612*^9, 
  3.509965435745974*^9}, {3.509965468672267*^9, 3.509965808634406*^9}, {
  3.509965946931533*^9, 3.509966095886098*^9}, {3.509966166089438*^9, 
  3.5099662664330482`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(z\\)]\\)=\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"-", "1"}], "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\!\(\*SubscriptBox[\(S\), \(z\)]\)=", -1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624153186*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tStates: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "}"}]}],
  SequenceForm["\tStates: ", {{{0, 1}, {0, 1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.5103256241557083`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tH:\"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["J", "4"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tH:", 
   MatrixForm[{{Rational[1, 4] $CellContext`J}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.5103256241587877`*^9}],

Cell[BoxData["\<\"\\tEigenstates:\"\>"], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.5103256241618233`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   FractionBox["J", "4"], "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["\t\tE=", Rational[1, 4] $CellContext`J, ": ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624164914*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(z\\)]\\)=\"\>", 
   "\[InvisibleSpace]", "0", "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\!\(\*SubscriptBox[\(S\), \(z\)]\)=", 0, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624167997*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tStates: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], "}"}]}],
  SequenceForm["\tStates: ", {{{0, 1}, {1, 0}}, {{1, 0}, {0, 1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.5103256241713867`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tH:\"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["J", "4"]}], 
        FractionBox["J", "2"]},
       {
        FractionBox["J", "2"], 
        RowBox[{"-", 
         FractionBox["J", "4"]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tH:", 
   MatrixForm[{{
     Rational[-1, 4] $CellContext`J, Rational[1, 2] $CellContext`J}, {
     Rational[1, 2] $CellContext`J, Rational[-1, 4] $CellContext`J}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624174748*^9}],

Cell[BoxData["\<\"\\tEigenstates:\"\>"], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.5103256241777554`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", "J"}], "4"]}], "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}],
  SequenceForm["\t\tE=", Rational[-3, 4] $CellContext`J, ": ", {-1, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.5103256241811113`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   FractionBox["J", "4"], "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}],
  SequenceForm["\t\tE=", Rational[1, 4] $CellContext`J, ": ", {1, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624184245*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(z\\)]\\)=\"\>", 
   "\[InvisibleSpace]", "1", "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\!\(\*SubscriptBox[\(S\), \(z\)]\)=", 1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624187385*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tStates: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}], "}"}], "}"}]}],
  SequenceForm["\tStates: ", {{{1, 0}, {1, 0}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.5103256241905603`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tH:\"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["J", "4"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tH:", 
   MatrixForm[{{Rational[1, 4] $CellContext`J}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624193729*^9}],

Cell[BoxData["\<\"\\tEigenstates:\"\>"], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624196755*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   FractionBox["J", "4"], "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["\t\tE=", Rational[1, 4] $CellContext`J, ": ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.50996609909663*^9, {3.509966180378068*^9, 3.509966199650675*^9}, 
   3.509966232338327*^9, 3.509966267432103*^9, 3.510030289675577*^9, 
   3.510325624199864*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"We", " ", "see", " ", "the", " ", "S"}], "=", 
   RowBox[{
    RowBox[{"1", " ", "triplet", " ", "with", " ", "energy", " ", 
     FractionBox["J", "4"], " ", "and", " ", "the", " ", "S"}], "=", 
    RowBox[{
     RowBox[{"0", " ", "singlet", " ", "at", " ", "E"}], "=", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["3", "4"]}], 
      RowBox[{"J", ".", " ", "The"}], " ", "former", " ", "is", " ", "the", 
      " ", "ground", " ", "state", " ", "for", " ", "ferromagnetic", " ", 
      "coupling", " ", 
      RowBox[{"(", 
       RowBox[{"J", "<", "0"}], ")"}]}]}]}]}], ",", " ", 
  RowBox[{"the", " ", "latter", " ", "for", " ", "antiferromagnetic", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"J", ">", "0"}], ")"}], "."}]}]}]], "Text",
 CellChangeTimes->{{3.509966525102811*^9, 3.509966644198653*^9}, {
  3.509967249518231*^9, 3.509967262909925*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["S = 1  Heisenberg model", "Section",
 CellChangeTimes->{{3.508786172194064*^9, 3.508786182305313*^9}}],

Cell[BoxData[
 RowBox[{"Basis", " ", 
  RowBox[{"representation", " ", ":", " ", 
   RowBox[{"Direct", " ", "product", " ", "of", " ", 
    SubscriptBox["S", "z"], " ", "eigenstates", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"|", 
       RowBox[{"m", ">"}]}], ",", 
      RowBox[{"m", "=", 
       RowBox[{"-", "1"}]}], ",", "0", ",", "1"}], "}"}], "  ", "for", " ", 
    "both", " ", "sites"}]}]}]], "Text",
 CellChangeTimes->{{3.509966763800754*^9, 3.509966825488346*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"S1basis", " ", "=", " ", 
  RowBox[{"Flatten", "[", " ", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m", ",", "n"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", 
        RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", 
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], ",", " ", "1"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5087862610990973`*^9, 3.508786332818791*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.50878633369862*^9, 3.509173187405579*^9, 
  3.509966879484519*^9, 3.510030290495617*^9, 3.510325624289016*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Splus", "[", 
   RowBox[{"mf_", ",", "mi_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   SqrtBox[
    RowBox[{"2", "-", 
     RowBox[{"mi", 
      RowBox[{"(", 
       RowBox[{"mi", "+", "1"}], ")"}]}]}]], 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"mf", ",", 
     RowBox[{"mi", "+", "1"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5087863983563547`*^9, 3.508786556485632*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sminus", "[", 
   RowBox[{"mf_", ",", "mi_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   SqrtBox[
    RowBox[{"2", "-", 
     RowBox[{"mi", 
      RowBox[{"(", 
       RowBox[{"mi", "-", "1"}], ")"}]}]}]], 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"mf", ",", 
     RowBox[{"mi", "-", "1"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5087863983563547`*^9, 3.50878657977427*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sx", "[", "i__", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Splus", "[", "i", "]"}], "+", 
     RowBox[{"Sminus", "[", "i", "]"}]}], ")"}], "/", "2"}]}]], "Input",
 CellChangeTimes->{{3.508786586401273*^9, 3.508786643215939*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sy", "[", "i__", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Splus", "[", "i", "]"}], "-", 
     RowBox[{"Sminus", "[", "i", "]"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", " ", "I"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.508786586401273*^9, 3.50878666393498*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sz", "[", 
   RowBox[{"mf_", ",", "mi_"}], "]"}], " ", ":=", " ", 
  RowBox[{"mi", " ", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"mf", ",", "mi"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.508786675973007*^9, 3.508786707775208*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"HS1", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"mf_", ",", "nf_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"mi_", ",", "ni_"}], "}"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"J", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Sx", "[", 
       RowBox[{"mf", ",", "mi"}], "]"}], " ", 
      RowBox[{"Sx", "[", 
       RowBox[{"nf", ",", "ni"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Sy", "[", 
       RowBox[{"mf", ",", "mi"}], "]"}], " ", 
      RowBox[{"Sy", "[", 
       RowBox[{"nf", ",", "ni"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Sz", "[", 
       RowBox[{"mf", ",", "mi"}], "]"}], " ", 
      RowBox[{"Sz", "[", 
       RowBox[{"nf", ",", "ni"}], "]"}]}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.508786347779708*^9, 3.508786369466791*^9}, {
  3.508786727583376*^9, 3.50878676062428*^9}, {3.508786793341441*^9, 
  3.5087868517415657`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"HS1matrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HS1", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "S1basis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "S1basis"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5087868796564083`*^9, 3.508786920936434*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HS1matrix", "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.508786923121214*^9, 3.508786931311994*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"J", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "J", "0", "0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", "J"}], "0", "J", "0", "0", "0", "0"},
     {"0", "J", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "J", "0", "0", "0", "J", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "J", "0"},
     {"0", "0", "0", "0", "J", "0", 
      RowBox[{"-", "J"}], "0", "0"},
     {"0", "0", "0", "0", "0", "J", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "J"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.508786931886113*^9, 3.5099668798027277`*^9, 
  3.5100302907184362`*^9, 3.5103256245670757`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sectors", "Subsection",
 CellChangeTimes->{{3.5099668911983957`*^9, 3.509966892640156*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Again", ":", " ", 
   RowBox[{
   "The", " ", "total", " ", "spin", " ", "component", " ", "along", " ", 
    "one", " ", "direction", " ", "is", " ", "conserved"}]}], ",", " ", 
  RowBox[{
   RowBox[{
   "hence", " ", "we", " ", "can", " ", "split", " ", "the", " ", 
    "Hamiltonian", " ", "into", " ", "sectors", " ", 
    SubsuperscriptBox["S", "z", 
     RowBox[{"(", "tot", ")"}]]}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "2"}], ",", 
      RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "2"}], "}"}], 
    "."}]}]}]], "Text",
 CellChangeTimes->{{3.509966389957258*^9, 3.509966491396262*^9}, {
  3.509967538545294*^9, 3.509967548280451*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"sz", ",", "basis", ",", "H", ",", "evals", ",", "evecs"}], "}"}],
    ",", "\[IndentingNewLine]", 
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<\!\(\*SubscriptBox[\(S\), \(z\)]\) = \>\"", ",", "sz", ",", 
        "\"\<:\>\""}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"basis", " ", "=", " ", 
       RowBox[{"Select", "[", 
        RowBox[{"S1basis", ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "+", 
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "\[Equal]", "sz"}], "&"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\\tBasis: \>\"", ",", "basis"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"H", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"HS1", "[", 
          RowBox[{"f", ",", "i"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"f", ",", "basis"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "basis"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\\tHamiltonian: \>\"", ",", 
        RowBox[{"MatrixForm", "[", "H", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\\tEigensystem: \>\"", ",", 
        RowBox[{"Eigensystem", "[", "H", "]"}]}], "]"}], ";"}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"sz", ",", 
       RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.509966931310486*^9, 3.509967156311015*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(z\\)]\\) = \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"-", "2"}], "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\!\(\*SubscriptBox[\(S\), \(z\)]\) = ", -2, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.5103256246507673`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "}"}], "}"}]}],
  SequenceForm["\tBasis: ", {{-1, -1}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624652732*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"J"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{$CellContext`J}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.5103256246565313`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tEigensystem: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "J", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "1", "}"}], "}"}]}], "}"}]}],
  SequenceForm["\tEigensystem: ", {{$CellContext`J}, {{1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624660328*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(z\\)]\\) = \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"-", "1"}], "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\!\(\*SubscriptBox[\(S\), \(z\)]\) = ", -1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624664104*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "}"}]}],
  SequenceForm["\tBasis: ", {{-1, 0}, {0, -1}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624667982*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "J"},
       {"J", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{0, $CellContext`J}, {$CellContext`J, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624671771*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tEigensystem: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "J"}], ",", "J"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], "}"}]}],
  SequenceForm[
  "\tEigensystem: ", {{-$CellContext`J, $CellContext`J}, {{-1, 1}, {1, 1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.5103256246758947`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(z\\)]\\) = \"\>", 
   "\[InvisibleSpace]", "0", "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\!\(\*SubscriptBox[\(S\), \(z\)]\) = ", 0, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.5103256246800117`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "}"}]}],
  SequenceForm["\tBasis: ", {{-1, 1}, {0, 0}, {1, -1}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624684224*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", "J"}], "J", "0"},
       {"J", "0", "J"},
       {"0", "J", 
        RowBox[{"-", "J"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{-$CellContext`J, $CellContext`J, 0}, {$CellContext`J, 
      0, $CellContext`J}, {0, $CellContext`J, -$CellContext`J}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624688529*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tEigensystem: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "J"}], ",", 
       RowBox[{"-", "J"}], ",", "J"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "1"}], "}"}]}], "}"}]}], "}"}]}],
  SequenceForm[
  "\tEigensystem: ", {{(-2) $CellContext`J, -$CellContext`J, $CellContext`J}, \
{{1, -1, 1}, {-1, 0, 1}, {1, 2, 1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624692791*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(z\\)]\\) = \"\>", 
   "\[InvisibleSpace]", "1", "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\!\(\*SubscriptBox[\(S\), \(z\)]\) = ", 1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624696945*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}],
  SequenceForm["\tBasis: ", {{0, 1}, {1, 0}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.5103256247011633`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "J"},
       {"J", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{0, $CellContext`J}, {$CellContext`J, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624705394*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tEigensystem: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "J"}], ",", "J"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], "}"}]}],
  SequenceForm[
  "\tEigensystem: ", {{-$CellContext`J, $CellContext`J}, {{-1, 1}, {1, 1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.5103256247095957`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\!\\(\\*SubscriptBox[\\(S\\), \\(z\\)]\\) = \"\>", 
   "\[InvisibleSpace]", "2", "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\!\(\*SubscriptBox[\(S\), \(z\)]\) = ", 2, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.5103256247136393`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "}"}]}],
  SequenceForm["\tBasis: ", {{1, 1}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624717375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"J"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{$CellContext`J}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624721262*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tEigensystem: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "J", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "1", "}"}], "}"}]}], "}"}]}],
  SequenceForm["\tEigensystem: ", {{$CellContext`J}, {{1}}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099671576323977`*^9, 3.510030291144125*^9, 
  3.510325624724963*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bose - Hubbard model", "Section",
 CellChangeTimes->{{3.50878589074474*^9, 3.50878589768194*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["H", "BH"], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "t"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox["b", "1", "\[Dagger]"], 
       SubscriptBox["b", "2"]}], "+", 
      RowBox[{
       SubsuperscriptBox["b", "2", "\[Dagger]"], 
       SubscriptBox["b", "1"]}]}], ")"}]}], " ", "+", " ", 
   RowBox[{
    FractionBox["U", "2"], 
    RowBox[{
     SubscriptBox["\[Sum]", "i"], 
     RowBox[{
      SubscriptBox["n", "i"], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["n", "i"], "-", "1"}], ")"}]}]}]}]}]}]], "Text",
 CellChangeTimes->{{3.508785909962515*^9, 3.508786058066607*^9}, {
  3.604145727373187*^9, 3.604145764200634*^9}}],

Cell[CellGroupData[{

Cell["Basis", "Subsection",
 CellChangeTimes->{{3.509082062674439*^9, 3.509082063268136*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "The", " ", "basis", " ", "can", " ", "be", " ", "enumerated", " ", "by", 
   " ", "the", " ", "number", " ", "of", " ", "particles", " ", "on", " ", 
   "each", " ", 
   RowBox[{"site", ".", " ", "\[IndentingNewLine]", "We"}], " ", "employ", 
   " ", "a", " ", "maximum", " ", "number", " ", "of", " ", "particles", " ", 
   "in", " ", "the", " ", "system", " ", 
   SubscriptBox["N", "max"]}], "=", "4."}]], "Text",
 CellChangeTimes->{{3.510325278460219*^9, 3.5103253468115997`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"maxN", " ", "=", " ", "4"}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Particle", " ", "number", " ", "cut"}], "-", "off"}], " ", 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.508783742570593*^9, 3.508783747959845*^9}, {
  3.5090820761803417`*^9, 3.509082079140167*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BHBasis", " ", "=", " ", 
  RowBox[{"Flatten", "[", " ", 
   RowBox[{
    RowBox[{"Table", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"n", "-", "k"}]}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", "maxN"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"k", ",", "0", ",", "n"}], "}"}]}], "]"}], ",", " ", "1"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.508783880127376*^9, 3.508783991254715*^9}, {
  3.508784023788666*^9, 3.508784071702196*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5087839933307667`*^9, 3.508784032836603*^9, 
  3.508784072438197*^9, 3.508837210475828*^9, 3.5099677524359627`*^9, 
  3.510030291498403*^9, 3.510325624801455*^9, 3.540571399199623*^9, 
  3.5405714508984327`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hamiltonian", "Subsection",
 CellChangeTimes->{{3.5090820847471533`*^9, 3.5090820861656647`*^9}}],

Cell["Creation/annihilation operators", "Text",
 CellChangeTimes->{{3.5099682689662123`*^9, 3.509968276663623*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Bcrt", "[", 
    RowBox[{"f_", ",", "i_"}], "]"}], ":=", 
   RowBox[{
    SqrtBox["f"], 
    RowBox[{"KroneckerDelta", "[", 
     RowBox[{"f", ",", 
      RowBox[{"i", "+", "1"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bann", "[", 
    RowBox[{"f_", ",", "i_"}], "]"}], ":=", 
   RowBox[{
    SqrtBox["i"], 
    RowBox[{"KroneckerDelta", "[", 
     RowBox[{"f", ",", 
      RowBox[{"i", "-", "1"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.509968078139415*^9, 3.509968094293738*^9}, {
  3.509968191759656*^9, 3.509968259817408*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"HBH", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"k_", ",", "l_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"m_", ",", "n_"}], "}"}]}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "t"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Bcrt", "[", 
         RowBox[{"k", ",", "m"}], "]"}], 
        RowBox[{"Bann", "[", 
         RowBox[{"l", ",", "n"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"Bann", "[", 
         RowBox[{"k", ",", "m"}], "]"}], 
        RowBox[{"Bcrt", "[", 
         RowBox[{"l", ",", "n"}], "]"}]}]}], ")"}]}], " ", "+", 
    RowBox[{
     FractionBox["U", "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"m", 
        RowBox[{"(", 
         RowBox[{"m", "-", "1"}], ")"}]}], "+", 
       RowBox[{"n", 
        RowBox[{"(", 
         RowBox[{"n", "-", "1"}], ")"}]}]}], ")"}], 
     RowBox[{"DiscreteDelta", "[", 
      RowBox[{
       RowBox[{"k", "-", "m"}], ",", 
       RowBox[{"l", "-", "n"}]}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HBHmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HBH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "BHBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "BHBasis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HBHmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.5087832565532103`*^9, 3.508783258500182*^9}, {
  3.508783348190814*^9, 3.5087836326748962`*^9}, {3.508783843170176*^9, 
  3.508783850313211*^9}, {3.508785074190639*^9, 3.508785080524797*^9}, {
  3.508837185610881*^9, 3.508837187974235*^9}, {3.50908212588087*^9, 
  3.509082126938532*^9}, {3.5099682998047523`*^9, 3.509968388579712*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0"},
     {"0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0", "0"},
     {"0", "0", "0", "U", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["2"]}], " ", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["2"]}], " ", "t"}], "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["2"]}], " ", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", 
      "0"},
     {"0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["2"]}], " ", "t"}], "U", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"3", " ", "U"}], 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["3"]}], " ", "t"}], "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["3"]}], " ", "t"}], "U", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "t"}], "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "t"}], "U", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["3"]}], " ", "t"}], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["3"]}], " ", "t"}], 
      RowBox[{"3", " ", "U"}], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"6", " ", "U"}], 
      RowBox[{
       RowBox[{"-", "2"}], " ", "t"}], "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "t"}], 
      RowBox[{"3", " ", "U"}], 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["6"]}], " ", "t"}], "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["6"]}], " ", "t"}], 
      RowBox[{"2", " ", "U"}], 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["6"]}], " ", "t"}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["6"]}], " ", "t"}], 
      RowBox[{"3", " ", "U"}], 
      RowBox[{
       RowBox[{"-", "2"}], " ", "t"}]},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "t"}], 
      RowBox[{"6", " ", "U"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.509082131779736*^9, 3.509967752469507*^9, 
  3.509968401732951*^9, 3.5100302916118517`*^9, 3.510325624884994*^9, 
  3.540571399332176*^9, 3.540571450965391*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sectors", "Subsection",
 CellChangeTimes->{{3.509082181075365*^9, 3.509082182381535*^9}}],

Cell["\<\
The Hamiltonian conserves the total particle number (U (1) symmetry), hence \
we can split into N - sectors\
\>", "Text",
 CellChangeTimes->{{3.509968520289266*^9, 3.509968574091744*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"doBHSector", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"basis", ",", "hmatrix", ",", "evals", ",", "evecs"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Print", "[", 
      RowBox[{"\"\<N = \>\"", ",", "n", ",", "\"\<:\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"basis", " ", "=", " ", 
      RowBox[{"Select", "[", 
       RowBox[{"BHBasis", ",", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "+", 
           RowBox[{"#", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "\[Equal]", "n"}], "&"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<\\tBasis: \>\"", ",", "basis"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"hmatrix", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"HBH", "[", 
         RowBox[{"f", ",", "i"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"f", ",", "basis"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "basis"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<\\tHamiltonian: \>\"", ",", 
       RowBox[{"MatrixForm", "[", "hmatrix", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"evals", ",", "evecs"}], "}"}], "=", 
         RowBox[{"Eigensystem", "[", 
          RowBox[{"hmatrix", "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"t", "\[Rule]", "1."}], ",", 
             RowBox[{"U", "\[Rule]", "u"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<\\tU=\>\"", ",", "u", ",", "\"\<:\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", " ", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<\\t\\tE=\>\"", ",", 
            RowBox[{"evals", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<\\t\>\"", ",", 
            RowBox[{"evecs", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "evals", "]"}]}], "}"}]}], "]"}]}], 
       "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"u", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1", ",", "4"}], "}"}]}], "}"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.50908224727859*^9, 3.509082288139579*^9}, {
   3.509082320253356*^9, 3.509082470192093*^9}, {3.509082502426523*^9, 
   3.509082652102894*^9}, {3.509082847502182*^9, 3.5090828601355143`*^9}, {
   3.509082946714623*^9, 3.5090829706468163`*^9}, {3.509967733608123*^9, 
   3.509967737366346*^9}, {3.509967793863312*^9, 3.509967827009042*^9}, 
   3.509968584801321*^9, {3.510030751538084*^9, 3.510030915952474*^9}, {
   3.510031123165592*^9, 3.510031207096511*^9}, {3.510031247272181*^9, 
   3.510031252013926*^9}, 3.5405714450428543`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"n", "=", "0"}], ",", 
   RowBox[{"n", "\[LessEqual]", "maxN"}], ",", 
   RowBox[{"n", "++"}], ",", 
   RowBox[{"doBHSector", "[", "n", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.509082832796688*^9, 3.509082833933125*^9}, {
  3.509082874846966*^9, 3.5090829227496147`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"N = \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["N = ", 0, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451033278*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}], "}"}]}],
  SequenceForm["\tBasis: ", {{0, 0}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714510347147`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451036318*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1"}], "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", -1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451037891*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["\t\tE=", 0, "\t", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451039425*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451040916*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["\t\tE=", 0, "\t", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451042637*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 4, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451044293*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["\t\tE=", 0, "\t", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451045948*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"N = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["N = ", 1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451047605*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}],
  SequenceForm["\tBasis: ", {{0, 1}, {1, 0}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714510493097`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        RowBox[{"-", "t"}]},
       {
        RowBox[{"-", "t"}], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{0, -$CellContext`t}, {-$CellContext`t, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714510511723`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1"}], "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", -1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451052959*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7071067811865475`"}], ",", 
     RowBox[{"-", "0.7071067811865475`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", -1., "\t", {-0.7071067811865475, -0.7071067811865475}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714510546703`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7071067811865475`"}], ",", "0.7071067811865475`"}], 
    "}"}]}],
  SequenceForm["\t\tE=", 1., "\t", {-0.7071067811865475, 0.7071067811865475}],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451056407*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451058135*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7071067811865475`"}], ",", 
     RowBox[{"-", "0.7071067811865475`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", -1., "\t", {-0.7071067811865475, -0.7071067811865475}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451059902*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7071067811865475`"}], ",", "0.7071067811865475`"}], 
    "}"}]}],
  SequenceForm["\t\tE=", 1., "\t", {-0.7071067811865475, 0.7071067811865475}],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.54057145106172*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 4, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451063243*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7071067811865475`"}], ",", 
     RowBox[{"-", "0.7071067811865475`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", -1., "\t", {-0.7071067811865475, -0.7071067811865475}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451064823*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7071067811865475`"}], ",", "0.7071067811865475`"}], 
    "}"}]}],
  SequenceForm["\t\tE=", 1., "\t", {-0.7071067811865475, 0.7071067811865475}],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451066381*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"N = \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["N = ", 2, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451067906*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}]}], "}"}]}],
  SequenceForm["\tBasis: ", {{0, 2}, {1, 1}, {2, 0}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451069434*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"U", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["2"]}], " ", "t"}], "0"},
       {
        RowBox[{
         RowBox[{"-", 
          SqrtBox["2"]}], " ", "t"}], "0", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["2"]}], " ", "t"}]},
       {"0", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["2"]}], " ", "t"}], "U"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{$CellContext`U, -2^Rational[1, 2] $CellContext`t, 
      0}, {-2^Rational[1, 2] $CellContext`t, 
      0, -2^Rational[1, 2] $CellContext`t}, {
     0, -2^Rational[1, 2] $CellContext`t, $CellContext`U}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451071168*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1"}], "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", -1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451072918*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "2.5615528128088276`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.5573454101893045`", ",", "0.6154122094026357`", ",", 
     "0.557345410189303`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", -2.5615528128088276`, "\t", {0.5573454101893045, 
   0.6154122094026357, 0.557345410189303}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714510745068`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.5615528128088303`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.43516214649359936`", ",", 
     RowBox[{"-", "0.7882054380161091`"}], ",", "0.4351621464935993`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 1.5615528128088303`, "\t", {
   0.43516214649359936`, -0.7882054380161091, 0.4351621464935993}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451076109*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "0.9999999999999978`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.7071067811865467`", ",", 
     RowBox[{"-", "8.881784197001278`*^-16"}], ",", 
     RowBox[{"-", "0.7071067811865485`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", -0.9999999999999978, "\t", {
   0.7071067811865467, -8.881784197001278*^-16, -0.7071067811865485}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451077704*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714510793133`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "2.5615528128088303`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.557345410189304`"}], ",", "0.6154122094026356`", ",", 
     RowBox[{"-", "0.5573454101893036`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", 2.5615528128088303`, "\t", {-0.557345410189304, 
   0.6154122094026356, -0.5573454101893036}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451080858*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.5615528128088263`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.43516214649359997`", ",", "0.7882054380161091`", ",", 
     "0.4351621464935987`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", -1.5615528128088263`, "\t", {0.43516214649359997`, 
   0.7882054380161091, 0.4351621464935987}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451082486*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.0000000000000016`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.7071067811865471`", ",", 
     RowBox[{"-", "5.551115123125796`*^-16"}], ",", 
     RowBox[{"-", "0.7071067811865479`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", 1.0000000000000016`, "\t", {
   0.7071067811865471, -5.551115123125796*^-16, -0.7071067811865479}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451084113*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 4, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451085703*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "4.82842712474619`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.6532814824381884`", ",", 
     RowBox[{"-", "0.3826834323650897`"}], ",", "0.6532814824381881`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 4.82842712474619, "\t", {0.6532814824381884, -0.3826834323650897, 
   0.6532814824381881}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451087323*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "4.000000000000001`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.7071067811865472`", ",", 
     RowBox[{"-", "2.775557561562897`*^-16"}], ",", 
     RowBox[{"-", "0.7071067811865477`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", 4.000000000000001, "\t", {
   0.7071067811865472, -2.775557561562897*^-16, -0.7071067811865477}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451088966*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "0.8284271247461872`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.27059805007309873`", ",", "0.9238795325112868`", ",", 
     "0.2705980500730982`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", -0.8284271247461872, "\t", {0.27059805007309873`, 
   0.9238795325112868, 0.2705980500730982}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451090748*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"N = \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["N = ", 3, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.54057145109268*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}]}], "}"}]}],
  SequenceForm["\tBasis: ", {{0, 3}, {1, 2}, {2, 1}, {3, 0}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714510943413`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"3", " ", "U"}], 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["3"]}], " ", "t"}], "0", "0"},
       {
        RowBox[{
         RowBox[{"-", 
          SqrtBox["3"]}], " ", "t"}], "U", 
        RowBox[{
         RowBox[{"-", "2"}], " ", "t"}], "0"},
       {"0", 
        RowBox[{
         RowBox[{"-", "2"}], " ", "t"}], "U", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["3"]}], " ", "t"}]},
       {"0", "0", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["3"]}], " ", "t"}], 
        RowBox[{"3", " ", "U"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{
     3 $CellContext`U, -3^Rational[1, 2] $CellContext`t, 0, 
      0}, {-3^Rational[
        1, 2] $CellContext`t, $CellContext`U, (-2) $CellContext`t, 0}, {
     0, (-2) $CellContext`t, $CellContext`U, -3^
       Rational[1, 2] $CellContext`t}, {
     0, 0, -3^Rational[1, 2] $CellContext`t, 3 $CellContext`U}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451096223*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1"}], "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", -1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451097972*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "4.732050807568877`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.4999999999999997`", ",", "0.4999999999999997`", ",", 
     "0.5000000000000002`", ",", "0.5000000000000002`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", -4.732050807568877, "\t", {0.4999999999999997, 0.4999999999999997,
    0.5000000000000002, 0.5000000000000002}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451099531*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "3.645751311064592`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.6625573458234493`", ",", "0.24701773923219902`", ",", 
     RowBox[{"-", "0.24701773923219866`"}], ",", 
     RowBox[{"-", "0.6625573458234487`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", -3.645751311064592, "\t", {0.6625573458234493, 
   0.24701773923219902`, -0.24701773923219866`, -0.6625573458234487}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451101159*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.6457513110645792`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.2470177392321991`", ",", 
     RowBox[{"-", "0.6625573458234495`"}], ",", "0.6625573458234485`", ",", 
     RowBox[{"-", "0.2470177392321986`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", 1.6457513110645792`, "\t", {
   0.2470177392321991, -0.6625573458234495, 
   0.6625573458234485, -0.2470177392321986}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451102783*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.2679491924311241`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.4999999999999998`", ",", 
     RowBox[{"-", "0.49999999999999967`"}], ",", 
     RowBox[{"-", "0.5000000000000004`"}], ",", "0.5000000000000002`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", -1.2679491924311241`, "\t", {
   0.4999999999999998, -0.49999999999999967`, -0.5000000000000004, 
   0.5000000000000002}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714511045856`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714511061993`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "4.732050807568877`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.4999999999999997`", ",", 
     RowBox[{"-", "0.4999999999999997`"}], ",", "0.5000000000000002`", ",", 
     RowBox[{"-", "0.5000000000000002`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", 4.732050807568877, "\t", {0.4999999999999997, -0.4999999999999997,
    0.5000000000000002, -0.5000000000000002}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451107786*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "3.645751311064592`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.6625573458234493`", ",", 
     RowBox[{"-", "0.24701773923219902`"}], ",", 
     RowBox[{"-", "0.24701773923219866`"}], ",", "0.6625573458234487`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 3.645751311064592, "\t", {
   0.6625573458234493, -0.24701773923219902`, -0.24701773923219866`, 
   0.6625573458234487}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451109453*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.6457513110645792`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.2470177392321991`", ",", "0.6625573458234495`", ",", 
     "0.6625573458234485`", ",", "0.2470177392321986`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", -1.6457513110645792`, "\t", {0.2470177392321991, 
   0.6625573458234495, 0.6625573458234485, 0.2470177392321986}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451111092*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.2679491924311241`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.4999999999999998`"}], ",", 
     RowBox[{"-", "0.49999999999999967`"}], ",", "0.5000000000000004`", ",", 
     "0.5000000000000002`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", 1.2679491924311241`, 
   "\t", {-0.4999999999999998, -0.49999999999999967`, 0.5000000000000004, 
   0.5000000000000002}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451112754*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 4, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451114336*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "12.464101615137755`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6830127018922189`"}], ",", "0.18301270189221922`", ",", 
     RowBox[{"-", "0.1830127018922194`"}], ",", "0.6830127018922196`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 12.464101615137755`, "\t", {-0.6830127018922189, 
   0.18301270189221922`, -0.1830127018922194, 0.6830127018922196}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714511159*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "12.291502622129181`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.697300362563198`", ",", 
     RowBox[{"-", "0.11735503555124092`"}], ",", 
     RowBox[{"-", "0.11735503555124085`"}], ",", "0.6973003625631974`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 12.291502622129181`, "\t", {
   0.697300362563198, -0.11735503555124092`, -0.11735503555124085`, 
   0.6973003625631974}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.54057145111756*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "5.535898384862242`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.18301270189221913`", ",", "0.6830127018922187`", ",", 
     RowBox[{"-", "0.68301270189222`"}], ",", 
     RowBox[{"-", "0.18301270189221946`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", 5.535898384862242, "\t", {0.18301270189221913`, 
   0.6830127018922187, -0.68301270189222, -0.18301270189221946`}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.54057145111919*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.7084973778708186`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.1173550355512409`", ",", "0.6973003625631979`", ",", 
     "0.6973003625631975`", ",", "0.11735503555124083`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", 1.7084973778708186`, "\t", {0.1173550355512409, 
   0.6973003625631979, 0.6973003625631975, 0.11735503555124083`}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.54057145112082*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"N = \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["N = ", 4, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714511224203`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tBasis: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0"}], "}"}]}], "}"}]}],
  SequenceForm["\tBasis: ", {{0, 4}, {1, 3}, {2, 2}, {3, 1}, {4, 0}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451124012*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tHamiltonian: \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"6", " ", "U"}], 
        RowBox[{
         RowBox[{"-", "2"}], " ", "t"}], "0", "0", "0"},
       {
        RowBox[{
         RowBox[{"-", "2"}], " ", "t"}], 
        RowBox[{"3", " ", "U"}], 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["6"]}], " ", "t"}], "0", "0"},
       {"0", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["6"]}], " ", "t"}], 
        RowBox[{"2", " ", "U"}], 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["6"]}], " ", "t"}], "0"},
       {"0", "0", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox["6"]}], " ", "t"}], 
        RowBox[{"3", " ", "U"}], 
        RowBox[{
         RowBox[{"-", "2"}], " ", "t"}]},
       {"0", "0", "0", 
        RowBox[{
         RowBox[{"-", "2"}], " ", "t"}], 
        RowBox[{"6", " ", "U"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["\tHamiltonian: ", 
   MatrixForm[{{
     6 $CellContext`U, (-2) $CellContext`t, 0, 0, 0}, {(-2) $CellContext`t, 
      3 $CellContext`U, -6^Rational[1, 2] $CellContext`t, 0, 0}, {
     0, -6^Rational[1, 2] $CellContext`t, 
      2 $CellContext`U, -6^Rational[1, 2] $CellContext`t, 0}, {
     0, 0, -6^Rational[1, 2] $CellContext`t, 
      3 $CellContext`U, (-2) $CellContext`t}, {
     0, 0, 0, (-2) $CellContext`t, 6 $CellContext`U}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451125925*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1"}], "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", -1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451127733*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "7.614627004194527`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.5130089636809934`", ",", "0.41415906307659095`", ",", 
     "0.36136982069473644`", ",", "0.4141590630765912`", ",", 
     "0.5130089636809946`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", -7.614627004194527, "\t", {0.5130089636809934, 
   0.41415906307659095`, 0.36136982069473644`, 0.4141590630765912, 
   0.5130089636809946}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451129314*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "7.`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.632455532033676`"}], ",", 
     RowBox[{"-", "0.3162277660168385`"}], ",", 
     RowBox[{"-", "2.8665835232995152`*^-16"}], ",", "0.3162277660168377`", 
     ",", "0.6324555320336755`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", -7., 
   "\t", {-0.632455532033676, -0.3162277660168385, -2.8665835232995152`*^-16, 
   0.3162277660168377, 0.6324555320336755}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451131008*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "4.632676330081332`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.46864061744857904`"}], ",", "0.3203917044613714`", ",", 
     "0.5961964900764719`", ",", "0.32039170446137066`", ",", 
     RowBox[{"-", "0.4686406174485783`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", -4.632676330081332, "\t", {-0.46864061744857904`, 
   0.3203917044613714, 0.5961964900764719, 
   0.32039170446137066`, -0.4686406174485783}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451132793*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "2.000000000000009`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.3162277660168381`", ",", 
     RowBox[{"-", "0.6324555320336759`"}], ",", "3.4399002279594126`*^-16", 
     ",", "0.6324555320336755`", ",", 
     RowBox[{"-", "0.31622776601683833`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", -2.000000000000009, "\t", {
   0.3162277660168381, -0.6324555320336759, 3.4399002279594126`*^-16, 
   0.6324555320336755, -0.31622776601683833`}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714511344748`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "1.2473033342758466`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.13114028694633678`", ",", 
     RowBox[{"-", "0.47520671942203957`"}], ",", "0.7169111506397076`", ",", 
     RowBox[{"-", "0.47520671942204074`"}], ",", "0.1311402869463372`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 1.2473033342758466`, "\t", {
   0.13114028694633678`, -0.47520671942203957`, 
   0.7169111506397076, -0.47520671942204074`, 0.1311402869463372}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714511361732`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 1, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451137783*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "7.614627004194527`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.5130089636809934`", ",", 
     RowBox[{"-", "0.41415906307659095`"}], ",", "0.36136982069473644`", ",", 
     
     RowBox[{"-", "0.4141590630765912`"}], ",", "0.5130089636809946`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 7.614627004194527, "\t", {
   0.5130089636809934, -0.41415906307659095`, 
   0.36136982069473644`, -0.4141590630765912, 0.5130089636809946}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714511394043`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "7.`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.632455532033676`"}], ",", "0.3162277660168385`", ",", 
     RowBox[{"-", "2.8665835232995152`*^-16"}], ",", 
     RowBox[{"-", "0.3162277660168377`"}], ",", "0.6324555320336755`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 7., "\t", {-0.632455532033676, 
   0.3162277660168385, -2.8665835232995152`*^-16, -0.3162277660168377, 
   0.6324555320336755}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451141101*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "4.632676330081332`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.46864061744857904`"}], ",", 
     RowBox[{"-", "0.3203917044613714`"}], ",", "0.5961964900764719`", ",", 
     RowBox[{"-", "0.32039170446137066`"}], ",", 
     RowBox[{"-", "0.4686406174485783`"}]}], "}"}]}],
  SequenceForm[
  "\t\tE=", 4.632676330081332, 
   "\t", {-0.46864061744857904`, -0.3203917044613714, 
   0.5961964900764719, -0.32039170446137066`, -0.4686406174485783}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451142831*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "2.000000000000009`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3162277660168381`"}], ",", 
     RowBox[{"-", "0.6324555320336759`"}], ",", 
     RowBox[{"-", "3.4399002279594126`*^-16"}], ",", "0.6324555320336755`", 
     ",", "0.31622776601683833`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", 2.000000000000009, 
   "\t", {-0.3162277660168381, -0.6324555320336759, -3.4399002279594126`*^-16,
    0.6324555320336755, 0.31622776601683833`}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451144492*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.2473033342758466`"}], "\[InvisibleSpace]", "\<\"\\t\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.13114028694633678`", ",", "0.47520671942203957`", ",", 
     "0.7169111506397076`", ",", "0.47520671942204074`", ",", 
     "0.1311402869463372`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", -1.2473033342758466`, "\t", {0.13114028694633678`, 
   0.47520671942203957`, 0.7169111506397076, 0.47520671942204074`, 
   0.1311402869463372}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451146185*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\tU=\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\":\"\>"}],
  SequenceForm["\tU=", 4, ":"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.5405714511478033`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "24.344520790605976`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.6963928199041625`", ",", 
     RowBox[{"-", "0.1199609024428538`"}], ",", "0.03595614748615579`", ",", 
     RowBox[{"-", "0.11996090244285405`"}], ",", "0.6963928199041649`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 24.344520790605976`, "\t", {
   0.6963928199041625, -0.1199609024428538, 
   0.03595614748615579, -0.11996090244285405`, 0.6963928199041649}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451149425*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "24.32455532033676`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6979762349196642`"}], ",", "0.11326595025589832`", ",", 
     RowBox[{"-", "9.240734289708722`*^-17"}], ",", 
     RowBox[{"-", "0.11326595025589768`"}], ",", "0.6979762349196614`"}], 
    "}"}]}],
  SequenceForm[
  "\t\tE=", 24.32455532033676, "\t", {-0.6979762349196642, 
   0.11326595025589832`, -9.240734289708722*^-17, -0.11326595025589768`, 
   0.6979762349196614}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451151103*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "13.712026926735188`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.1159463200906007`", ",", "0.5964263095181217`", ",", 
     RowBox[{"-", "0.5115312466937821`"}], ",", "0.5964263095181122`", ",", 
     "0.11594632009059898`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", 13.712026926735188`, "\t", {0.1159463200906007, 
   0.5964263095181217, -0.5115312466937821, 0.5964263095181122, 
   0.11594632009059898`}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451152831*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "11.675444679663245`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.1132659502558974`"}], ",", 
     RowBox[{"-", "0.6979762349196597`"}], ",", 
     RowBox[{"-", "4.397339942392373`*^-15"}], ",", "0.697976234919666`", ",",
      "0.11326595025589856`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", 11.675444679663245`, 
   "\t", {-0.1132659502558974, -0.6979762349196597, -4.397339942392373*^-15, 
   0.697976234919666, 0.11326595025589856`}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451154538*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\\t\\tE=\"\>", "\[InvisibleSpace]", "5.943452282658837`", 
   "\[InvisibleSpace]", "\<\"\\t\"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.03991855763144709`", ",", "0.36039567033982894`", ",", 
     "0.8585120494867028`", ",", "0.360395670339831`", ",", 
     "0.039918557631447374`"}], "}"}]}],
  SequenceForm[
  "\t\tE=", 5.943452282658837, "\t", {0.03991855763144709, 
   0.36039567033982894`, 0.8585120494867028, 0.360395670339831, 
   0.039918557631447374`}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5099677527691174`*^9, 3.509967830061452*^9, 
  3.5099684499525023`*^9, 3.509968589492371*^9, 3.510030292003498*^9, 
  3.510031175129266*^9, 3.5100312099009533`*^9, 3.510031254165797*^9, 
  3.5103256250705147`*^9, 3.5405713993782797`*^9, 3.540571451194001*^9}]
}, Open  ]]
}, Open  ]],

Cell["\<\
In the attractive case (U < 0), the system can gain energy by attracting \
additional particles from the environment.  With positive or vanishing \
chemical potential \[Mu] >= 0 the ground state has infinitely many particles.
For U=1, \[Mu]=0, the ground state among those considered here has N=3 \
particles. The first excitations have 2 and 4 particles, respectively. \
Therefore a higher cut-off than N=4 may make sense.
For U=4, \[Mu]=0, the ground state has N=1 one particle and all states with \
more than 2 particles have such high energies that they are probably \
irrelevant for most purposes.\
\>", "Text",
 CellChangeTimes->{{3.509968717767687*^9, 3.509968750261797*^9}, {
  3.50996886551903*^9, 3.509968892119748*^9}, {3.509969001344927*^9, 
  3.509969037041493*^9}, {3.50996929703123*^9, 3.509969392901599*^9}, {
  3.509969534477647*^9, 3.50996968740697*^9}, {3.509969754048749*^9, 
  3.509969807616721*^9}, {3.5099698937624397`*^9, 3.5099699983311977`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Fermi - Hubbard model", "Section",
 CellChangeTimes->{{3.50878589074474*^9, 3.50878589768194*^9}, {
  3.5088377030353937`*^9, 3.508837704096752*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["H", "FH"], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "t"}], 
    RowBox[{
     SubscriptBox["\[Sum]", "\[Sigma]"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox["c", 
         RowBox[{"1", ",", "\[Sigma]"}], "\[Dagger]"], 
        SubscriptBox["c", 
         RowBox[{"2", ",", "\[Sigma]"}]]}], "+", 
       RowBox[{
        SubsuperscriptBox["c", 
         RowBox[{"2", ",", "\[Sigma]"}], "\[Dagger]"], 
        SubscriptBox["c", 
         RowBox[{"1", ",", "\[Sigma]"}]]}]}], ")"}]}]}], " ", "+", " ", 
   RowBox[{"U", 
    RowBox[{
     SubscriptBox["\[Sum]", "i"], 
     RowBox[{
      SubscriptBox["n", 
       RowBox[{"i", ",", "\[UpArrow]"}]], 
      SubscriptBox["n", 
       RowBox[{"i", ",", "\[DownArrow]"}]]}]}]}]}]}]], "Text",
 CellChangeTimes->{{3.508785909962515*^9, 3.508786058066607*^9}, {
  3.508837708148725*^9, 3.5088377082770853`*^9}, {3.5088379322201977`*^9, 
  3.508837936950053*^9}, {3.6041457814883833`*^9, 3.6041457839908*^9}, {
  3.604145839931108*^9, 3.60414594383324*^9}}],

Cell[CellGroupData[{

Cell["Basis", "Subsection",
 CellChangeTimes->{{3.5090804841292953`*^9, 3.5090804850501823`*^9}}],

Cell["\<\
Basis representation : Number of up and down spins on site 1, number of up \
and down spins on site 2.
We are dealing with fermions, so each site can hold at most one particle of \
each spin.\
\>", "Text",
 CellChangeTimes->{{3.5103254085755367`*^9, 3.510325490075185*^9}, 
   3.604145039062447*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHBasis", " ", "=", " ", 
  RowBox[{"Flatten", "[", " ", 
   RowBox[{
    RowBox[{"Table", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", "j", ",", "k", ",", "l"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", "1"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"j", ",", "0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "0", ",", "1"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"l", ",", "0", ",", "1"}], "}"}]}], "]"}], ",", " ", "3"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.508783880127376*^9, 3.508783991254715*^9}, {
  3.508784023788666*^9, 3.508784071702196*^9}, {3.508837729976532*^9, 
  3.508837730106048*^9}, {3.508837770902673*^9, 3.508837837983169*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5087839933307667`*^9, 3.508784032836603*^9, 3.508784072438197*^9, 
   3.508837210475828*^9, {3.508837821810259*^9, 3.508837838684524*^9}, 
   3.509970045837077*^9, 3.510030292269497*^9, 3.510325625420429*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hamiltonian", "Subsection",
 CellChangeTimes->{{3.5090804925886374`*^9, 3.509080494178164*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"HFH", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"kf_", ",", "lf_", ",", "mf_", ",", "nf_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ki_", ",", "li_", ",", "mi_", ",", "ni_"}], "}"}]}], "]"}], " ",
   ":=", " ", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "t"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"kf", "-", "ki", "-", "1"}], ",", 
        RowBox[{"mf", "-", "mi", "+", "1"}], ",", 
        RowBox[{"lf", "-", "li"}], ",", 
        RowBox[{"nf", "-", "ni"}]}], "]"}], "+", 
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"kf", "-", "ki", "+", "1"}], ",", 
        RowBox[{"mf", "-", "mi", "-", "1"}], ",", 
        RowBox[{"lf", "-", "li"}], ",", 
        RowBox[{"nf", "-", "ni"}]}], "]"}], "+", 
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"kf", "-", "ki"}], ",", 
        RowBox[{"mf", "-", "mi"}], ",", 
        RowBox[{"lf", "-", "li", "-", "1"}], ",", 
        RowBox[{"nf", "-", "ni", "+", "1"}]}], "]"}], "+", 
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"kf", "-", "ki"}], ",", 
        RowBox[{"mf", "-", "mi"}], ",", 
        RowBox[{"lf", "-", "li", "+", "1"}], ",", 
        RowBox[{"nf", "-", "ni", "-", "1"}]}], "]"}]}], ")"}]}], " ", "+", 
   "\[IndentingNewLine]", 
   RowBox[{"U", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"kf", " ", "lf"}], " ", "+", " ", 
      RowBox[{"mf", " ", "nf"}]}], ")"}], 
    RowBox[{"DiscreteDelta", "[", 
     RowBox[{
      RowBox[{"kf", "-", "ki"}], ",", 
      RowBox[{"lf", "-", "li"}], ",", 
      RowBox[{"mf", "-", "mi"}], ",", 
      RowBox[{"nf", "-", "ni"}]}], "]"}], 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"+", "\[IndentingNewLine]", 
       RowBox[{"-", "\[Mu]"}]}], 
      RowBox[{"(", 
       RowBox[{"m", "+", "n"}], ")"}], 
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"k", "-", "m"}], ",", 
        RowBox[{"l", "-", "n"}]}], "]"}]}], "*)"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5087832565532103`*^9, 3.508783258500182*^9}, {
  3.508783348190814*^9, 3.5087836326748962`*^9}, {3.508783843170176*^9, 
  3.508783850313211*^9}, {3.508785074190639*^9, 3.508785080524797*^9}, {
  3.508837185610881*^9, 3.508837187974235*^9}, {3.5088377114253597`*^9, 
  3.5088377115681562`*^9}, {3.5088378907530746`*^9, 3.508837918838941*^9}, {
  3.50883796354082*^9, 3.508837969300885*^9}, {3.508838011485293*^9, 
  3.508838143990327*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "FHBasis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.508783670539372*^9, 3.508783704346925*^9}, {
   3.5087837778192*^9, 3.5087837828681717`*^9}, {3.508784092387499*^9, 
   3.508784122553347*^9}, 3.508784221180039*^9, {3.508838154137784*^9, 
   3.508838167857397*^9}, {3.508838199737981*^9, 3.5088382000263166`*^9}, {
   3.5088386843965683`*^9, 3.508838684823778*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "U", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0"},
     {"0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "U", "0", "0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0"},
     {"0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "U", "0", "0", 
      RowBox[{"-", "t"}], "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "U", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "U", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "U", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", 
      RowBox[{"2", " ", "U"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.508838200700156*^9, 3.5088386861861067`*^9, 
  3.509970046004353*^9, 3.510030292369396*^9, 3.510325625486863*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sectors", "Subsection",
 CellChangeTimes->{{3.50908051097156*^9, 3.5090805120273943`*^9}}],

Cell[CellGroupData[{

Cell["N = 0", "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN0Basis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", "1", "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5090806558336973`*^9, 3.509970046254805*^9, 
  3.51003029270404*^9, 3.510325625543804*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN0matrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN0Basis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "FHN0Basis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN0matrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.509970046343501*^9, 
  3.510030292808241*^9, 3.5103256255938673`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "N = 1, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "z"], "=", 
    RowBox[{
     RowBox[{"-", "1"}], "/", "2"}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}, {
  3.509080723461989*^9, 3.509080739915999*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN1SdownBasis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", 
     RowBox[{"2", ",", "5"}], "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}, {3.509080752222481*^9, 
  3.5090807863471317`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5090806558336973`*^9, 3.509080787703191*^9, 
  3.509970046459276*^9, 3.510030293543831*^9, 3.5103256256437387`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN1Sdownmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN1SdownBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       StyleBox["FHN1SdownBasis",
        FontWeight->"Plain"]}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN1Sdownmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}, {
  3.5090808101811743`*^9, 3.5090808368693*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "t"}]},
     {
      RowBox[{"-", "t"}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.50908083835019*^9, 
  3.509970046609377*^9, 3.510030293827169*^9, 3.5103256256935463`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Eigensystem", "[", "HFHN1Sdownmatrix", "]"}]], "Input",
 CellChangeTimes->{{3.509080847171867*^9, 3.509080852594387*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "t"}], ",", "t"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.509080853122671*^9, 3.509970046760251*^9, 
  3.51003029389473*^9, 3.5103256257434397`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "N = 1, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "z"], "=", 
    RowBox[{
     RowBox[{"+", "1"}], "/", "2"}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}, {
  3.509080723461989*^9, 3.509080739915999*^9}, {3.50908087568501*^9, 
  3.509080875986874*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN1SupBasis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", 
     RowBox[{"3", ",", "9"}], "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}, {3.509080752222481*^9, 
  3.5090807863471317`*^9}, {3.509080881136285*^9, 3.509080904169484*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5090806558336973`*^9, 3.509080787703191*^9, 
  3.509080905301075*^9, 3.509970046855816*^9, 3.51003029395993*^9, 
  3.510325625793338*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN1Supmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN1SupBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       StyleBox["FHN1SupBasis",
        FontWeight->"Plain"]}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN1Supmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}, {
  3.5090808101811743`*^9, 3.5090808368693*^9}, {3.5090809139129343`*^9, 
  3.50908092707698*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "t"}]},
     {
      RowBox[{"-", "t"}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.50908083835019*^9, 
  3.5090809290251207`*^9, 3.509970046990045*^9, 3.5100302940613613`*^9, 
  3.510325625844454*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Eigensystem", "[", "HFHN1Supmatrix", "]"}]], "Input",
 CellChangeTimes->{{3.509080847171867*^9, 3.509080852594387*^9}, 
   3.5090809341805077`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "t"}], ",", "t"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.509080853122671*^9, 3.509080934856102*^9, 
  3.5099700470439663`*^9, 3.510030294149268*^9, 3.510325625894435*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "N = 2, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "z"], "=", 
    RowBox[{"-", "1"}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}, {
  3.509080723461989*^9, 3.509080739915999*^9}, {3.50908087568501*^9, 
  3.509080875986874*^9}, {3.509080954377675*^9, 3.509080960909334*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN2SdownBasis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", "6", "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}, {3.509080752222481*^9, 
  3.5090807863471317`*^9}, {3.509080881136285*^9, 3.509080904169484*^9}, {
  3.509080965235941*^9, 3.509081008387887*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5090806558336973`*^9, 3.509080787703191*^9, 
  3.509080905301075*^9, 3.5090810101669073`*^9, 3.509970047077467*^9, 
  3.510030294228916*^9, 3.5103256259446163`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN2Sdownmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN2SdownBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       StyleBox["FHN2SdownBasis",
        FontWeight->"Plain"]}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN2Sdownmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}, {
  3.5090808101811743`*^9, 3.5090808368693*^9}, {3.5090809139129343`*^9, 
  3.50908092707698*^9}, {3.509081018447012*^9, 3.509081032983221*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.50908083835019*^9, 
  3.5090809290251207`*^9, 3.509081035395775*^9, 3.509970047135475*^9, 
  3.510030294312437*^9, 3.510325626092774*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "N = 2, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "z"], "=", "0"}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}, {
  3.509080723461989*^9, 3.509080739915999*^9}, {3.50908087568501*^9, 
  3.509080875986874*^9}, {3.509081065308095*^9, 3.5090810741553288`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN2S0Basis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", 
     RowBox[{"4", ",", "7", ",", "10", ",", "13"}], "}"}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}, {3.509080752222481*^9, 
  3.5090807863471317`*^9}, {3.509080881136285*^9, 3.509080904169484*^9}, {
  3.509081077427451*^9, 3.509081140669469*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5090806558336973`*^9, 3.509080787703191*^9, 3.509080905301075*^9, {
   3.509081114764721*^9, 3.509081141232716*^9}, 3.5090811729164743`*^9, 
   3.509970047174118*^9, 3.510030294396461*^9, 3.510325626144672*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN2S0matrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN2S0Basis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       StyleBox["FHN2S0Basis",
        FontWeight->"Plain"]}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN2S0matrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}, {
  3.5090808101811743`*^9, 3.5090808368693*^9}, {3.5090809139129343`*^9, 
  3.50908092707698*^9}, {3.509081148135426*^9, 3.509081161875668*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"U", 
      RowBox[{"-", "t"}], 
      RowBox[{"-", "t"}], "0"},
     {
      RowBox[{"-", "t"}], "0", "0", 
      RowBox[{"-", "t"}]},
     {
      RowBox[{"-", "t"}], "0", "0", 
      RowBox[{"-", "t"}]},
     {"0", 
      RowBox[{"-", "t"}], 
      RowBox[{"-", "t"}], "U"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.50908083835019*^9, 
  3.5090809290251207`*^9, 3.509081173102688*^9, 3.5099700472406263`*^9, 
  3.510030294481472*^9, 3.5103256261953077`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Eigensystem", "[", "HFHN2S0matrix", "]"}]], "Input",
 CellChangeTimes->{{3.509080847171867*^9, 3.509080852594387*^9}, 
   3.5090809341805077`*^9, 3.509081165471714*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "U", ",", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"U", "-", 
        SqrtBox[
         RowBox[{
          RowBox[{"16", " ", 
           SuperscriptBox["t", "2"]}], "+", 
          SuperscriptBox["U", "2"]}]]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"U", "+", 
        SqrtBox[
         RowBox[{
          RowBox[{"16", " ", 
           SuperscriptBox["t", "2"]}], "+", 
          SuperscriptBox["U", "2"]}]]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "U"}], "-", 
          SqrtBox[
           RowBox[{
            RowBox[{"16", " ", 
             SuperscriptBox["t", "2"]}], "+", 
            SuperscriptBox["U", "2"]}]]}], 
         RowBox[{"4", " ", "t"}]]}], ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "U"}], "-", 
          SqrtBox[
           RowBox[{
            RowBox[{"16", " ", 
             SuperscriptBox["t", "2"]}], "+", 
            SuperscriptBox["U", "2"]}]]}], 
         RowBox[{"4", " ", "t"}]]}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "U"}], "+", 
          SqrtBox[
           RowBox[{
            RowBox[{"16", " ", 
             SuperscriptBox["t", "2"]}], "+", 
            SuperscriptBox["U", "2"]}]]}], 
         RowBox[{"4", " ", "t"}]]}], ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "U"}], "+", 
          SqrtBox[
           RowBox[{
            RowBox[{"16", " ", 
             SuperscriptBox["t", "2"]}], "+", 
            SuperscriptBox["U", "2"]}]]}], 
         RowBox[{"4", " ", "t"}]]}], ",", "1"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.509080853122671*^9, 3.509080934856102*^9, 
  3.509081173216898*^9, 3.5099700473346043`*^9, 3.5100302946148157`*^9, 
  3.5103256262953653`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{"%", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "\[Rule]", "1"}], ",", 
     RowBox[{"U", "\[Rule]", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.509081185051283*^9, 3.509081227527027*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.`", ",", "1.`", ",", 
     RowBox[{"-", "1.5615528128088303`"}], ",", "2.5615528128088303`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.`", ",", 
       RowBox[{"-", "1.`"}], ",", "1.`", ",", "0.`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1.`"}], ",", "0.`", ",", "0.`", ",", "1.`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "1.`", ",", "1.2807764064044151`", ",", "1.2807764064044151`", ",", 
       "1.`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.`", ",", 
       RowBox[{"-", "0.7807764064044151`"}], ",", 
       RowBox[{"-", "0.7807764064044151`"}], ",", "1.`"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5090811985980186`*^9, 3.509081228573151*^9}, 
   3.5099700474079323`*^9, 3.510030294838773*^9, 3.510325626346389*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "N = 2, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "z"], "=", 
    RowBox[{"+", "1"}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}, {
  3.509080723461989*^9, 3.509080739915999*^9}, {3.50908087568501*^9, 
  3.509080875986874*^9}, {3.509080954377675*^9, 3.509080960909334*^9}, {
  3.509081309203281*^9, 3.5090813094907713`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN2SupBasis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", "11", "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}, {3.509080752222481*^9, 
  3.5090807863471317`*^9}, {3.509080881136285*^9, 3.509080904169484*^9}, {
  3.509080965235941*^9, 3.509081008387887*^9}, {3.509081315975029*^9, 
  3.509081316039914*^9}, {3.509081346455505*^9, 3.509081346840076*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5090806558336973`*^9, 3.509080787703191*^9, 
  3.509080905301075*^9, 3.5090810101669073`*^9, 3.509081349455768*^9, 
  3.509970047473996*^9, 3.510030294904725*^9, 3.5103256263952312`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN2Supmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN2SupBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       StyleBox["FHN2SupBasis",
        FontWeight->"Plain"]}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN2Supmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}, {
  3.5090808101811743`*^9, 3.5090808368693*^9}, {3.5090809139129343`*^9, 
  3.50908092707698*^9}, {3.509081018447012*^9, 3.509081032983221*^9}, {
  3.509081355866563*^9, 3.5090813687676783`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.50908083835019*^9, 
  3.5090809290251207`*^9, 3.509081035395775*^9, 3.509081374969657*^9, 
  3.509970047541456*^9, 3.510030294971818*^9, 3.51032562644627*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "N = 3, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "z"], "=", 
    RowBox[{
     RowBox[{"-", "1"}], "/", "2"}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}, {
  3.509080723461989*^9, 3.509080739915999*^9}, {3.50908087568501*^9, 
  3.509080875986874*^9}, {3.509081065308095*^9, 3.5090810741553288`*^9}, {
  3.509081433906945*^9, 3.5090814576806498`*^9}, {3.5090814895165443`*^9, 
  3.509081489565625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN3SdownBasis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", 
     RowBox[{"8", ",", "14"}], "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}, {3.509080752222481*^9, 
  3.5090807863471317`*^9}, {3.509080881136285*^9, 3.509080904169484*^9}, {
  3.509081077427451*^9, 3.509081140669469*^9}, {3.509081462627431*^9, 
  3.509081464496978*^9}, {3.5090814948262863`*^9, 3.509081532871961*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5090806558336973`*^9, 3.509080787703191*^9, 3.509080905301075*^9, {
   3.509081114764721*^9, 3.509081141232716*^9}, 3.5090811729164743`*^9, 
   3.509081534964801*^9, 3.509970047607524*^9, 3.510030295053656*^9, 
   3.510325626495886*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN3Sdownmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN3SdownBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       StyleBox["FHN3SdownBasis",
        FontWeight->"Plain"]}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN3Sdownmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}, {
  3.5090808101811743`*^9, 3.5090808368693*^9}, {3.5090809139129343`*^9, 
  3.50908092707698*^9}, {3.509081148135426*^9, 3.509081161875668*^9}, {
  3.509081544645392*^9, 3.509081560035411*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"U", 
      RowBox[{"-", "t"}]},
     {
      RowBox[{"-", "t"}], "U"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.50908083835019*^9, 
  3.5090809290251207`*^9, 3.509081173102688*^9, 3.509081564168229*^9, 
  3.509970047675343*^9, 3.51003029513037*^9, 3.5103256265464*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Eigensystem", "[", "HFHN3Sdownmatrix", "]"}]], "Input",
 CellChangeTimes->{{3.509080847171867*^9, 3.509080852594387*^9}, 
   3.5090809341805077`*^9, 3.509081165471714*^9, 3.5090815670737553`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "t"}], "+", "U"}], ",", 
     RowBox[{"t", "+", "U"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.509080853122671*^9, 3.509080934856102*^9, 
  3.509081173216898*^9, 3.509081567945903*^9, 3.5099700477413607`*^9, 
  3.5100302952192383`*^9, 3.510325626595799*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "N = 3, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "z"], "=", 
    RowBox[{
     RowBox[{"+", "1"}], "/", "2"}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}, {
   3.509080723461989*^9, 3.509080739915999*^9}, {3.50908087568501*^9, 
   3.509080875986874*^9}, {3.509081065308095*^9, 3.5090810741553288`*^9}, {
   3.509081433906945*^9, 3.5090814576806498`*^9}, {3.5090814895165443`*^9, 
   3.509081489565625*^9}, 3.5090815926501493`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN3SupBasis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", 
     RowBox[{"12", ",", "15"}], "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}, {3.509080752222481*^9, 
  3.5090807863471317`*^9}, {3.509080881136285*^9, 3.509080904169484*^9}, {
  3.509081077427451*^9, 3.509081140669469*^9}, {3.509081462627431*^9, 
  3.509081464496978*^9}, {3.5090814948262863`*^9, 3.509081532871961*^9}, {
  3.509081601474731*^9, 3.509081630665339*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5090806558336973`*^9, 3.509080787703191*^9, 3.509080905301075*^9, {
   3.509081114764721*^9, 3.509081141232716*^9}, 3.5090811729164743`*^9, 
   3.509081534964801*^9, 3.509081632937151*^9, 3.509970047808132*^9, 
   3.510030295297756*^9, 3.510325626646489*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN3Supmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN3SupBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       StyleBox["FHN3SupBasis",
        FontWeight->"Plain"]}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN3Supmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}, {
  3.5090808101811743`*^9, 3.5090808368693*^9}, {3.5090809139129343`*^9, 
  3.50908092707698*^9}, {3.509081148135426*^9, 3.509081161875668*^9}, {
  3.509081544645392*^9, 3.509081560035411*^9}, {3.509081641999453*^9, 
  3.509081654472526*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"U", 
      RowBox[{"-", "t"}]},
     {
      RowBox[{"-", "t"}], "U"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.50908083835019*^9, 
  3.5090809290251207`*^9, 3.509081173102688*^9, 3.509081564168229*^9, 
  3.509081660633189*^9, 3.5099700478753853`*^9, 3.510030295365656*^9, 
  3.5103256266968517`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Eigensystem", "[", "HFHN3Supmatrix", "]"}]], "Input",
 CellChangeTimes->{{3.509080847171867*^9, 3.509080852594387*^9}, 
   3.5090809341805077`*^9, 3.509081165471714*^9, 3.5090815670737553`*^9, {
   3.509081664937511*^9, 3.509081674443981*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "t"}], "+", "U"}], ",", 
     RowBox[{"t", "+", "U"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.509080853122671*^9, 3.509080934856102*^9, 
  3.509081173216898*^9, 3.509081567945903*^9, 3.509081675524811*^9, 
  3.509970048046549*^9, 3.510030295458765*^9, 3.5103256267427063`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "N = 4, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["S", "z"], "=", "0"}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.509080572847994*^9, 3.5090805744030046`*^9}, {
   3.509080723461989*^9, 3.509080739915999*^9}, {3.50908087568501*^9, 
   3.509080875986874*^9}, {3.509081065308095*^9, 3.5090810741553288`*^9}, {
   3.509081433906945*^9, 3.5090814576806498`*^9}, {3.5090814895165443`*^9, 
   3.509081489565625*^9}, 3.5090815926501493`*^9, {3.5090816973051367`*^9, 
   3.509081702350813*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FHN4S0Basis", " ", "=", " ", 
  RowBox[{"FHBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", "16", "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509080606595818*^9, 3.5090806092362127`*^9}, {
  3.509080644988741*^9, 3.509080654707156*^9}, {3.509080752222481*^9, 
  3.5090807863471317`*^9}, {3.509080881136285*^9, 3.509080904169484*^9}, {
  3.509081077427451*^9, 3.509081140669469*^9}, {3.509081462627431*^9, 
  3.509081464496978*^9}, {3.5090814948262863`*^9, 3.509081532871961*^9}, {
  3.509081601474731*^9, 3.509081630665339*^9}, {3.509081707635148*^9, 
  3.509081726210595*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5090806558336973`*^9, 3.509080787703191*^9, 3.509080905301075*^9, {
   3.509081114764721*^9, 3.509081141232716*^9}, 3.5090811729164743`*^9, 
   3.509081534964801*^9, 3.509081632937151*^9, 3.509081728714408*^9, 
   3.509970048109439*^9, 3.510030295537692*^9, 3.510325626796653*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HFHN4S0matrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HFH", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "FHN4S0Basis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       StyleBox["FHN4S0Basis",
        FontWeight->"Plain"]}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HFHN4S0matrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509080658962317*^9, 3.509080699734676*^9}, {
  3.5090808101811743`*^9, 3.5090808368693*^9}, {3.5090809139129343`*^9, 
  3.50908092707698*^9}, {3.509081148135426*^9, 3.509081161875668*^9}, {
  3.509081544645392*^9, 3.509081560035411*^9}, {3.509081641999453*^9, 
  3.509081654472526*^9}, {3.509081734734194*^9, 3.509081749114333*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"2", " ", "U"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090807030335493`*^9, 3.50908083835019*^9, 
  3.5090809290251207`*^9, 3.509081173102688*^9, 3.509081564168229*^9, 
  3.509081660633189*^9, 3.5090817507359343`*^9, 3.509970048175845*^9, 
  3.510030295620113*^9, 3.5103256268467484`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["t - J model", "Section",
 CellChangeTimes->{{3.508787678198584*^9, 3.508787682796872*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["H", "tJ"], " ", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "t"}], 
    RowBox[{
     SubscriptBox["\[Sum]", "\[Sigma]"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox["c", 
         RowBox[{"1", ",", "\[Sigma]"}], "\[Dagger]"], 
        SubscriptBox["c", 
         RowBox[{"2", ",", "\[Sigma]"}]]}], "+", 
       RowBox[{
        SubsuperscriptBox["c", 
         RowBox[{"2", ",", "\[Sigma]"}], "\[Dagger]"], 
        SubscriptBox["c", 
         RowBox[{"1", ",", "\[Sigma]"}]]}]}], ")"}]}]}], "+", " ", 
   RowBox[{"J", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubscriptBox["S", "1"], ".", 
       SubscriptBox["S", "2"]}], "-", 
      RowBox[{
       SubscriptBox["n", "1"], 
       RowBox[{
        SubscriptBox["n", "2"], "/", "4"}]}]}], ")"}]}]}]}]], "Text",
 CellChangeTimes->{{3.508787698583405*^9, 3.508787703684375*^9}, {
   3.50878774000204*^9, 3.5087877991075373`*^9}, {3.508787845628374*^9, 
   3.508787924934188*^9}, 3.5098732576715527`*^9, {3.6041459732061234`*^9, 
   3.604145989694685*^9}}],

Cell[CellGroupData[{

Cell["Basis", "Subsection",
 CellChangeTimes->{{3.5090794061916933`*^9, 3.509079406904153*^9}}],

Cell["\<\
For each basis state, the first two elements are either a spinor for the \
particle on site 1 or 0 for no particle and the last two elements likewise \
for the second site.\
\>", "Text",
 CellChangeTimes->{{3.5103255121690903`*^9, 3.510325606566979*^9}, 
   3.5411607660955963`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tJBasis", " ", "=", " ", 
  RowBox[{"Flatten", "[", " ", 
   RowBox[{
    RowBox[{"Table", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"k", ",", "l", ",", "m", ",", "n"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"k", ",", "0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"l", ",", "0", ",", 
        RowBox[{"1", "-", "k"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", "0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0", ",", 
        RowBox[{"1", "-", "m"}]}], "}"}]}], "]"}], ",", " ", "3"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.508783880127376*^9, 3.508783991254715*^9}, {
  3.508784023788666*^9, 3.508784071702196*^9}, {3.508837729976532*^9, 
  3.508837730106048*^9}, {3.508837770902673*^9, 3.508837837983169*^9}, {
  3.508840464198662*^9, 3.508840464461895*^9}, {3.5088405270837297`*^9, 
  3.508840555634008*^9}, {3.5088406193841267`*^9, 3.508840677205818*^9}, {
  3.509078854415884*^9, 3.509078927477874*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5088405566060343`*^9, 3.508840625450501*^9, {3.5088406677031403`*^9, 
   3.50884067823619*^9}, {3.509078923267597*^9, 3.50907892809859*^9}, 
   3.509873004146297*^9, 3.509874184303581*^9, 3.509970051351584*^9, 
   3.5100302957051363`*^9, 3.510325626897502*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hamiltonian", "Subsection",
 CellChangeTimes->{{3.509079420532467*^9, 3.50907942309033*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"HtJ", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"kf_", ",", "lf_", ",", "mf_", ",", "nf_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ki_", ",", "li_", ",", "mi_", ",", "ni_"}], "}"}]}], "]"}], " ",
   ":=", " ", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "t"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"kf", "-", "ki", "-", "1"}], ",", 
        RowBox[{"mf", "-", "mi", "+", "1"}], ",", 
        RowBox[{"lf", "-", "li"}], ",", 
        RowBox[{"nf", "-", "ni"}]}], "]"}], "+", 
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"kf", "-", "ki", "+", "1"}], ",", 
        RowBox[{"mf", "-", "mi", "-", "1"}], ",", 
        RowBox[{"lf", "-", "li"}], ",", 
        RowBox[{"nf", "-", "ni"}]}], "]"}], "+", "\[IndentingNewLine]", 
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"kf", "-", "ki"}], ",", 
        RowBox[{"mf", "-", "mi"}], ",", 
        RowBox[{"lf", "-", "li", "-", "1"}], ",", 
        RowBox[{"nf", "-", "ni", "+", "1"}]}], "]"}], "+", 
      RowBox[{"DiscreteDelta", "[", 
       RowBox[{
        RowBox[{"kf", "-", "ki"}], ",", 
        RowBox[{"mf", "-", "mi"}], ",", 
        RowBox[{"lf", "-", "li", "+", "1"}], ",", 
        RowBox[{"nf", "-", "ni", "-", "1"}]}], "]"}]}], ")"}]}], " ", "+", 
   "\[IndentingNewLine]", 
   RowBox[{
    FractionBox["J", "4"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sum", "[", " ", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"kf", ",", "lf"}], "}"}], ".", 
          RowBox[{"PauliMatrix", "[", "\[Alpha]", "]"}], ".", 
          RowBox[{"{", 
           RowBox[{"ki", ",", "li"}], "}"}]}], "*", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"mf", ",", "nf"}], "}"}], ".", 
          RowBox[{"PauliMatrix", "[", "\[Alpha]", "]"}], ".", 
          RowBox[{"{", 
           RowBox[{"mi", ",", "ni"}], "}"}]}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]", ",", "3"}], "}"}]}], " ", "]"}], " ", "-", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"ki", "+", "li"}], ")"}], 
       RowBox[{"(", 
        RowBox[{"mi", "+", "ni"}], ")"}], 
       RowBox[{"DiscreteDelta", "[", 
        RowBox[{
         RowBox[{"kf", "-", "ki"}], ",", 
         RowBox[{"mf", "-", "mi"}], ",", 
         RowBox[{"lf", "-", "li"}], ",", 
         RowBox[{"nf", "-", "ni"}]}], "]"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5087832565532103`*^9, 3.508783258500182*^9}, {
  3.508783348190814*^9, 3.5087836326748962`*^9}, {3.508783843170176*^9, 
  3.508783850313211*^9}, {3.508785074190639*^9, 3.508785080524797*^9}, {
  3.508837185610881*^9, 3.508837187974235*^9}, {3.5088377114253597`*^9, 
  3.5088377115681562`*^9}, {3.5088378907530746`*^9, 3.508837918838941*^9}, {
  3.50883796354082*^9, 3.508837969300885*^9}, {3.508838011485293*^9, 
  3.508838143990327*^9}, {3.508840697248144*^9, 3.508840697591522*^9}, {
  3.5090785040742826`*^9, 3.509078536676858*^9}, {3.509078571853326*^9, 
  3.509078620164332*^9}, {3.509079045831913*^9, 3.50907904657579*^9}, {
  3.5098740553726187`*^9, 3.509874156469371*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HtJmatrix", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HtJ", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "tJBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "tJBasis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HtJmatrix", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.508783670539372*^9, 3.508783704346925*^9}, {
   3.5087837778192*^9, 3.5087837828681717`*^9}, {3.508784092387499*^9, 
   3.508784122553347*^9}, 3.508784221180039*^9, {3.508838154137784*^9, 
   3.508838167857397*^9}, {3.508838199737981*^9, 3.5088382000263166`*^9}, {
   3.5088386843965683`*^9, 3.508838684823778*^9}, {3.509078643533945*^9, 
   3.509078672053007*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "t"}], "0", "0"},
     {"0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["J", "2"]}], "0", 
      FractionBox["J", "2"], "0"},
     {"0", "0", 
      RowBox[{"-", "t"}], "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["J", "2"], "0", 
      RowBox[{"-", 
       FractionBox["J", "2"]}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.5090786743176003`*^9, 3.5090790110265493`*^9, 3.509873004530007*^9, {
   3.5098741695820513`*^9, 3.509874184454855*^9}, 3.50997005153472*^9, 
   3.510030295936781*^9, 3.510325626973976*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sectors", "Subsection",
 CellChangeTimes->{{3.5090794532933083`*^9, 3.509079454551938*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "=", "0"}], ",", " ", 
  RowBox[{
   SubscriptBox["S", "z"], "=", "0"}]}]], "Subsubsection",
 CellChangeTimes->{{3.509079942612878*^9, 3.509079951079707*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tJN0Basis", " ", "=", " ", 
  RowBox[{"tJBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", "1", "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509079714800024*^9, 3.509079765089875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.50907973069385*^9, 3.50907973607672*^9}, 
   3.5090797663366823`*^9, 3.5098730046858273`*^9, 3.509874184555613*^9, 
   3.509970051684512*^9, 3.510030296073934*^9, 3.5103256271116953`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HtJN0", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HtJ", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "tJN0Basis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "tJN0Basis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HtJN0", " ", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509079510184618*^9, 3.509079524894363*^9}, {
  3.509079591799148*^9, 3.5090795932955713`*^9}, {3.509079748970049*^9, 
  3.509079779450526*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.509079780962462*^9, 3.509873004748386*^9, 
  3.5098741846222553`*^9, 3.509970051718769*^9, 3.510030296158188*^9, 
  3.510325627164168*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "=", "1"}], ",", " ", 
  RowBox[{
   SubscriptBox["S", "z"], "=", 
   RowBox[{
    RowBox[{"-", "1"}], "/", "2"}]}]}]], "Subsubsection",
 CellChangeTimes->{{3.509079942612878*^9, 3.509079968638932*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tJN1SdownBasis", " ", "=", " ", 
  RowBox[{"tJBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", 
     RowBox[{"2", ",", "4"}], "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509079812636983*^9, 3.5090798593901653`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.509079860013033*^9, 3.509873004814958*^9, 
  3.509874184688035*^9, 3.509970051773518*^9, 3.5100302962420883`*^9, 
  3.510325627214677*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HtJN1Sdown", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HtJ", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "tJN1SdownBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "tJN1SdownBasis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HtJN1Sdown", " ", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509079510184618*^9, 3.509079524894363*^9}, {
  3.509079591799148*^9, 3.5090795932955713`*^9}, {3.509079748970049*^9, 
  3.509079779450526*^9}, {3.5090798768892097`*^9, 3.5090799011830387`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "t"}]},
     {
      RowBox[{"-", "t"}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090799021483192`*^9, 3.509873004882298*^9, 
  3.509874184755988*^9, 3.5099700518231773`*^9, 3.510030296325145*^9, 
  3.510325627264242*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Eigensystem", "[", "HtJN1Sdown", "]"}]], "Input",
 CellChangeTimes->{{3.509079906937154*^9, 3.509079918011222*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "t"}], ",", "t"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5090799187559566`*^9, 3.509873004975389*^9, 
  3.509874184822618*^9, 3.50997005187321*^9, 3.510030296409807*^9, 
  3.510325627315303*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "=", "1"}], ",", " ", 
  RowBox[{
   SubscriptBox["S", "z"], "=", 
   RowBox[{
    RowBox[{"+", "1"}], "/", "2"}]}]}]], "Subsubsection",
 CellChangeTimes->{{3.509079942612878*^9, 3.509079987671603*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tJN1SupBasis", " ", "=", " ", 
  RowBox[{"tJBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", 
     RowBox[{"3", ",", "7"}], "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509079812636983*^9, 3.5090798593901653`*^9}, {
  3.509079992698197*^9, 3.5090800180903187`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.509079860013033*^9, 3.5090800190574627`*^9, 
  3.50987300501471*^9, 3.5098741848889513`*^9, 3.5099700519236717`*^9, 
  3.510030296493371*^9, 3.510325627365245*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HtJN1Sup", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HtJ", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "tJN1SupBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "tJN1SupBasis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HtJN1Sup", " ", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509079510184618*^9, 3.509079524894363*^9}, {
  3.509079591799148*^9, 3.5090795932955713`*^9}, {3.509079748970049*^9, 
  3.509079779450526*^9}, {3.5090798768892097`*^9, 3.5090799011830387`*^9}, {
  3.509080024877133*^9, 3.5090800412428102`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "t"}]},
     {
      RowBox[{"-", "t"}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090799021483192`*^9, 3.509080044133542*^9, 
  3.509873005082075*^9, 3.509874184956231*^9, 3.509970051973385*^9, 
  3.510030296581338*^9, 3.5103256274147053`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Eigensystem", "[", "HtJN1Sup", "]"}]], "Input",
 CellChangeTimes->{{3.509079906937154*^9, 3.509079918011222*^9}, {
  3.509080048319892*^9, 3.5090800497919607`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "t"}], ",", "t"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5090799187559566`*^9, 3.5090800512318707`*^9, 
  3.509873005149672*^9, 3.509874185023218*^9, 3.509970052023752*^9, 
  3.5100302966608562`*^9, 3.5103256274652576`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "=", "2"}], ",", " ", 
  RowBox[{
   SubscriptBox["S", "z"], "=", "0"}]}]], "Subsubsection",
 CellChangeTimes->{{3.509079942612878*^9, 3.509079987671603*^9}, {
  3.5090800757135487`*^9, 3.5090800810425262`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tJN2S0Basis", " ", "=", " ", 
  RowBox[{"tJBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", 
     RowBox[{"6", ",", "8"}], "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509079812636983*^9, 3.5090798593901653`*^9}, {
  3.509079992698197*^9, 3.5090800180903187`*^9}, {3.5090800890822287`*^9, 
  3.5090800928165913`*^9}, {3.5090801228255587`*^9, 3.509080123174704*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.509079860013033*^9, 3.5090800190574627`*^9, 
  3.509080124699259*^9, 3.509080186784032*^9, 3.5098730053534737`*^9, 
  3.509874185090362*^9, 3.509970052073296*^9, 3.510030296745442*^9, 
  3.5103256275148582`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HtJN2S0", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HtJ", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "tJN2S0Basis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "tJN2S0Basis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HtJN2S0", " ", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509079510184618*^9, 3.509079524894363*^9}, {
  3.509079591799148*^9, 3.5090795932955713`*^9}, {3.509079748970049*^9, 
  3.509079779450526*^9}, {3.5090798768892097`*^9, 3.5090799011830387`*^9}, {
  3.509080024877133*^9, 3.5090800412428102`*^9}, {3.509080145433753*^9, 
  3.509080159129292*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       FractionBox["J", "2"]}], 
      FractionBox["J", "2"]},
     {
      FractionBox["J", "2"], 
      RowBox[{"-", 
       FractionBox["J", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090799021483192`*^9, 3.509080044133542*^9, 
  3.5090801869273252`*^9, 3.509873005417053*^9, 3.5098741851562157`*^9, 
  3.5099700521239557`*^9, 3.510030296965186*^9, 3.510325627565387*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Eigensystem", "[", "HtJN2S0", "]"}]], "Input",
 CellChangeTimes->{{3.509079906937154*^9, 3.509079918011222*^9}, {
   3.509080048319892*^9, 3.5090800497919607`*^9}, 3.509080170049466*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "J"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5090799187559566`*^9, 3.5090800512318707`*^9, 
  3.509080186986652*^9, 3.509873005483986*^9, 3.5098741852237053`*^9, 
  3.509970052174533*^9, 3.510030297030752*^9, 3.510325627615778*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "=", "2"}], ",", " ", 
  RowBox[{
   SubscriptBox["S", "z"], "=", 
   RowBox[{"-", "1"}]}]}]], "Subsubsection",
 CellChangeTimes->{{3.509079942612878*^9, 3.509079987671603*^9}, {
   3.5090800757135487`*^9, 3.5090800810425262`*^9}, {3.509080217102944*^9, 
   3.509080217190887*^9}, 3.509080301415887*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tJN2SdownBasis", " ", "=", " ", 
  RowBox[{"tJBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", "5", "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509079812636983*^9, 3.5090798593901653`*^9}, {
  3.509079992698197*^9, 3.5090800180903187`*^9}, {3.5090800890822287`*^9, 
  3.5090800928165913`*^9}, {3.5090801228255587`*^9, 3.509080123174704*^9}, {
  3.509080225633051*^9, 3.509080225720783*^9}, {3.5090803065633593`*^9, 
  3.509080318618063*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.509079860013033*^9, 3.5090800190574627`*^9, 
  3.509080124699259*^9, 3.509080186784032*^9, 3.509080319431724*^9, 
  3.509873005550837*^9, 3.5098741852903147`*^9, 3.5099700522238407`*^9, 
  3.510030297105237*^9, 3.51032562766639*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HtJN2Sdown", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HtJ", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "tJN2SdownBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "tJN2SdownBasis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HtJN2Sdown", " ", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509079510184618*^9, 3.509079524894363*^9}, {
  3.509079591799148*^9, 3.5090795932955713`*^9}, {3.509079748970049*^9, 
  3.509079779450526*^9}, {3.5090798768892097`*^9, 3.5090799011830387`*^9}, {
  3.509080024877133*^9, 3.5090800412428102`*^9}, {3.509080145433753*^9, 
  3.509080159129292*^9}, {3.509080328717297*^9, 3.509080339783039*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090799021483192`*^9, 3.509080044133542*^9, 
  3.5090801869273252`*^9, 3.5090803417903633`*^9, 3.509873005617288*^9, 
  3.509874185462298*^9, 3.509970052286819*^9, 3.5100302971769*^9, 
  3.51032562771595*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "=", "2"}], ",", " ", 
  RowBox[{
   SubscriptBox["S", "z"], "=", 
   RowBox[{"+", "1"}]}]}]], "Subsubsection",
 CellChangeTimes->{{3.509079942612878*^9, 3.509079987671603*^9}, {
   3.5090800757135487`*^9, 3.5090800810425262`*^9}, {3.509080217102944*^9, 
   3.509080217190887*^9}, 3.509080301415887*^9, 3.509080364434093*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tJN2SupBasis", " ", "=", " ", 
  RowBox[{"tJBasis", "[", 
   RowBox[{"[", 
    RowBox[{"{", "9", "}"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.509079812636983*^9, 3.5090798593901653`*^9}, {
  3.509079992698197*^9, 3.5090800180903187`*^9}, {3.5090800890822287`*^9, 
  3.5090800928165913`*^9}, {3.5090801228255587`*^9, 3.509080123174704*^9}, {
  3.509080225633051*^9, 3.509080225720783*^9}, {3.5090803065633593`*^9, 
  3.509080318618063*^9}, {3.5090803691319313`*^9, 3.509080374180279*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.509079860013033*^9, 3.5090800190574627`*^9, 
  3.509080124699259*^9, 3.509080186784032*^9, 3.509080319431724*^9, 
  3.5090803943765373`*^9, 3.5098730056841087`*^9, 3.509874185524622*^9, 
  3.509970052318865*^9, 3.5100302972652063`*^9, 3.510325627763411*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"HtJN2Sup", " ", "=", " ", 
   RowBox[{"Table", "[", " ", 
    RowBox[{
     RowBox[{"HtJ", "[", 
      RowBox[{"f", ",", "i"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"f", ",", "tJN2SupBasis"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "tJN2SupBasis"}], "}"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"HtJN2Sup", " ", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.509079510184618*^9, 3.509079524894363*^9}, {
  3.509079591799148*^9, 3.5090795932955713`*^9}, {3.509079748970049*^9, 
  3.509079779450526*^9}, {3.5090798768892097`*^9, 3.5090799011830387`*^9}, {
  3.509080024877133*^9, 3.5090800412428102`*^9}, {3.509080145433753*^9, 
  3.509080159129292*^9}, {3.509080328717297*^9, 3.509080339783039*^9}, {
  3.509080379877461*^9, 3.509080390317148*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5090799021483192`*^9, 3.509080044133542*^9, 
  3.5090801869273252`*^9, 3.5090803417903633`*^9, 3.509080394526349*^9, 
  3.509873005750936*^9, 3.509874185590584*^9, 3.509970052375643*^9, 
  3.510030297352895*^9, 3.5103256278157883`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{2552, 1396},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
CellContext->Notebook,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 159, 2, 67, "Section"],
Cell[729, 26, 366, 12, 38, "Text"],
Cell[1098, 40, 207, 4, 26, "Text"],
Cell[1308, 46, 1104, 32, 43, "Input"],
Cell[CellGroupData[{
Cell[2437, 82, 1281, 37, 78, "Input"],
Cell[3721, 121, 996, 29, 113, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4754, 155, 97, 1, 34, "Subsection"],
Cell[4854, 158, 581, 15, 31, "Text"],
Cell[CellGroupData[{
Cell[5460, 177, 3613, 91, 193, "Input"],
Cell[CellGroupData[{
Cell[9098, 272, 463, 10, 20, "Print"],
Cell[9564, 284, 547, 15, 20, "Print"],
Cell[10114, 301, 975, 26, 31, "Print"],
Cell[11092, 329, 237, 4, 20, "Print"],
Cell[11332, 335, 486, 11, 38, "Print"],
Cell[11821, 348, 443, 9, 20, "Print"],
Cell[12267, 359, 763, 22, 20, "Print"],
Cell[13033, 383, 1237, 34, 56, "Print"],
Cell[14273, 419, 237, 4, 20, "Print"],
Cell[14513, 425, 585, 15, 39, "Print"],
Cell[15101, 442, 514, 12, 38, "Print"],
Cell[15618, 456, 443, 9, 20, "Print"],
Cell[16064, 467, 547, 15, 20, "Print"],
Cell[16614, 484, 973, 26, 31, "Print"],
Cell[17590, 512, 235, 4, 20, "Print"],
Cell[17828, 518, 486, 11, 38, "Print"]
}, Open  ]]
}, Open  ]],
Cell[18341, 533, 917, 22, 45, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19307, 561, 108, 1, 67, "Section"],
Cell[19418, 564, 485, 12, 28, "Text"],
Cell[CellGroupData[{
Cell[19928, 580, 508, 15, 27, "Input"],
Cell[20439, 597, 842, 28, 27, "Output"]
}, Open  ]],
Cell[21296, 628, 417, 13, 33, "Input"],
Cell[21716, 643, 417, 13, 33, "Input"],
Cell[22136, 658, 300, 8, 27, "Input"],
Cell[22439, 668, 348, 10, 27, "Input"],
Cell[22790, 680, 276, 7, 27, "Input"],
Cell[23069, 689, 927, 28, 27, "Input"],
Cell[23999, 719, 409, 11, 27, "Input"],
Cell[CellGroupData[{
Cell[24433, 734, 133, 2, 27, "Input"],
Cell[24569, 738, 1180, 28, 157, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25786, 771, 97, 1, 34, "Subsection"],
Cell[25886, 774, 712, 19, 31, "Text"],
Cell[CellGroupData[{
Cell[26623, 797, 1873, 49, 178, "Input"],
Cell[CellGroupData[{
Cell[28521, 850, 374, 8, 20, "Print"],
Cell[28898, 860, 374, 11, 20, "Print"],
Cell[29275, 873, 860, 23, 20, "Print"],
Cell[30138, 898, 410, 11, 20, "Print"],
Cell[30551, 911, 372, 8, 20, "Print"],
Cell[30926, 921, 464, 14, 20, "Print"],
Cell[31393, 937, 906, 24, 38, "Print"],
Cell[32302, 963, 633, 19, 20, "Print"],
Cell[32938, 984, 354, 7, 20, "Print"],
Cell[33295, 993, 535, 16, 20, "Print"],
Cell[33833, 1011, 1066, 28, 54, "Print"],
Cell[34902, 1041, 856, 25, 20, "Print"],
Cell[35761, 1068, 352, 7, 20, "Print"],
Cell[36116, 1077, 418, 12, 20, "Print"],
Cell[36537, 1091, 906, 24, 38, "Print"],
Cell[37446, 1117, 633, 19, 20, "Print"],
Cell[38082, 1138, 354, 7, 20, "Print"],
Cell[38439, 1147, 328, 9, 20, "Print"],
Cell[38770, 1158, 858, 23, 20, "Print"],
Cell[39631, 1183, 410, 11, 20, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[40114, 1202, 103, 1, 67, "Section"],
Cell[40220, 1205, 719, 24, 44, "Text"],
Cell[CellGroupData[{
Cell[40964, 1233, 93, 1, 34, "Subsection"],
Cell[41060, 1236, 522, 10, 42, "Text"],
Cell[41585, 1248, 335, 9, 27, "Input"],
Cell[CellGroupData[{
Cell[41945, 1261, 554, 15, 27, "Input"],
Cell[42502, 1278, 1171, 36, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43722, 1320, 103, 1, 34, "Subsection"],
Cell[43828, 1323, 115, 1, 26, "Text"],
Cell[43946, 1326, 656, 21, 71, "Input"],
Cell[CellGroupData[{
Cell[44627, 1351, 1857, 54, 78, "Input"],
Cell[46487, 1407, 3354, 96, 303, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[49890, 1509, 95, 1, 34, "Subsection"],
Cell[49988, 1512, 197, 4, 26, "Text"],
Cell[50188, 1518, 3280, 82, 208, "Input"],
Cell[CellGroupData[{
Cell[53493, 1604, 336, 8, 27, "Input"],
Cell[CellGroupData[{
Cell[53854, 1616, 468, 9, 20, "Print"],
Cell[54325, 1627, 520, 11, 20, "Print"],
Cell[54848, 1640, 1035, 25, 20, "Print"],
Cell[55886, 1667, 485, 9, 20, "Print"],
Cell[56374, 1678, 532, 10, 20, "Print"],
Cell[56909, 1690, 469, 9, 20, "Print"],
Cell[57381, 1701, 532, 10, 20, "Print"],
Cell[57916, 1713, 469, 9, 20, "Print"],
Cell[58388, 1724, 532, 10, 20, "Print"],
Cell[58923, 1736, 468, 9, 20, "Print"],
Cell[59394, 1747, 608, 14, 20, "Print"],
Cell[60005, 1763, 1148, 28, 38, "Print"],
Cell[61156, 1793, 485, 9, 20, "Print"],
Cell[61644, 1804, 702, 15, 20, "Print"],
Cell[62349, 1821, 663, 14, 20, "Print"],
Cell[63015, 1837, 469, 9, 20, "Print"],
Cell[63487, 1848, 700, 15, 20, "Print"],
Cell[64190, 1865, 662, 14, 20, "Print"],
Cell[64855, 1881, 469, 9, 20, "Print"],
Cell[65327, 1892, 700, 15, 20, "Print"],
Cell[66030, 1909, 663, 14, 20, "Print"],
Cell[66696, 1925, 468, 9, 20, "Print"],
Cell[67167, 1936, 677, 16, 20, "Print"],
Cell[67847, 1954, 1587, 42, 68, "Print"],
Cell[69437, 1998, 485, 9, 20, "Print"],
Cell[69925, 2009, 752, 16, 20, "Print"],
Cell[70680, 2027, 751, 15, 20, "Print"],
Cell[71434, 2044, 792, 16, 26, "Print"],
Cell[72229, 2062, 471, 9, 20, "Print"],
Cell[72703, 2073, 763, 15, 20, "Print"],
Cell[73469, 2090, 755, 16, 20, "Print"],
Cell[74227, 2108, 773, 15, 26, "Print"],
Cell[75003, 2125, 469, 9, 20, "Print"],
Cell[75475, 2136, 743, 15, 20, "Print"],
Cell[76221, 2153, 770, 15, 26, "Print"],
Cell[76994, 2170, 754, 16, 20, "Print"],
Cell[77751, 2188, 467, 9, 20, "Print"],
Cell[78221, 2199, 750, 18, 20, "Print"],
Cell[78974, 2219, 1908, 52, 90, "Print"],
Cell[80885, 2273, 485, 9, 20, "Print"],
Cell[81373, 2284, 797, 16, 20, "Print"],
Cell[82173, 2302, 836, 16, 20, "Print"],
Cell[83012, 2320, 817, 16, 20, "Print"],
Cell[83832, 2338, 847, 18, 20, "Print"],
Cell[84682, 2358, 471, 9, 20, "Print"],
Cell[85156, 2369, 810, 15, 20, "Print"],
Cell[85969, 2386, 825, 17, 20, "Print"],
Cell[86797, 2405, 800, 16, 20, "Print"],
Cell[87600, 2423, 826, 17, 20, "Print"],
Cell[88429, 2442, 469, 9, 20, "Print"],
Cell[88901, 2453, 819, 16, 20, "Print"],
Cell[89723, 2471, 825, 17, 20, "Print"],
Cell[90551, 2490, 811, 15, 20, "Print"],
Cell[91365, 2507, 782, 15, 20, "Print"],
Cell[92150, 2524, 470, 9, 20, "Print"],
Cell[92623, 2535, 819, 20, 20, "Print"],
Cell[93445, 2557, 2244, 61, 100, "Print"],
Cell[95692, 2620, 485, 9, 20, "Print"],
Cell[96180, 2631, 861, 18, 20, "Print"],
Cell[97044, 2651, 889, 19, 26, "Print"],
Cell[97936, 2672, 894, 18, 20, "Print"],
Cell[98833, 2692, 904, 18, 26, "Print"],
Cell[99740, 2712, 881, 17, 20, "Print"],
Cell[100624, 2731, 469, 9, 20, "Print"],
Cell[101096, 2742, 881, 18, 20, "Print"],
Cell[101980, 2762, 868, 18, 26, "Print"],
Cell[102851, 2782, 912, 18, 20, "Print"],
Cell[103766, 2802, 904, 18, 26, "Print"],
Cell[104673, 2822, 867, 18, 20, "Print"],
Cell[105543, 2842, 471, 9, 20, "Print"],
Cell[106017, 2853, 875, 17, 20, "Print"],
Cell[106895, 2872, 903, 18, 26, "Print"],
Cell[107801, 2892, 852, 16, 20, "Print"],
Cell[108656, 2910, 902, 18, 26, "Print"],
Cell[109561, 2930, 843, 17, 20, "Print"]
}, Open  ]]
}, Open  ]],
Cell[110431, 2951, 981, 15, 56, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[111461, 2972, 155, 2, 67, "Section"],
Cell[111619, 2976, 1075, 31, 36, "Text"],
Cell[CellGroupData[{
Cell[112719, 3011, 97, 1, 34, "Subsection"],
Cell[112819, 3014, 309, 7, 41, "Text"],
Cell[CellGroupData[{
Cell[113153, 3025, 792, 19, 27, "Input"],
Cell[113948, 3046, 1550, 38, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[115547, 3090, 101, 1, 34, "Subsection"],
Cell[115651, 3093, 2535, 66, 73, "Input"],
Cell[CellGroupData[{
Cell[118211, 3163, 757, 17, 43, "Input"],
Cell[118971, 3182, 2506, 57, 269, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[121526, 3245, 96, 1, 34, "Subsection"],
Cell[CellGroupData[{
Cell[121647, 3250, 98, 1, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[121770, 3255, 267, 6, 27, "Input"],
Cell[122040, 3263, 229, 5, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122306, 3273, 493, 13, 43, "Input"],
Cell[122802, 3288, 678, 18, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[123529, 3312, 308, 10, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[123862, 3326, 349, 8, 27, "Input"],
Cell[124214, 3336, 348, 8, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[124599, 3349, 609, 16, 43, "Input"],
Cell[125211, 3367, 765, 21, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[126013, 3393, 145, 2, 27, "Input"],
Cell[126161, 3397, 433, 14, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[126643, 3417, 356, 11, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[127024, 3432, 393, 8, 27, "Input"],
Cell[127420, 3442, 370, 9, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127827, 3456, 651, 17, 43, "Input"],
Cell[128481, 3475, 792, 22, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129310, 3502, 171, 3, 27, "Input"],
Cell[129484, 3507, 456, 14, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[129989, 3527, 376, 10, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[130390, 3541, 418, 8, 27, "Input"],
Cell[130811, 3551, 303, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[131151, 3562, 705, 17, 43, "Input"],
Cell[131859, 3581, 746, 19, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[132654, 3606, 358, 9, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[133037, 3619, 467, 10, 27, "Input"],
Cell[133507, 3631, 604, 14, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134148, 3650, 693, 17, 43, "Input"],
Cell[134844, 3669, 1022, 30, 77, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[135903, 3704, 192, 3, 27, "Input"],
Cell[136098, 3709, 2382, 78, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[138517, 3792, 257, 7, 27, "Input"],
Cell[138777, 3801, 915, 25, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[139741, 3832, 427, 11, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[140193, 3847, 512, 9, 27, "Input"],
Cell[140708, 3858, 325, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[141070, 3869, 748, 18, 43, "Input"],
Cell[141821, 3889, 767, 19, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[142637, 3914, 506, 13, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[143168, 3931, 542, 10, 27, "Input"],
Cell[143713, 3943, 472, 11, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144222, 3959, 754, 18, 43, "Input"],
Cell[144979, 3979, 831, 22, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[145847, 4006, 219, 3, 27, "Input"],
Cell[146069, 4011, 558, 17, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[146676, 4034, 534, 13, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[147235, 4051, 590, 11, 27, "Input"],
Cell[147828, 4064, 494, 11, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[148359, 4080, 795, 19, 43, "Input"],
Cell[149157, 4101, 863, 23, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[150057, 4129, 267, 4, 27, "Input"],
Cell[150327, 4135, 578, 17, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[150954, 4158, 540, 12, 26, "Subsubsection"],
Cell[CellGroupData[{
Cell[151519, 4174, 611, 11, 27, "Input"],
Cell[152133, 4187, 422, 8, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[152592, 4200, 837, 19, 43, "Input"],
Cell[153432, 4221, 846, 21, 27, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[154351, 4250, 96, 1, 67, "Section"],
Cell[154450, 4253, 1099, 33, 36, "Text"],
Cell[CellGroupData[{
Cell[155574, 4290, 95, 1, 34, "Subsection"],
Cell[155672, 4293, 292, 6, 26, "Text"],
Cell[CellGroupData[{
Cell[155989, 4303, 1037, 24, 27, "Input"],
Cell[157029, 4329, 1049, 25, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[158127, 4360, 98, 1, 34, "Subsection"],
Cell[158228, 4363, 3226, 80, 91, "Input"],
Cell[CellGroupData[{
Cell[161479, 4447, 807, 18, 43, "Input"],
Cell[162289, 4467, 1467, 38, 175, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[163805, 4511, 97, 1, 34, "Subsection"],
Cell[CellGroupData[{
Cell[163927, 4516, 197, 5, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[164149, 4525, 216, 5, 27, "Input"],
Cell[164368, 4532, 327, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[164732, 4543, 586, 15, 43, "Input"],
Cell[165321, 4560, 723, 19, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[166093, 4585, 241, 7, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[166359, 4596, 249, 6, 27, "Input"],
Cell[166611, 4604, 371, 9, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[167019, 4618, 656, 15, 43, "Input"],
Cell[167678, 4635, 791, 22, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[168506, 4662, 139, 2, 27, "Input"],
Cell[168648, 4666, 480, 15, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[169177, 4687, 241, 7, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[169443, 4698, 298, 7, 27, "Input"],
Cell[169744, 4707, 396, 9, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[170177, 4721, 699, 16, 43, "Input"],
Cell[170879, 4739, 813, 22, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[171729, 4766, 188, 3, 27, "Input"],
Cell[171920, 4771, 509, 15, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[172478, 4792, 250, 6, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[172753, 4802, 398, 8, 27, "Input"],
Cell[173154, 4812, 444, 10, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173635, 4827, 744, 17, 43, "Input"],
Cell[174382, 4846, 941, 26, 63, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[175360, 4877, 210, 3, 27, "Input"],
Cell[175573, 4882, 529, 15, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[176151, 4903, 342, 8, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[176518, 4915, 475, 9, 27, "Input"],
Cell[176996, 4926, 371, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[177404, 4938, 802, 17, 43, "Input"],
Cell[178209, 4957, 793, 20, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[179051, 4983, 364, 8, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[179440, 4995, 521, 9, 27, "Input"],
Cell[179964, 5006, 396, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[180397, 5018, 843, 18, 43, "Input"],
Cell[181243, 5038, 820, 20, 27, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
