(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    277757,       4707]
NotebookOptionsPosition[    277182,       4683]
NotebookOutlinePosition[    277535,       4699]
CellTagsIndexPosition[    277492,       4696]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.603693394888689*^9, 3.6036934082878933`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tightBinding3D", "=", 
  RowBox[{"Plot3D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Cos", "[", "kx", "]"}], " ", "+", " ", 
       RowBox[{"Cos", "[", "ky", "]"}]}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"kx", ",", 
      RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ky", ",", 
      RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
    RowBox[{"Ticks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "\[Pi]"}], ",", 
         RowBox[{
          RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", "0", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\[Pi]"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "\[Pi]"}], ",", 
         RowBox[{
          RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", "0", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\[Pi]"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(k\), \(x\)]\)\>\"", ",", 
       "\"\<\!\(\*SubscriptBox[\(k\), \(y\)]\)\>\"", ",", 
       "\"\<\[Epsilon](k)\>\""}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.603692837892145*^9, 3.60369285026022*^9}, {
   3.60369289370977*^9, 3.6036929373472*^9}, {3.603693044502232*^9, 
   3.603693051752363*^9}, {3.6036930940048637`*^9, 3.60369309706608*^9}, {
   3.6036931326646547`*^9, 3.603693194773513*^9}, {3.603693268790053*^9, 
   3.603693272352414*^9}, {3.6036937656772537`*^9, 3.6036937955583467`*^9}, 
   3.604372717555108*^9}],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx1nXecl8Xxx0/ggEMpdiIW1GjsMcQedFdFothR0GgsGDFYoom9FzDBBvjL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   "], {{
     {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxFnHf8V+P7x9/vsw9RsrK3IqJtpaGSlR0VIWW27JmMQlIps6yKUGaIkNE0
CllFJBrILCHJ+L2eve7v4/fH+dzX5zr3fc59zvs+1/W61r1T977H9YkqlUrN
vFKJ1a5LK5WXqpXKOWrbZ5VKffH+VPuheLV17KX/P1a7hY4mojdLKpU91fbU
4GPU7yDRka51hcZvpj6P6/ymOvYQv4f6tMvcf43aQ3TUE13o/IuaREMd0zWm
mfi1xV+udn8dm4v+Tu1+OjYT/a3aJrrWJPV/Q/0P1P9bi/+j2q10rUaie+n8
e5rDTJ3vo/YAzon/g9rmOjYV/Y3aOurfUPT56v+mrreh+ic6XtUzPCf+m+pz
lvpMEr1AfV4X/3nRb4k/TXQrXfu9slKZI/oV8d8T/23RL4t+V/RfRaUyRfQc
0c1y35f7fyd+b9G3iH5d1zhJ91yn+2ygtqpjO527WPwaou8XfyMdO4nXVXOY
J15NHbvr//fVbqxjN9GXqX8t0Q+r78Y6dhbvFPWvKXoX0aeKPkj320b0T2pb
6NhW9M+8Z52bpuefo/Ffa249xb9O/KWizxJ9vejFonuIvlb0JerbTseJ6t9f
z3W2+DeI30/06aKvFn2BzvfTcbz6nKW2p47DRJ+ntoWOI0R/qjkfpfZXzXGB
2q35PTW+i8YfwdrQ9U7S8ZLOP6v3vFBzOEb83jrfV/xjRfcR/bn4p4m+SvRF
4h8vuh9zEH2c6L6iP1OfbqKvZP7if8q60zWXiH8S71v8bppXUx2x5tEq8ztc
pbZ15nf4q9o2OnYVvVptrqNU33t1rX/1LKnoe0TnaleqzxY6mul6hf5fLfpv
3esltXM1rmXm3zRR/090fksdTfX/V+rTSe1FOn+15nmy6EtELxD/VNFXiJ6n
e7VR/+809jr16cLvL37bzN/aH4xVnzrq86z6DFCfzuJfKv4KXaeP6FtFvyT+
/ur3rt7DJNGNRM8V/ZPmfKHGnq9jtHgX8c2rHa8xd2js9ur7oP6/Svxd1XbS
PUaL/7rW0Umi7xX9huin1X+86D3U/xfd92LRd4q3UvQlou8WPUTnLhU9SvRg
3fdQHefpujuyXkV3E32j+vRVn2HqM1P36y5epvZanW+l43T9P07/D1BbX+1u
GttW/HP0/8+610UaezvfvXjXiPeA/q8tuj/fl+haoq8QfafowzX/UWpf1TUe
Ym58X2q31nWHif+c+OP0/yU8u9ptxR8u/vPif537N1+hez2S+5r11HbUNR8U
f6b61NG5XuJvkvq3Zw10Ef9+/X8Z377a48S/XfyXxD9W9EjRU0QfIfoW0U+L
Pkr0raIniT5S9BDRz4jeOPKcmdMx4o9Q+6L4G0WeM8+wvfj7s+bFfyDzNbfQ
PB/KfK9tRS/QMU/0EvEaqN9YjX8e+aT18a74i3lGvm8dL4jfSH2eiKw/Oqnd
R8dy9WuSW54j12ONfY81LjoV/b7or0VHol8X/SFrMrOM3VfjNtc1rkOm8Qz6
/0m103R+sugnWGOiz9CzTEQW6v6r9e4mqX9Pte8jH9R+wHxFT6WP+t+tax6t
42n121NjRop+UvR89ZmGflOfsTqGit5KvDGZ33Md1nzm97yl6D4ac5qOAfr/
CF2jr+gzdFyg41zWrPgPZ/4dt2OdIB/F30xzGpf5d2mvuXfVMRZdo7ms1Vqd
LfpTnU807zdEfyR6ocbPED1f9Keip4v+RPT3utYE7qv2HfHfFv9z8U/RNceh
p3TNdbrmm6I/E/8f0W+JXog8U5/WyEz1+Vb8XqJvFr+rrnOI6DNEf1RYX6A3
Gou/o+hWag/MrU/Rq41E7yD6YNGfFNYp6Jb24jcQfSgyMrNuuUDzbJFbX6O3
o8w6v5f4zTWPVyPr7INzyzHkWUvRd2uu5+t9zC+MScAmHxfGEmCKeYXlM3J6
o6DTz9P1mub+vpC1zXPL81ZB7/PsV6rPlqJbIVf51tTnGf3/tO61OLXsqard
VeduiCx3PiiMScAm24h3q3izgr5H7x+h/rV1jf1EXxhb94MB3swt95H//+oa
B+XGP+CgI0Q3E71S7eE6xmv8k5rDceAQ0c+I3k5tB3Sxrrmt6EPR0aKPV592
on9Xe7SOg9FTag/TMU79ntDYo0RPFP2U6I6iW6jPsawBdJCe4XEwkvh1mY/a
/XTcqP7nqv+F6nOi+Jfn1knopitFX6sxO+rZpyXWnejQZYVxAHjgm8K4Afyw
XPTC1FjgT/X/XO1OOk7Qud0TX/M2PcsA9dlB/NfEq5dY940Uf2lqGZ+orZv4
XiPE3zkxHhgseifRR7OGRV+pZ+qgo3PV6xyccIv4nyJfdRyFDNT/l0XGXqx7
1v/1uXUMuuZHzfnD1Jjl58SY5nTxvyyMM8Abi0Sfkvl9dtLYE3VMAS+yVlNj
nFXIWvFvVnue+IeK3kf9f1L7YWEsAaYAl4BP+uTW8ej6Xrn1NPr6+8J4Edw4
MDc+A6ddlRuTgc2uEL2NngtQD67aUvQZkbHCpurzk9pbNa8e4h2goy16NrVO
f5l3yJpAHqaWO8ifTHMeyvxF3y/e74XlIXIRnY3uXi3ebbllIzJymOjBokeD
i9ET6CbRw3PrGnTON6n180apMQHYYHBuTAA2WKVr/ll4buCOUTpXS32HaD5j
Rd8j/k46P4Yxoh8Bm4jO1eeW0rp7G9GzRf9RWJ4j10eKn4o/WPwnRO+F7BT9
ODJH9NuinxT9lPrvoXHvF7Y7sD9OFb+t6O6iz+RbFX0Ov0NuvHou8rnwOuyV
8fJso5yn656mPm9oDTyn658t+k3Rz4teU1hHoCseFX8X9X1L/AmiH+X70Pku
yABkfmx9gT0yH3ylPg3Vf476nyj+BOSQ+ONz441dNfaxPLz/zHgAXTNbfR4W
f3uNfVNjd9Nvfq/mOVfn7hT/Nn5r3mtuPAAu6Jl4PSyPrSPRlaekto+gvxF/
d/Hr61rPil9P/98aWT89qfYb9VnKdyu6IzJH/B6J9f4y9d1KvJuxvfgtNf4m
0QekxgT0+Vhz+UD0a6I/FP2O6BdFzwJbauww9R9SNc4D793EetTzvyzeF8hU
XetG0c3VPsYaEd1S7USNbaBjiv5vzDuNPCZOrO86x8Yr4JZPcuMe8M9HovcG
t0XGHCtTY4oeyKrEcn6Rzv+YGl90V7uF+g4U/YLOnZZYL3yhPnflxgPgAnQz
Ovq/wjgAPDCb70jjvhW9CbI4sb1+mdoTw/zBWn+kxmhnpcZt4LeiNCYAG1RK
4wDwwFu5sRcYLBf/eo3ZRWNnI0d1jOHd6ib7pcZdH4JvdZ/2Ov5Rv8vBGeKf
pHkeIt7fvE8dddTvzCBbzte5lWpTtcsT2yB36HxP/f8vMgkZC4YHM+lcD/3/
C3Je7cGxz/H/cI2tgYwV7y39/3fFGGI2+kRtHWQH9jO/e2KfArq1O5giMZ7p
L3pH0R3pg72vsX9VjGNO0P3e1f8/6p38rLaFjnPE3zex/roPXI3tWfW66is6
0dy2UltTx7FVy64+ov8QvaHaQsehVcvqLUV3QNYhY/TeDtbYaXqvlyLj4Ku9
UEcq/tZqByBfdN/TRe+XWB4+zFrCPq5avy4N+vF2MJ54B1Uti8/VmFXYR2qr
Og6oWkccJXqN6Bpqcx3tq9Z3dybGbBdqPqfo/k10RDp3l/rMVfuD+hyT2+eT
gMHVv7H69+ZbSewH6iN6C9EtWZuiD9AxO/I73UL0qcGmBsvhX/lLz7d5Yqxy
mc5PSOxbOjs2Vtm0aj8S+nSbqv0AnXPr7pPBm4l1+I2x/QPbVq1/t06MhQaI
PzAxTjs/Na7Dvk7VTkpsZ/dVn9v0jDPEXyr+ScEHtUrnuqhtpOM30a+pXaP2
d3SAxjTX/7M0pmvwFfCu8sTY6QydH5EYM/fTfa8RraZypPi348fhexG9Qvf7
p2Lfy4HBL9JP/38l/o8V+7te5d1X7DO6vfA9l2MTaXznMDdwGn6F39X/FeRW
5Oc5We2+4VmuTay/ztVErk/Wq6TKUbrGMF1zmvou4b3p/5bBJ9NL/Fh0HbX9
sa+QdRo7BhyJf0D99y9s3x2gdqz4x+AHE/8TbBbRrcC3he33B9W2KWynj+G7
Luz/aan2IfXvpv6fsQ5Fn6z5vSX+XaI7i35b9AOiD1af19RnlOgmyDjRo0U3
E/2C6HtLy6kpou8XfZDoqeDiwn6AcehY8U/QNWeLHin6eNGzRB9RGCseqfaw
wv6Hh2gL+7g6FP52DkNHFv7G+4seDeYpLStnFra/7tT726ew7fyQ6GaFv/GB
6n+f2uY69hI9WO3ZpXXME6I3iC1XLw/f7+WiR6ntWthvdkphWXqF6HvUdixs
wx7NvXSdd/S8x4g+rrA9fjw+j8I2y8WM03GT6PvVdi/slztT7VmFMfDZal9M
7Hu7VHM5K7Ot8Zr4y3imqtfBuXqu3ZCN2IDIYo39Uv/XT4xd746NbXZFB6k9
IzfOPx1eYrw/DD9qYhx1DTavzu1ZNdZtlBiHPyD+ybr3YuS7+M0T48OHUHrI
xKqx7j6JMfC94s/XXPaLrG+6FJ7XGuab2H4Zrj7n6f8jK57bnokx9l3iz0qM
5QaJniH6MNEDRTdOjLcfFL0gsV9xaOxv9nddv6GOJonx+Rjxl+j/vau2E35T
26BqW2KR+reOLH8/TuyTvFX9W2Afgo3E/zDYKUPA7Jr/CvH+0zxbi/5O9L9g
1cR2xz3q8xf/V20vLIz8/aJ7Ti18vX/Enyfe+5HHN0uMi8ZpbIPE9sJobCD1
a4LuUHtCbh9sjtxVn/bID/WZLPoA0ZeIbo0e0jU31FFX9M3BXwc+x1+4o9pC
vLNE34AsE/1tZH05UuvqQq5TGIfjL9lG7cZav4N4LrX3qs9lomtqXW+o/wey
rsBu4p8v+hzsD425EjhDW3guO6qNkLlgDLU7a27XBN/g7dhL4rfQc9yT2zez
GWsg83c9G5mFHy2yDs519EQ/VuyjAZu9AK5Rv09FH632C419R/RP4En1P0HH
i6xXtY/ye+rcK7kx7cv8VvgX/ud3QiZVjc/GiZ4s+hH0o/osi4yNbg9+qc/U
Zw90VcDMmdoeVT9Pu8RYfbLOd0+MnZeI3h5ZAL7C3hK9N99GYTz+BGtQ/RZk
9lv0F39YwOQTq8b04PlvY8sNsF5ttRcH7IfPf9/UPrl30O2J8ezCYI9cX7Xv
7rncWPfZ3HIaf90HseX346Lnie6WGMN/Htv/fEPVdiKyGdtnTmyb6MqqfciH
Jbb7popfP/Pv9Zaud19ufydriXfTL7yfB3L7dHfAnsvtS9xH7c6p+a/oOg/q
/7sqXrcNxH9I9Nux9c/Toj+OrTceEz1X9H+i+6OT1fe2zHp7I63VEbl9gRur
/Q8ZVPUa3SG23MYXUUWWq70a+ZIZY26osa0T28tP8j2iD9RvB7UVtV3BbxWv
i97IPdETc/uu91K7O88v3jSNrZfanz09ti7Fhv1I9J6pfd4zYs+rV5jbvbn9
wVvntn/xje+ttk5qe/nZ2PrqYfE/qFhXT+ebjo0FiHl9hR9Gfe6q+nvA/4Uf
bLH4bXWs0rldI2MEfLBfx17bT6n/PTr+QJbq2F3HDYX7NlQ7OvL38gz3zm2f
zlN7bOG+jdT2SmyL/axr3qT/64rfmLUq/hfirxH/EtGLRP8Z207BB4V86Z3Y
pvuFNakxD1Zt001Vu6Jin3U7bLyK8WoN9d8XHYgMzB1z+038NrljcWAwbBHi
Qdgj9TJjxal67k00trl4F8S24YgTYccdmTuuWsXWT+zbPEt9xmjccTqerdoe
zdTWYr2qTxu1V6vPhon9SOewhhP7kbqJ7pA7JviP7j828TxPE79WYh9jP36X
3Hh7bWY/IfHEf0U/lPhZTlefdrFlGbJjRx13VG1DEvfEzn4jt+37nOjP0ZGs
gTBn7H3iAGoqSzOvnTV6D2frWMz11X6e+x2siy0DsVu/Qt7G5v+T2vcyQHOq
TUwKPFI1pt8LX4bGzFGfUcwtrJMvM/swbgS/xf4Nr0Cfx8bRV/EbYm9EtveJ
Ib+OvmPdxsbJ/ZE9YMAgz8cH2U6M41Kd+5L3pr7X6h7bil+/MN58VvxP0RGJ
fRRLY+NW4sifiT4nsS3/vejhGndUkLdt9P/Pka81I7c/ebraC9V/AWtM52fq
/8kVv/MGYNmq7fem4O+q/RJ9EtvyK9W/n+hPRP+KDlSf7XTtvdSem9j2/wEs
lNjP8KPoC0TPF71a9N7qN6Jqn0Mtvc+logfpOTYWvVz0TaK/rRozYKMSN35H
9MY8W+7Y9S/q+y9ytGrbkpg2tiTnjo9tu98K3oltf9+SOHZwBzYbvqzYNtSw
xDGI27BhSsfosSm317nmar+vGscQm16oPkeWjl9/gX0oekhq+/2rxLHsL7H/
xa+b2b6bEvzNC6vGdvtjc1WNKUfFfr4F6tMUDBQ5VlFL4/8Tb6HazZEZVX+H
P+e2hfnuVuf2OWAv/5Lb3uT72gRZVrWtCHZbXTW+XJUbeyMHuma2i7Fzt0f/
V40X/8iNUcFmx8SWMRm+as1lS8ZmtlWJn2hqlU30pxDvC7Ubifde1f6sZsFG
ZMxWaudXLRd+y43J04AHV4TfF18IfmN01dDUvodl+CPxO6I3M2MHMMRHFctp
5DDfYX3RX1dtGwxMjV3f19gbU2PkjxLbFqyxMyr2lWOD4hvpVvjd36j5f6Dr
9dLRtOpcAXzb01Pj6nMDv0Fm+pPUWJg8A67VItCNRd+c+j41M1+vdxjLuPMD
fVDA5Kx18greZU6l8wfmYCeIHpb6fdTWdT6J7EvH7nhAffYXfaDaTyP73vHF
kO/xvcYeo7G3aGx3MEPmuNsK/G2lbaBfq7Z/hqe2KT7QuQsy202XBtsLmwi/
G3H8H/iGNHYPZGfV9szOar+o2td2ZmZ/CPbXeZl9Jthud8a+xvup8wreRkbq
Om8He66rzs3LjCfRuXsWlmNgp2t1frPI/mXinGAV8PTE2Hi5QFboWsux69X+
oLE/oZ+Q4aJXopNEn4p+iIzXH4uNqf5NnHsAnr+JNan+f+FbwWfOuo5sJyyO
HOPAdzYW/4LotmofiY2V/kaGx8ZZ/2Bjx7YjNkgds8W/AVb7FZ8YOg//f2x7
pVSfCbHx4zZ6B3fp/2tFL0kd58WO4X/yD4gHLkt9/100pmPVtjuxpf/l9NAu
Sq0TiZGjFx8tfA3yrogt4f/5OPXa2Q6cUnXewmpsxdIxSGKRX6t9RPzzNPY8
tTV07ktsktL+9qEaP7xq3YKOGVp1vPIGXWfT0rY+c2sHBhW9EzZP1X4a8i0O
B2sGmvvxnfGesdmwuddWbUN+Jt7Zke3NJ1LjgiNTY0DiieDAwaK3jowXDwk4
kNjSxNR6p0PqeHR7tWdqbk+lHrez3vn0zNgVu+lqsFJk3F+3sB0B7n05s42A
fTEIeRYZj+LjrxMZa9Yr7LsG0+5SGAOTy/F2ZpsFPbtbYVuGPI3LNbZmZJtq
RWz7aEXq+AL6eWbF+hl9yrnxsXH0lplzWn7Hx1Ha5/pX1T4L8l5+w3dQ2hfG
u25RBB+T6MML+8Xwjx2CrkvtM5gPhg3yDb/BV/wOke2xEal9wkvUZ6T+3yGy
XifW35Z1qXvdhp6MjDnIK2iD7BN/58I2Arkr44J/rD32eGr/8bf4WjS2RmSb
5M+wBppVHcNlDp+ljgVAt67a34jv9Be+4UBjvkxOja066j09H9knSZ/nUtu+
p2KXaHy9yDj++dRYcTd+/8g+xiUV+xvBv03FXxc53lFFxwWbemHFeR3Qo5Hb
kd8naxvf4wU6P0Jjs9i6gf/JYzle9+tROl+lQbjXlMjY4FfRYzR+j8h2Arkr
J6p/z9K5KyeBLUrrjYOD7ngjyHZk/HuRdQ96J46tI/huF0T+zvnG8YXS/xqc
srH9yTUrzgmkz2vYdpFtgfuq9qlib2J3klOHHwofFPYZcTfe3aTUOLCz2hdT
/w5Hx36mxpH9xujDlmFu84P+2l10Enxb3OOl1JjuZPBn5LgAL/2ixHj/D/F/
i+yH5J3jk+4Srv9xZN8pa4NcwfaBnhlk5YzUurd1eG9fRuYjP5smljdjY/tj
8Ynep+fdKLb8RW7iU4LGf7Q0sv+W94kvF/v4JvVfEvn76iT+rNS/+ebiXxfZ
58O9yFHEJiRu9WaQ88j79d9lZL9WEexGbEZ8wsSpBmX2LcPDX8V65xvA305O
FPbCY8iAyP5YaHyz+ISWZfbfgp0WZc5T5d29m9qPCx9shfzuGGT4PZHtHdYA
77hzWJ/c96TwrQ2JLPfp3zexj2eV5l4z9nXAZnxPncI6Z72fGL6jfcP8fwl8
+iwXvVnsZ/m6Ynm/Vew1U42NI8GQxB2giUPgdyX217lw7kF30fWqzjc4M6wx
1lqPQOPfBo/1D3EQ1jS68MzQhxgivs2zw1plHeGHYk2wvi4J64r8HHzsR1ft
Z4fGx0ge4CB+D/F/UHtjWA/kHkCDUXqG+zYM1+ea+LjwwzAWPyG+aJ6FWCd4
7ozwXG0CjV9yW93rojAf3tM5Yc7428GK+HvIzegbWZbi44UmxvdRwKXgU9Ya
6xI/Rb9Asz7x54NJ8GWSl8I7+YA1o/a08D7JXz01fKfIEuJ5UaC7BT6xTvqs
zNzCJzZ3YmE8OKj09U4P1yTHlOd8NfX1mobr7B47psD7xAeLH3hzza1fYay0
uLT/lRxNfLDETPkfzNMq8JHP5FmBRcAx4A7wBzhkhdoB4Tul7zWh/zeR+0OD
X/oHumHi3+H+2HPfL8z/lWAfYSchA7uEb4fnIIaHvG0S3hXPRfyLOeDH+ym2
HfNrah8eeUX48YiboPfxQ4PXLg3yB7kxOLyTlWpvCd8j7ZBAk6tHTsTbqW1z
MFv/8P4GB5nDeXy1fMNPBBpcx/mbw/WvKoxNHi6NPa8P74q4ERgUPzlYDxq8
1yHMn3nSXhFo4knQ4En846wx8C+5Vvxu+Mb5Ha4L1x9f2D7gG0eHEDtEtoIR
WN+sbfzh+E+Qe8iP8UGGrAn6HT2PXHwk9FnfN7K/5YRA/28sffC97KNrPxz4
5HeSczE3dc0C/py/Usu5EeE9X1cYT+KnJwcDH9EPqf2O+B/xq+8ZfJH4Idem
9j/9rvbeyHoXeTuw8O8/vnR+BXOlDz57/FaMaRB8WPjwye9dHhkT4q/Fb3ty
1T59aPQTfv7lgc+6/iasYdbR0vC7EDNBz6HjyDPA7uhdOA7AMxILmKV2Rli3
YIQxYc745PDN3V/1e4JGZ5Ov8kDg4y+Fxlf2W2oM9UvquP/0yD6cu8I18end
XPi3w5+3VWb76c7UfjDmNCD4bHnP4AFqCrjOfxX7h6YFmhj6G6L/qDgnFD44
47/g08C3QT4ovhb8M3cU5i/LnW/PWPwexMKJiY8sHJ/H94Hf4/HI2HEJmK+w
X+Qr8otZR9H/601qTtB3kwPN/Tg/JfQhH5VrEvefGnk8fHIF8J8MLzz2pXCd
OHPud+/U7+2e8FuQD0TMZ05Yg7wjfJXHBpp3tSr1emR9wgfLMuanYBNhG9XX
fO4M/fn9bwvrfN/wO/HbHR3G0qdZ7HkzZ/Qzepp5vxxo9DXfDflP+EIbBJr3
xm9+V5j/mih8D1WfnxD6kFNFnhQ5AOTxsL6JobMeZ4Y1SR4MNiJ2zdzI8Uhi
ke8HulHQn/hKkN3IoQVh/W8WYivoOPKH8K/gV6FGBz8gPkDyTKDJKdkjsU8D
3wb4Ab2I/CdOjV+DmHTdqmnkF7pvVpgnecmsxZdT65PPw/dIPhD+xrt13w0y
+y8vCroXXMKztQx044BtwNPMlbwc8nNmopcy5x2dr+stqtqPw1yZC3NibuQL
kjfYO3ftCLkZrCfqW4gLEx+m7oV81y8Kx47f1fh9q86V+kj0wVXnTpEzRd7C
fmE+vAfix7z70wrbK/jUwN70Jc8KXNsq0FwHLAOObx2eCz8X9gt5pNwL3xdx
QexRbFjwznvhPeA3Zm742ch7/z6yL4XYDn4AMC55TsRaLyjsF4B/t8Y2Ub9f
I/sViQ1Bj6raz44NfnVhXQc+QB8dEeQk8hH89nWYM9gEGwBdSc4TNjQ+IrD/
l2EstjU+RM6hv/ArYXuQF706si/iwnBNnnOLEJvG/iVGxfOQg8F3+Vv47oh5
rQ7Pgr2BbsQnuXdifyp+ZeLz+Bi7V+xnnBN+R/IV8L91KmwbLQq/Ed/K3PC9
NM5M4z8kxs+1yKWhXgffGX6zs5Pgu4gtJ1YGWUGsAV8G8RvyJaHxaYApfgjv
ijg4v9eZVcf6ueb6uH5hv9zlarfL7PMbpefat3D87/rC8oB4FbY6+Z74vPjE
kEu1Yss05Bt2OzIQe2Xj2HEQdD32xotBl9WOrXf4fbH9qK8AM2waGw+g67Ft
Hg/fILY93+PemfUA9hSxK2JY2F3E5KHHV52nujaynwG5ty7IQGLkjCF/ZkT4
7bAdiYWtDWPBINh14BBwbI3YOInfK4+9lsDw2I3kRJIzQe7EY4nz84kZPF84
D58ayecK59zg/ydHn7w04gXUAFALQE3fM+rzTOT8VN4xuXfk4I1JbBeuCfKZ
OgJiDJMK5+QRj6AGYIPSNvf80jhww9g4lu+F3CPWNvZUGdv2oY4HX+VSjT8y
cy7ls4XjtH+E7/HpMJ9lFddijNR9ti0dlyU+O6iwXflPZLsY3ASG472Rn0q8
78/UuAn8xP/UneIf/ZvvK/Pa+SvoRPInFgad1TC2DgLXrM/BrRrLQIN3xoZr
gseoN8CW+iL4rrDTkA/YXuBVfJzkSWFDYj8ODDS+XXJ2ycH4ObUtiD1Jznrb
QGNXkr8O77tgU2IX8R2B2fHJgtuxL/6LbIuhi7GfqQlEPkdx0G2R/S+/B3mL
zwj7d729FdtGA7fgXwOrlKX9Qx+Xtuv/jmyz43NKY8c+0K3Y4diqjxWWDdho
Q8PcsDPAJGALZBdYGEzMM48MNNj44cL6Fpuxe7gmNuGEwvID7Md64XtnzVCn
c5fe+3al64CoY32qcN4QMgV5goxB1qThG+Ub4/siFoqcGhLkEzRyH5mKbEXm
/hSugzxaG8by3VIHdJ3uW6d0bcUg0VuVrgEmLpYG3YW+RO+BwcHiYBdi5LtV
XPdyZJgbMnBVuC/ynBoo4vfU7VH3xNonf48++LjRa7+Gb4Rv4PzE9iN2JHUA
xJvxh1IryvdMjJvaKDATsbosfFdc99bCcXDi5NQPMP6F1GsfjMv6J3ZOH2Lm
1E6BWcGr4Fmw6Xpfa2TfKzQyE78S8pZv95lwL3JBn41ct0htNfTPFcfGJwX6
toB3v8+MeZ8L1yShFJqYKPm75BVQr/VamA/vHX8VeBQs2iNzXtlU/BCZc4Zf
Ft0zc03Tq4XzAolFUvtEfRNxyhcL10NR0/pC4XzuQyqu1yInj/gttUjk1REv
pYaoW+barlfUv0PmWjDqw6jBISb6NNfMnNcxWfTxmWvHqA8jx6IN2Ft0p8z5
G1PU57TMtWPUFZGrBzabmjh3kPgs9T/kDpJD+ALxn8y1YC8V1vPgNnQ9thE2
0v9sIGjsI+wbbCRsG36HJmHtvBvGou8nFvZp8FtMCn34jZqHsdhWH4Z1DpYD
Z4KDwRbUeZGnQo48dUn0fbJwzge5H9QpLQvfBfbpW2HsrgGnEB/tXnF+N/gb
7P1moMHKvUrnpvC9k+tPHJKagtMDjuW9kZ9EDIL6HPKWyF/aKnV+EjEa6lKo
u9ix4vr3F3TNTxLXXh2eucZ/Hbkr4ffiN52sPvMS12RRH0QMY7rox8WPEte8
T8pc2/sm/Mx5fdTEjA+xH/J4qYuhDndG4doiap+nFa4TX8Ta0fUmEpNLvOcA
OWTkklGbRO325+K3L51vSt7pZ4nrr4mjX6P2ycy1mbuLnpC5Vnpn0Y9lrqHe
SfTEzO9kF9FPZK7ZYZ5PZc5PqwtO1D2+TZ0nuUjHV6nz0CYAfhLvdUC9MXFa
aqKfy1wnu2fumnHWxbW5c86I81Df/VTs+qwtU9c/8652Ez2FvIrEdXzPZ87f
q587D4+4HDXgL6nPN4nr/siV5N3uIP5j4v8be9+GR0T/HXtvhx1K703wt+gO
8fopV67Un51K7yuBoNy+9F4G/NZ/xc696Zq6botab3LFdy6970Ms3o6l95v4
T/1/j50/c7j6Hx47D/9qnZuaOZdvTmGfBliBfGzkLbhnqNoTYtebDCX+ip4R
PSRxDQzxxL2CXwKZeye/eWn/xeOFcxyJUVJLRq0cN64fatBi0XuVzn3kHdbV
/1sQT0q8zwD1bjXB1KVzEPmtd0qdZ0mMktqwLXUuS7wXwYQQHyWnnTov6vHJ
aX9Uff6JvccF9WU1NG6f0nV8fNOvY3OVrgPPcte0kwdIXRz1X+RQkve6jfps
kHi/jq1Fl4n3FthD9CGJ66Cpeyf3kro76u/QmW8Uzkkljko9O/stYLtcnDv/
m3wG9l8YmjnuX4Ocsszx+g1z20r4CDYRb3DmmP4GufMHyBcYLt4dmfMNauW2
zZFHG2bON+CaXBufAPKrRua643Xif5c7V5b6skdT5+geSJyN7yh3nRVrgLr1
79T/y9x7d3wvenFunxJ+IvxO1EGvFf9b7LDc9UisB/IWBok/OnOOAbkH92Q+
oGur7w2la3iQCVeVzonvRt5X6doY7IJ1QdeDhy8qXWOD7dC/dJ56d/ztpfML
wfx9S+f5YS+Qq8o6b6yx15XOX+f9Y7uBw7bHb5Q552GT3P4rfENJ5joH7GRs
n2tK58f3IPejdP76hbltTLDaDsEfiL9y68yYBzth18y15OQwdcldO0mu1Sm5
63PaVVwP+ZquuTZxDemrfCeJaz9fFv156vzYV3T8mLgGdqroXxLX574uev/E
eeDkVqKjn9f/M6gZSbw2ZopumfgZp1Mbkni9nZhZvyM32DMEncxznRD0Oxjg
I2IhqWvoPtTRJXWtHDmgYIYn1Gea/j8w8bp9g9h/4rU6T3RHhE7p/D/yZ6jV
JP+SfCv25SB3k9wx9smhJg0f0VuJ9zmZq7Zt6XrSd0QfUjoXH+w0PXE9KfXX
rBnqoMjtoaaU+qv1mCpxbRW5ZOyf8r7GH5a6rpB6VWr9+E3ZI4UcLPxLR2S2
K5HJ1DLVrXg/mVka2yrxuj06sz2LfO6YeR8J5C31sOQesSY7Z8Y/yBZq8LAf
H9H4S0rXaIHfyJUkZ3Kf1L567A18CMgb6vvI/Ts0cR4+OTnIHur1yBtENiGj
yDWifo38QuwN6gXIE0Le3Zd4Px1kAnUovLOrsX8T1yaQC4QOXxtkO3ssYH9Q
i8QeC8TUyYUfndhWI48XzAR2Il8RhQXWpt6Q+kTquchTpO4M/x22x6jEe8Hw
TVEXRk4kdjK1YGA98h3BJuuCrtk0tZ+DnHZsdnxR1Ey0Kl0nD2ZuJ/q9xD7A
2qn3oeC7a1m6Hh6si22IP5WaiTaJc77JiWJPiU4acxrfTem9MxrqWQ8ovWcB
Nj65W/h2qJOgLoMcL3QSe/tQz7IOLFN6PwIw7cGla+/B8AeW3k8BLH1Q6X0K
wMybp94XA5nTunQNPzifHFlyZY9LXXsCXr6s9H5K5BKRS85eTOQSUc/F/jnt
iEOqz+zMdQrUH5OjT64+cpy9PrDVqFNDT1JDR04vezdR80sdGfsyHaK+XUvX
HlCD0Fr/v545d513sr72oOI9caZkXqsNcu9DQo4RdWfk1pOnxB461PpRu0e+
MrUQ5BexPxR77KBrqE2jFo88ZmxUavHA7ORmkQeOf+iC0vuW4F+hno6aKb7x
61LXP/JNX166/pGax2tS121RI9k/dT0mdY5Xpq4DIX+PPVCoecRuuir1Xisn
qO1Wuq4T++bi0nnj+JP6BIyGHU99MbWZ1GNentruxf4lpxpM933AVOCXFRXn
V5NzTj75JanzyfFfXZoaj3wXMF6b0vs7UF8GjqDGgTy9tonrI8gDRH7jjyEH
rkvp+vP3Csty6nDJqepcuob8XfFPKl1TDa47uXQN9tzCeoPaW3IQkWHU6pKn
dWLpmnlsAfQJMWdyE6mxIm8V+Uv9F3mZ5H1Sg0YOHLnF1OSS40U+MfqKWhvy
CDuVrtV/p/D+D/iXyUtdnLhulzxk9A91weRu7ln6mdlbpl7pb5V9eKivmF5x
fTp1OKzzFqlrLchxo4adPYOwZx/gW8pc+8/zzsq8PwDfxeTMddzM54VgR7B/
wKm616Gp9yGZmXlvAd4ttRnkzVF3D96nppgcM3A9OQjkhqHrqB0mnxVdR2yZ
HNYXw325/ozM3yO/C3UgfFNNU9eTM5+9U9fNkQNNfi3yjLo5coOpJSSfFZ3X
qPTeRthH1BlRH/SwxjYuvf8R9lGz0vtPYdc0L73/FLYJNUrUIj2Uui6G2pYx
qeuSwET3lK6jAYPfUbo+CF10t+i9S+se9kGi3odcVXD8fqX31kEOsCcJcfF9
Mtedrc8rTZ2TSWyUeiDqbrBTxqptEHQPewE1LL2XE7Yee02QU0utK/tKYQcP
0/mmpfeBwtajzpF8d2xL6vjW5+Il1tnobvKosX2Rz+QMU6cJjhjAd6Dj5NT7
eFBfiS+QfN8bUseiwMbsbcWeUfemrgfEZr1e/QenzvUHh7PPFXbxffx2pfel
wobtUHp9s/cLdVXUaj2Qev8rbJcRwXYnv4acRmrqybPHlgb34UMlx/eK0vUt
YEX2dyKnkzpf9gfj+6pVOJ8QnzJ+MHLbyOcgl58cD3wf1NyQt4a/lVgeeIea
XGxA6uDw3ZODQL4N8SpybvkOqG0hH3WDwv5X8jOpjyC3En1DLQY1F+SqUluB
T5d8Suo10BsPls4/wZ9LnsyE1HsDgY3RYegy8mPZK49vKiqcv0FeCPEsMCyx
f/KEqVeiFolcQ3JpWGPEyNgrCbujkdqbS9f+YWeBkYnV4d8mZ568dmJ8T6fe
1wMcTl4HMTNylYkpE6/Cp02dFL5z8iDJuyOGQV79oNy2GDYZPgZiafi3wbP4
g6l/JC+CuDB+fnwPxE3JT44L76FAfTF1JdSSkJOKLYRNRE0iNRTENtkv7ebc
dhz23GaFa+eoR76pdF0ctuotue0U7BX6I/+3LYzN8fFTT4RNiG3IHgusd+or
yYFkXw5i2cTJeS5k7xYae0NuuxL7EpwH3iMfFT7ybXP1+Tt3/TP11+wlgi2G
TcYaYi0Rv2Bu6JTtCudGErsiL4VaG3JwwRlDS+8rhz+KvezQR2XhPD1iYOQC
UY9GLiy6uXfpejP8k9sUrvmkjpv6I+p9yD0lXxE/NXWQ5G6Rs0XcEJsN243a
1ltL10ziv6I+iHxW8N/w0nvS4ePapHCcihxg6uzAYuOCrUMNO/4W9qZg/bCO
qC/m2+EbYl8Ccgzwe1xZeq8N7Dv2EcIPTiz3nNL7I+BjvLR0XTG+XOr4iF1R
tz6w9P4g+KM2DvFN4pzUA7JWWbPUQRO3Zm8BaluIxVNv9H/O65ii
         "]], 
        Polygon3DBox[CompressedData["
1:eJw1nAn8F9P3xufz+czMnU8lKaGUVkuyZN/JkpKlTWhTllS0KHuRSGlFkV0k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         "]], Polygon3DBox[CompressedData["
1:eJwl12e0VcUZxvED7MO9l25QowETUQIKKioEUGKkg4j0Ioi0AGIWoSpE6b2D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         "]], Polygon3DBox[CompressedData["
1:eJwl0TkvRFEYxvEThhEUiEoh0fsAtqDRKISpVLYPYBS0tHaFXU1HIrGEimQU
KhIKWhr7voXK72SKf/Lc//vk3PfcW9WXTvXnhBDKkY+yZAjNiRC+8FoQwiK5
hD2+Ji+Es9wQzlEr73MZnTbdIy6DSn6VL0I9f49bnXFnTGCQv+CmdKdxKQ9x
U2aTuNd95J7wIBebNcSMu4JsJ3Y35RJuwBlprMmturt8hTzCDWNLTvEnaLfb
FXeNDvmUO9bvTGTvFO9Wza/zM94xjUfzl/gt4k5yqVmT/IkXz/M6CyjhG7kP
PPOz3BwK+bq4O274UW4MXfxBIrtj3PVQ7uY2dJJyL9eDUbk2mf0H8V+8mX9z
P3iXV7hlfMi/3F/cTT5Ei7zjjG0k3WvOOf8PUkup
         "]]}]}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0r1L1WEYxvFbj56yU1qZ0aQ0SYNRRJtGg1KY9iKZ+TLVIAoVRJD+AWIt
jklQuKSWhUplGQ0NOUSjlmXvQbkfM7M38vPL4eF7Xddz3/fvOTdn+6lzDWdz
ImLC+Z0bkehG/Ip/cG86YiOddrGPLqMP4E48hlXYhnXYuSaiXF0rPbg2Ylsq
oppPYadsSFZGN8sy2KuvW36Gv05fSmqwH8dxCB+nV982ZXafuin6ljk79N/m
i3BG1uetI3whn3VeyO7wC/RL+hvO4iK+wu/4Gk/nR4yqm6Oz9FVzxvlN7t8k
9bIB2V3ZZtmS81Z+j/9Bv6OX8T3+xA/4Cz9iu94JdZ+SO3rYnIf8Fvefkx3x
D/hi/ovfOS0b5mfpp/QzvI+PcBDH8AoO2MV5db30TbsoT/bL15p3TU2X/ALd
KCtw1yPrkO3nL9ItdAcewhasxKNYgTVmZ9SV0jfM3qo/lfwpsAhazc3l/+FJ
WaHsOd9Eb6BP4Ho8jhlswHV4Oc++sMCp8K0S+SK9x5wjtE9FE53Fv3hY5inx
xOx6WkvUoTVGLRoXB1P/nxVdzDxqi90Kdwknc1b/zyvWDlxk
       "]]}, {
      Line3DBox[CompressedData["
1:eJwVzksyQ1EYReFfpQrpEQzAHAhCJoERGIAMxCOeyQRSHslglFI6EiTkIRGk
n47vNFbtvde55967elDaPZyJiD2sz0ZszUcU0JqLOJLTTERTP9ZP8KrfZCN6
ns1jzX7DLde3N5K333HHDexNPLibs9v8V/oOHrkl7oM71YdcR1/gXlDmPu0z
OXJWl23+XF6g5+xSNtDku/aVfo2+fs99u1fAtj1AnRunjWL6FzS4H3sHT+4u
20P+Nz2DZ24lvYur6H/cSF/kWqhyY3tfTpzV5D+inTh9
       "]], 
      Line3DBox[{1598, 1842, 2220, 2407, 1856, 1843, 1028, 1599, 1845, 2326, 
       1777, 1600, 1847, 2327, 1778, 1601, 2256, 2328, 1779, 1602, 2258, 2329,
        1780, 1857, 2409, 1848, 1781, 1858, 2410, 1849, 2221, 2408, 1859, 
       1850, 1032, 1603, 1852, 2330, 1782, 1604, 1854, 2331, 1783, 1605, 2260,
        2332, 1784, 1606, 2262, 2333, 1785, 1860, 2411, 1855, 1786, 1861}], 
      Line3DBox[{1607, 1862, 2222, 2412, 2029, 1863, 2223, 2413, 1608, 1037, 
       1609, 2334, 1787, 1610, 2335, 1788, 1611, 2414, 1864, 1789, 2030, 2476,
        1865, 1790, 2031, 2477, 1866, 2224, 2415, 2032, 1867, 2225, 2416, 
       1612, 2226, 2362, 1613, 2336, 1791, 1614, 2337, 1792, 1615, 2417, 1868,
        1793, 2033, 2478, 1869, 1794, 1616}], 
      Line3DBox[{1617, 1870, 2227, 2418, 2034, 1871, 2228, 2419, 1618, 2229, 
       2363, 1619, 1048, 1620, 2338, 1795, 1621, 2420, 1872, 1796, 2035, 2479,
        1873, 1797, 2036, 2480, 1874, 2230, 2421, 2037, 1875, 2231, 2422, 
       1622, 2232, 2364, 1623, 2233, 2365, 1624, 2339, 1798, 1625, 2423, 1876,
        1799, 2038, 2481, 1877, 1800, 1626}], 
      Line3DBox[{1628, 1878, 1879, 2482, 1627, 1880, 1881, 2424, 1629, 2234, 
       2366, 1630, 2235, 2367, 1631, 1059, 1632, 2425, 1882, 1883, 1633, 2426,
        1884, 1885, 1634, 2427, 1886, 1887, 2483, 1635, 1888, 1889, 2428, 
       1636, 2236, 2368, 1637, 2237, 2369, 1638, 2238, 2370, 1639, 2429, 1890,
        1891, 1640, 2430, 1892, 1893, 1641}], 
      Line3DBox[{1655, 1921, 1920, 2436, 1654, 1919, 1918, 2435, 1653, 1916, 
       2376, 2276, 1652, 2274, 2375, 1914, 1651, 2272, 2374, 1912, 1650, 2434,
        1911, 1910, 1649, 2487, 1909, 1908, 2433, 1648, 1907, 1906, 2432, 
       1647, 1905, 1234, 1646, 1903, 2373, 2268, 1645, 2266, 2372, 1901, 1644,
        2264, 2371, 1899, 1643, 2431, 1897, 1896, 1642, 2484, 1895, 1894, 
       1898}], Line3DBox[CompressedData["
1:eJwVzksuw2EYhfH371LEKmyEGpW6DCp1r0trKGWodStaO7EEorYh0oggTcMW
UNefwZNzzvN+g2+kuJMrJxExh0YqIjMYMYE+bOFmKGIYdbeiXUIvmtyrPOMP
ByJ69GvuRZ5yHTlrJ3Lf/YRr6zNcyApX4571ae7X3tQ3cMyfc2v6On7cxmUa
d/yR+6g+hm+3grzt9w9+RV/FF3/l7ZN+wO/an7jkHv//xD3IKbvLl1Hl7rks
92Fvo8K1uEnu3V7UF7DHN7i8Po83t2W5hAv8AQSBL8o=
       "]], 
      Line3DBox[CompressedData["
1:eJwV0EsuQ2EchvG/RGjpzaXudUmKVVgBo9qBBBPUpQkxbcS1ESEiNqC7QKt7
YGQB0olYgN8ZPHnf9znfl5NzFjaqlb2eiFjHeV/EaipiDSPYxGs6It0fcYMt
exujeOMHuEt36rLIvXOD+jV3Jse4FpfRG9yPXbbHZZa75br6Ijchd5Dj75Dh
PrHLTaKKPP8iv/l9eYApHGKlN+Le8yO9hmm0nStwD95zIWe4D25If+SuZInr
cMP6E/drL9mzyT/gnrk/fZmbk8fJ9ydnkeO+cMLN4xRFvin/AST7JK0=
       "]], 
      Line3DBox[CompressedData["
1:eJwV0LdKg2EUBuDjkPLH7h14HepiAwUxRnfByQJxUnAViRWxIFETO3gTls07
EDddLYgFb8DnHx7ec97zJYR0Ts2Xyg0RMUk9GzGUj7himA6WOOEliWil5s2A
/ZJB2rnX/8kjt81cRJv5Tvcrq7ofOZF+Xq67H+i+zeO6Frmq29d9mUu6ZrlI
nQX23Ar6Jy7s/TQxQo2HTMSuN73mc/popMwxz+l3suNNt/2MHgrc6j/ltlvF
70jMN7oPuaV7l2P2vFxx39C9mYu6nFzWrelezaO6rJxJ/wumqbgl+kdO7V1k
mOOQWa75Bzp1MY8=
       "]], 
      Line3DBox[{1693, 1933, 2239, 2439, 1946, 1934, 2344, 1814, 1694, 1935, 
       2345, 1815, 1695, 1936, 2346, 1816, 1696, 2293, 2347, 1817, 1697, 2294,
        2348, 1818, 1947, 2441, 1938, 1819, 1948, 2442, 1940, 2240, 2440, 
       1949, 1941, 1094, 1698, 1942, 2349, 1820, 1699, 1943, 2350, 1821, 1700,
        2295, 2351, 1822, 1701, 2296, 2352, 1823, 1950, 2443, 1945, 1824, 
       1951}], Line3DBox[{1702, 1952, 2241, 2444, 2081, 1953, 2242, 2445, 
       1703, 2353, 1825, 1704, 2354, 1826, 1705, 2355, 1827, 1706, 2446, 1954,
        1828, 2082, 2502, 1955, 1829, 2083, 2503, 1956, 2243, 2447, 2084, 
       1957, 2244, 2448, 1707, 1104, 1708, 2356, 1830, 1709, 2357, 1831, 1710,
        2449, 1958, 1832, 2085, 2504, 1959, 1833, 1711}], 
      Line3DBox[{1712, 1960, 2245, 2450, 2086, 1961, 2246, 2451, 1713, 2247, 
       2389, 1714, 2358, 1834, 1715, 2359, 1835, 1716, 2452, 1962, 1836, 2087,
        2505, 1963, 1837, 2088, 2506, 1964, 2248, 2453, 2089, 1965, 2249, 
       2454, 1717, 2250, 2390, 1718, 1115, 1719, 2360, 1838, 1720, 2455, 1966,
        1839, 2090, 2507, 1967, 1840, 1721}], 
      Line3DBox[{1723, 1968, 1969, 2508, 1722, 1970, 1971, 2456, 1724, 2251, 
       2391, 1725, 2252, 2392, 1726, 2361, 1841, 1727, 2457, 1972, 1973, 1728,
        2458, 1974, 1975, 1729, 2459, 1976, 1977, 2509, 1730, 1978, 1979, 
       2460, 1731, 2253, 2393, 1732, 2254, 2394, 1733, 1126, 1734, 2461, 1980,
        1981, 1735, 2462, 1982, 1983, 1736}], 
      Line3DBox[{1750, 2010, 2009, 2467, 1749, 2008, 1372, 1748, 2006, 2400, 
       2310, 1747, 2308, 2399, 2004, 1746, 2306, 2398, 2002, 1745, 2466, 2001,
        2000, 1744, 2513, 1999, 1998, 2465, 1743, 1997, 1996, 2464, 1742, 
       1995, 1355, 1741, 1993, 2397, 2302, 1740, 2300, 2396, 1991, 1739, 2298,
        2395, 1989, 1738, 2463, 1987, 1986, 1737, 2510, 1985, 1984, 1988}], 
      Line3DBox[CompressedData["
1:eJwVzksuQ2EYgOHvRKrtMozrWtdVULUCLYYsgJbqxWUdOrARkU4IkbpXMTVu
RISngyff97//OTlnrLRT3E4iosjnqJmJWGOJUwapiA/92H7CIrfZiAzvejcd
saDdOKfpaylzi3n9zv2bNuK8ydzwfa2nJc4bzGpHtHjV21rD3iTPKgW6+ov7
ZfsKM9T58o/Pes1+yDTXng2e9I7vTWlXzn/mo/Zrlp0nzUv3D9qPvaRNmBfa
vfZtX9fGzSqV4X/oZ9qufY8cB+xzzj8MgjCD
       "]]}, {
      Line3DBox[{840, 1146, 1021, 2471, 841, 1147, 1029, 2326, 859, 1037, 874,
        2363, 1047, 889, 2366, 1057, 904, 2371, 1226, 1067, 919, 2378, 1227, 
       1075, 927, 2384, 1258, 1083, 2497, 935, 1277, 1091, 2345, 943, 1099, 
       2353, 958, 2389, 1109, 973, 2391, 1119, 988, 2395, 1347, 1129, 1003, 
       2402, 1348, 1137, 1011}], 
      Line3DBox[{842, 1148, 1022, 2472, 843, 1149, 1030, 2327, 860, 1038, 
       2334, 875, 1048, 890, 2367, 1058, 905, 2372, 1228, 1068, 920, 2379, 
       1229, 1076, 928, 2385, 1259, 1084, 2498, 936, 1278, 1092, 2346, 944, 
       1100, 2354, 959, 1110, 2358, 974, 2392, 1120, 989, 2396, 1349, 1130, 
       1004, 2403, 1350, 1138, 1012}], 
      Line3DBox[{844, 1150, 1151, 2322, 1385, 1152, 1153, 2328, 861, 1039, 
       2335, 876, 1049, 2338, 891, 1059, 906, 2373, 1230, 1231, 1412, 2485, 
       1232, 1233, 1423, 2491, 1260, 1261, 2340, 1427, 1279, 1280, 2347, 945, 
       1101, 2355, 960, 1111, 2359, 975, 1121, 2361, 990, 2397, 1351, 1352, 
       1450, 2511, 1353, 1354, 1013}], 
      Line3DBox[{845, 1154, 1155, 2323, 1387, 1156, 1157, 2329, 862, 1183, 
       2414, 1184, 877, 1197, 2420, 1198, 892, 1211, 2425, 1212, 907, 1234, 
       1235, 1414, 2486, 1237, 1238, 1424, 2492, 1263, 1264, 2341, 1428, 1282,
        1283, 2348, 946, 1304, 2446, 1305, 961, 1318, 2452, 1319, 976, 1332, 
       2457, 1333, 991, 1355, 1356, 1452, 2512, 1358, 1359, 1379}], 
      Line3DBox[CompressedData["
1:eJwVzrEuQ1EcgPH/TXslJiKW1kQXXoCnYOgLSLpp0nbq0kRqISRWAxYkJqIS
YWMwSDqWDo0ENZcmnkB/d/jy/c93zj3nLlYa5XoSEWVs5CLu04gHVBFTEf/8
Ph1R45x1Hsf5iC1tjzd9c85N+9fahbmudbildbRb87b2mDXrtv5kPtT6vKPt
arPunsG++Q19jO2/cg/z9j6cHZq/keALnxjoR1xwpog584GW8p13inyKF22B
n7VlPkNXW8ne0Fb5xPqS1zDU1rNz2hWX3L2EG/Nv9n+o4Acj/GECwq4wCg==

       "]], Line3DBox[CompressedData["
1:eJwVzc8qhFEYgPF3GGTBRnaSWWEIYSE3QW6AZCX5djZKrGjK1gIbid3UiKIo
JvkTOzVm6d8FoFyA31k8Pe/7nHO+rzCfzSznImIWU40R500Rvc0RF7yEBvMo
3lsjcpxpl+gzX/FuPmLR2RbPeX/IK3pZOzJn2gmvahXt1LymXadmX9er5m2t
zhvaptbu+2NoQ8l+g5qzfnvV/OvuKw/Za9zJd1zke87jC8P2N+8+zTt4wID2
yB0oOWvhM//v4v10R+vmW63IB3jSBvlFm+A9+zFP4kObTve0Mhd8fxw9qKS3
qKf39mfzAn4wYv/mP/wDbts0/g==
       "]], 
      Line3DBox[{850, 1163, 1025, 2474, 851, 1164, 1033, 2330, 867, 2362, 
       1042, 882, 2364, 1052, 897, 2368, 1062, 912, 2374, 1243, 1071, 923, 
       2381, 1244, 1079, 931, 2387, 1268, 1087, 2500, 939, 1289, 1095, 2349, 
       951, 1104, 966, 2390, 1114, 981, 2393, 1124, 996, 2398, 1364, 1133, 
       1007, 2405, 1365, 1141, 1016}], 
      Line3DBox[{852, 1165, 1026, 2475, 853, 1166, 1034, 2331, 868, 1043, 
       2336, 883, 2365, 1053, 898, 2369, 1063, 913, 2375, 1245, 1072, 924, 
       2382, 1246, 1080, 932, 2388, 1269, 1088, 2501, 940, 1290, 1096, 2350, 
       952, 1105, 2356, 967, 1115, 982, 2394, 1125, 997, 2399, 1366, 1134, 
       1008, 2406, 1367, 1142, 1017}], 
      Line3DBox[{854, 1167, 1168, 2324, 1392, 1169, 1170, 2332, 869, 1044, 
       2337, 884, 1054, 2339, 899, 2370, 1064, 914, 2376, 1247, 1248, 1419, 
       2488, 1249, 1250, 1425, 2493, 1270, 1271, 2342, 1431, 1291, 1292, 2351,
        953, 1106, 2357, 968, 1116, 2360, 983, 1126, 998, 2400, 1368, 1369, 
       1457, 2514, 1370, 1371, 1018}], 
      Line3DBox[{855, 1171, 1172, 2325, 1394, 1173, 1174, 2333, 870, 1191, 
       2417, 1192, 885, 1205, 2423, 1206, 900, 1219, 2429, 1220, 915, 1251, 
       2435, 1252, 1421, 2489, 1254, 1255, 1426, 2494, 1273, 1274, 2343, 1432,
        1294, 1295, 2352, 954, 1312, 2449, 1313, 969, 1326, 2455, 1327, 984, 
       1340, 2461, 1341, 999, 1372, 1373, 1459, 2515, 1375, 1376, 1383}], 
      Line3DBox[CompressedData["
1:eJwVzr8ug2EYhvFH0CiRNBU2khJmToBzqMVk6MAgIdJELAzCpOkkkSaNxaIG
CZFomUnDEaCxFSfg3+b3Dlfu+72e53vfr1DaKK73RMQilnojWv0Rt9hENhMx
gE42ouw8qA+h3hexxh3LVd805Lb5BXeub3E3coe75Jr6AXcvd533+Af9iOvK
fa7Cjbg7j2r6B+5VdvBr50U+Y8z8zexD/8Qw3tFNc74mx+1MYFQ/5HLyzluT
8gRtbko+crPyFE/cXLqDm097zmdyIb3DLac97krOuHsa1/pP+j+s4Btf+MM/
xjMx3Q==
       "]], Line3DBox[CompressedData["
1:eJwVzi1Ig2EUBtArU0FmWfCnDcFi3NqaFsHqksGgZQviQASxrIxtxSQMxmBY
ZhCxiGWgLooo02Aa2J3N6qZ4DA/PvefC+31Lu6XN/YmIyMtXIqI0GfE4FbEj
n9KZiRjqoVvBLT0dcWHv81U94Nu8Y35mWf3E8uzUfmZfllu2wU5Yyz4vV2yN
1VnKvujtBTnnPZZze+cj3dP38sbb7hl2Z//Qr7rKX3TDbYXNeqdiv+EP9hpP
6zK7Zl3zEZvTB/ZjfmkusqTeY4esbd5iCV1gTf3Lf2Sdj2RsLv7/p3xLxrf/
AMEaMQA=
       "]], 
      Line3DBox[{1010, 1136, 1346, 2401, 1002, 1128, 2463, 1345, 987, 1118, 
       2456, 1331, 972, 1108, 2451, 1317, 957, 1098, 2445, 1303, 942, 2344, 
       1090, 1276, 934, 2496, 1082, 1257, 2383, 926, 1074, 1225, 2377, 918, 
       1066, 2431, 1224, 903, 1056, 2424, 1210, 888, 1046, 2419, 1196, 873, 
       1036, 2413, 1182, 858, 1028, 1145, 839, 2470, 1020, 1143, 1144}], 
      Line3DBox[CompressedData["
1:eJwV0C9IQ1EcBeCf6HvDpmDyTxDWZNGwYLSK24rVwUAQNkHEIsiKaHHJIGKY
TGRJUMaq6KIKIujAJlbLBKt+C4dzz3ffbth8uVasjkRESX5HI7bHIh6TiIr8
yOV4xEB/u9t0l00jru0XXtCfvMyvnJ9YXr+yNXZiX9gL0mMrrMHO7TnpsGV2
yKbsWW/PSJsv8S+WDn8rD/Lmu6a7RXf39kD39QF/16fucmzSG0d2l/ftY57V
dXbL7pz32bTesff4jfMWm9A1tstazussozfYmc54O5VV/icfPLGrvn8e/geS
s/8BpYYucA==
       "]], 
      Line3DBox[{1015, 1140, 1363, 2404, 1006, 1132, 2466, 1362, 995, 1123, 
       2460, 1339, 980, 1113, 2454, 1325, 965, 1103, 2448, 1311, 950, 1094, 
       1288, 938, 2499, 1086, 1267, 2386, 930, 1078, 1242, 2380, 922, 1070, 
       2434, 1241, 911, 1061, 2428, 1218, 896, 1051, 2422, 1204, 881, 1041, 
       2416, 1190, 866, 1032, 1162, 849, 2473, 1024, 1159, 1161}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJyVfWV8VkfzdnB3SpHiWrw4AbJ40FCkuBV3d0pxd2lx9+JeINyDFSheQkiA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    "]],
  Axes->True,
  AxesLabel->{
    FormBox[
    "\"\\!\\(\\*SubscriptBox[\\(k\\), \\(x\\)]\\)\"", TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*SubscriptBox[\\(k\\), \\(y\\)]\\)\"", TraditionalForm], 
    FormBox["\"\[Epsilon](k)\"", TraditionalForm]},
  BoxRatios->{1, 1, 0.4},
  Method->{"RotationControl" -> "Globe"},
  PlotRange->
   NCache[{{-Pi, Pi}, {-Pi, Pi}, {-4., 
     3.999999999999597}}, {{-3.141592653589793, 
    3.141592653589793}, {-3.141592653589793, 3.141592653589793}, {-4., 
    3.999999999999597}}],
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{
      NCache[-Pi, -3.141592653589793], 
      FormBox[
       RowBox[{"-", "\[Pi]"}], TraditionalForm]}, {
      NCache[Rational[-1, 2] Pi, -1.5707963267948966`], 
      FormBox[
       RowBox[{"-", 
         FractionBox["\[Pi]", "2"]}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {
      NCache[Rational[1, 2] Pi, 1.5707963267948966`], 
      FormBox[
       FractionBox["\[Pi]", "2"], TraditionalForm]}, {
      NCache[Pi, 3.141592653589793], 
      FormBox["\[Pi]", TraditionalForm]}}, {{
      NCache[-Pi, -3.141592653589793], 
      FormBox[
       RowBox[{"-", "\[Pi]"}], TraditionalForm]}, {
      NCache[Rational[-1, 2] Pi, -1.5707963267948966`], 
      FormBox[
       RowBox[{"-", 
         FractionBox["\[Pi]", "2"]}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {
      NCache[Rational[1, 2] Pi, 1.5707963267948966`], 
      FormBox[
       FractionBox["\[Pi]", "2"], TraditionalForm]}, {
      NCache[Pi, 3.141592653589793], 
      FormBox["\[Pi]", TraditionalForm]}}}]], "Output",
 CellChangeTimes->{{3.603692920199164*^9, 3.603692937797933*^9}, 
   3.60369305267076*^9, 3.603693097387198*^9, 3.603693134109413*^9, {
   3.603693185830611*^9, 3.6036932042918997`*^9}, 3.6036932796152773`*^9, {
   3.6036933649289017`*^9, 3.6036933790478354`*^9}, {3.603693411692937*^9, 
   3.603693416866695*^9}, 3.603693797047988*^9, {3.6036938280653973`*^9, 
   3.60369383217148*^9}, {3.604372726742483*^9, 3.6043727470831327`*^9}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tightBindingContour", "=", 
  RowBox[{"ContourPlot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Cos", "[", "kx", "]"}], " ", "+", " ", 
       RowBox[{"Cos", "[", "ky", "]"}]}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"kx", ",", 
      RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ky", ",", 
      RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "}"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "\[Pi]"}], ",", 
         RowBox[{
          RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", "0", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\[Pi]"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "\[Pi]"}], ",", 
         RowBox[{
          RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", "0", ",", 
         RowBox[{"\[Pi]", "/", "2"}], ",", "\[Pi]"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(k\), \(x\)]\)\>\"", ",", 
       "\"\<\!\(\*SubscriptBox[\(k\), \(y\)]\)\>\""}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.603692983787211*^9, 3.603693039687956*^9}, {
   3.603693200358313*^9, 3.6036932006040773`*^9}, {3.603693253948852*^9, 
   3.6036932863186903`*^9}, {3.603693809725132*^9, 3.6036938189928617`*^9}, 
   3.604372720535181*^9}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJyNnXmYV8Wx92eAEfAqGq9rXFHjEsU1btFYrZLEaNyXa0xck2jcFRNRExXX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   "], {{
     {RGBColor[0.293416, 0.0574044, 0.529412], EdgeForm[None], 
      GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmFtwlWcVhv+9dxKanX3KBmcKCj05WnW0CA2gJIHiVSChI8SZ9oaSEwQa
EsALD4EcmarTGelF8XRVnNGE1plaOzp2oI6ltnWmpUC9aiv0gkNINYGOpok4
Et+H9WZ68c+/9vrX933r+K717Xva+7b1ppMk+VsqSTJ6V+jHhJ5B0d+qSpKb
1UmyvSJJluSSpFXPYj3bTT8s/l7JbtCzWusf0HNJT5vWnhHvqukG0+1JrL8i
ervo8crYi32WLdK54reK3yjetqrgn00HvyP55OxV7KVnk74dFH+RFH/INLrO
Suev6vt9mZBB9p2aJDlfE98qxF8v/n7J70oHjfzjejfqqRP951KSnNRer+WT
JCf5jeIfkPy+dJyFzFt6X7NdVZnwAzK/zCbJcT3PyYb307G2WXLPar+H9f62
ZOol/2Y6fIHs9erw3ah4VXqGJfOh3pWmB00Pif59VciMiJ7Rmn/Krj78o30+
peeUzvmR/PSUeL8oJslp0Q9K7jHRW9IRY/Y5oH2Kkn9J8r36nhP9Y/Fz5SQp
iH41Hz5ADpnX5JODoscLcQ40Zx0qRLz69b6YDp9v1X73a59viv898XvS4Tv8
1qX3ZefGR9Uhs1X7fFnya7TvaDn2+45z4GU931CuHJX8g/r+jH6v0fpnpM8x
0f+qlf6y7X7l0EG98+WQr9G5Q/b/TsnfLZ/Xi94h+qbW/Ednvygb79K6yVT4
6ILjOyu6Lx18zjonH5+tiThddq6j/xvap1U6/CAfcST225zbf6qMfL5T/p/z
PofTkRPkA37Ehyf0/nUh/HxaNj0pGzr1vUfv885J8qxOe6+1/U3i/d16bvSe
H6diP/xFXKjja3raUhHfCdP4Fd3w7dvidbs+W11f1FmD8xP+uXTUITq853rn
LOqG/KN2Zu0X6N3iv+v6Omwa+T3WmRrB15Ou68pMYAR1hC/BHeq4x2ciM1QI
/qDencWIWbfer+vcR8R/tCLiWu9z56ojvjtdI/A3GwfmzGfdiYpYC87NGete
yUV824uRb+jZKfkXSrFmtBA2vme7HnJut4gek19frgx822AZsHGqIvjkOTY1
2l4wBCwAB/YVo7ZvFKJO+1IRL3Kgx7VDHB9LBT4TuwbvD1bsx1epeJezQeez
UcvU9SHXPmvHcuGDQ3ovLwZWXda5GX1fe0f4at0dQQ9YT3Rc5RzY7XOJZ5Nj
Snwft54t2rc5F9hEfVKnv1GNrMB38sOjet+ojvrHJxOuP2LNudM1cTbxqasM
fGsydlB3P5XOv5POU9qnQ/Ry5UNbMXKwy3jeXQobsZX6vbFwVj7i8XnhxH7j
Bvjx19o4a1Ehao3YE/fb2JCN+iUmzenwLT0OzF6pZ6YQPv6hzuovR53+Ix/+
wC9bUtHX6KP4Al3AErBiWSZk8OGMdH5COvxb76WZqE38TO6MOX+o3XHX71RN
+Jh4kbvYja/w3ZT55OFe63DB+tS5V6PDSttXZ2z5Sjb0Q7c/gGvi/bc29mtx
TMl1cpJ4oSf5QHzAi27HqLMy1rLnpyXT6xohh1+sijxudM6g22guetrPFYsT
pVj/Gfl1JBe+xcf4FT570gOpF7Dy9Xzg3qul0BFdqeth5yf9aK/rhbP2uaZa
jFkz9hvzQJdtwWb0Hy/FzFBvvHvFswEzAlj6tPH0XdcFmDAv/yXZsOeDdNhO
D0hl4xuzwCLPJ2B4lWcM1lKLl9xj6Ml512/RNL2Yh2/gA32feqffL8nGb+j5
2tDhpXx8X+zZAL9nFnCgMuqaHBhzD6IXkV8TrvexbORTxvi9xzpTx9iDLbeq
wy7sZcaZ85yzy1gNZpM3YAJ+ZpZp9hxCj9ri3rTGeUjdgQFgAXGk1+xyXJrc
Y8D5mxWhBzo8Vw4ajOEc8oC1XV57e8ZTzL6mPXtKgS3NloG3zliXz4Q+6DaQ
C97PpP+ZXPiuXvTZQpx9PR95eMu2/zEf+z5fCiyhn2Hvgo/wDXMoeAVWkafT
ztXxbPgaXGPddq+lBsj5FaXoUbPuU/SdC67lncWYoXfoPUDf9owx6Tmmw/6c
Mq7ek4l+sMOxIj/Bt89mYgZlZqZm+8zn3Hc8P3+9GH7AH9TXoOcr8rF3oWfV
hDz42+e+xPy2w3oeM+7SqzqNqRszIbdk4Z4h+Sfy4QvmLPCWuQSMIWcX+y5w
zPcT5B9xXIgP8WQ+wLdt7hF7StErOYscbDUmg6Vri1Fz9P/pitiXPVl33rZg
PzSxAyPPeSakdofs8wHT+ORIOnyKPzdLp3nFsakQ/j9seXDjsPOZuB0y/4VC
9AJ6wkg67jPssywXfOqL+B1yLTOfog89YpPlt/r7Vfd+dLs3E7m9NBezKViK
LzhjOIk67/ee2VLMsF8sR68lN9cXYzYkFivdQzgbGqwdtu3YhJ3oiC4jxuFR
+4RauN1rZcv/aiOPhi2zwvi/vBBnMSO1e4ZhT/xD7Z5wjXDH4B7x/UL4B9vA
bs4hBpzV73vK8VLgB31rtfsVdJNrhbynL7RbV3zSa/4a91N69sLMA01PAQdG
fRaYz7ncSZ831vyW3MsHxnHXAS9vuReQs7yJKbhLjTAPMZPRD9YVI8eqfC71
knccyUVylNwFE+grs45FzvJbLE8tbrIMum20DPGih837zgJu3MbtJPy41HnC
Q87gh93F0PG0a6jRdcS9i/tXQTZOupa+UI65mfn5iN7P5mPO+Fw5cu1u5wnx
afSMVG/+Zs+xOfe+k+5/Rz1j45OPPUtUOk8aTBOXX+VilvluLuYD5oS/6P1G
PvplyffFk94TTAKbnnKNkE/E5ZTvokd9p1tqPnoyH1C/4Ncpy6w3f8YYe6fl
pwsx/1zXe9L4Sc4PujaJBe9B96B+4zT1iD/4jU/AMPKA2mU/sJc5gXter+Xb
PLOiz8pyzAPMBSPliO1PipEX7NPnHAaPyXkwZpnriBln3nfaL5WDBs/InSbX
O318wjhDfNp8LrYMWIbcHneONRRD72njCrhDX+Hcm66FsmeWDmMpNUnejphG
zyv5iC9xni5FvpF32LHfMk8X40zwjPsVc+NHhaiFi55n8Pek/Ukfph8POB8+
NA4c8N38Sf+Xcs32jngtccSn+LarGDFiLfpjC3uRV9jLGRnPUxesA/dv/ENf
437CPeWq7yvT7kfcBaZM08vHrGeL+zj+AQuR2er/Ci5aN75/YJkjpueM4cf9
3wV4A33JGE7ukdv8pge3JYHH3AmpNTCsyrgH/rSkPtmfveG/7x5HnU7aX/i5
z/LMJ3f5bsgcR38f8z36qvtWhe1osq+4R/O/RId7H/L0IOquyTrDO+ueOOR9
6B0LvZD64j8yYtJXDMwAR8AN7iEj4j9QDozfYH6398cPzLTUN/VIXWZcm8yL
xGQ4FzryHwoxBZe4h6w2zR1+4T+WtywzYbtW+ay3LY/cm/b5FdPYyz2G/wjw
Bz35jPmN5i/8V3nOMv8HVoa2hg==
         "]], PolygonBox[CompressedData["
1:eJwlk7tPFWEQxWfN5fq63+7eVRsTQmwMPqIWIvhqtLL0BhOsJHgVVBShgShB
BYNijLGA2IqNIBYiakRjoQIS/w8f0YhiKIRE8XcyxSQzOzNnZs53dlNTW+nC
CjM7hOWwZ8FsabXZsbzZ1djsX9FsmThaY/aK3AS2SPwHWyR3rWDWQ98I+VuZ
WSU95QqzWuLLxB+JB8HqxL7SO5yalfCHGHYf/zPffuAf5Vs19U2J2c4InJVm
J/Hn6X9OrpcZfcz6STxBfIe4V7H2pb+fmePkbhDXE9cQz7JfH5h72KWsevwr
sd+mmn5q65gxlveZtfgHsBORzziIP4RtZJd6+ge1W+a7GJi78L8Hv7UG2068
BZvL+U1fgnMm7prZp4rZk8F7xam4PcK35QrnSFydSf32Rspa8J9go2A1kB/H
P4vVrTLbi51Tjp4OchvAnAV7a+a7CnMb/vXYe2eYd5t8F5yVyD+gfoD8b3b4
RW4H8SPyj4O/jW6YA/9v0bnUDi/JtcJBOfI3OY+fgrGe3rtgDoD9npqYOGBr
yd0s+FvpW4F4BMzhnGtkFH8/GE/zzvk+/LbEsarh4CL+NHivqT9Mfcj8Bt0i
DsTF5sx3102fgmtMWpPGurn9UuzamqdnLPgb6a2kiW/BNSwtS/PSfpz5rDfM
nCE+lbh2qtjndOKciTtpplJawXZHrpFG/OOxv7U02YDfmvpb6R/pgYvugr+t
/qGlov8z+nfEwT36F1LXsjh6wfyWxGdrRjN+R+Lc6A3aE+dYXCfYVHANSAvr
9I3cO/Da887hW/yp1G+TZqZTr1Gt3vBDcI7ElTQhbQhT2MJ4yD3/AVVvkFQ=

         "]]}]}, 
     {RGBColor[0.4455187332341498, 0.32186997546921486`, 0.7432107918860154], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXmsVdUVxg99073v3jOqrdYBnk20juBUjVpNqiagjfqcJ6SgDxEEHBCN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         "]], PolygonBox[CompressedData["
1:eJwtlmds12UQx5/Kv5P/b/ybOAjQ8UIQsQzBEcCYKCaABEpBLAhUQApChyC0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         "]]}]}, 
     {RGBColor[0.5469205553902498, 0.49818035911535813`, 0.8857433198100256], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmgmwVdWVhs+Dd+993HfPvfdcFLVNg0MlorwgWsYwimLUbmMUnFrUWNEW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         "]], PolygonBox[CompressedData["
1:eJwll3lwVfUVx29C8l5eePfedx+I4MI6Y9VEpVaxbCoNS8W2EoQpCDpCAatg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         "]]}]}, 
     {RGBColor[0.6259490281195165, 0.6273881033512626, 0.9109150720273521], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNm3fcVsWVxy/vC2992n0siIICUiyAawGxJBaaHTBgAYxGTUxiipqNYoum
IEbTbRExiogaNZbEgr2nbEw2ZI2Iq0FRibsaARHEKGZ/3/f345P9435mnrlz
Z86cOXPO75wzz6ATv3rkV1qKopjfuyhaVd7SVhRHdBfFX/sUxcGVojhIzw76
PbxRFH9oL4phKh/p0u/OojilV1FMrRbF2yrfUr8/q32JnkUaa6zK0zTwO3rX
v6Mo1qr+Hxr/BI3xM439nib777IontM4S1Veq7b5elar/Qr1fU/PPH27VmOd
pParVX6g53Oq36TyYtHZ3ebfr+hZTqn+GzV+f72/VHOdrTH+ome12q/QHPM1
12UqPxLN16jte/WieE3fPaA+T+n3vS2ur9K3V6r8qZ75rFHlVXruVH2x+j+o
+pbqM1Dr2q7D9E5OH2ieHPqHpG1yvh2j8qHMNV78Ok90DtU4s0XXWXoebvHY
9Fmr9m/0dp9hhcvz03+9ngvSPqiP+1Ef32o+X6Xxh6o+XvXPq95P+/ee+DJD
9ZWad4nKp2tF8Ubqh4gfx4qXd2icmXrG6dt39e3vNeZ+ev+RnjNV78iY/GZt
a9JnfYv7X632+1Q+o7JvZAk5Gpq1P5X2E1Q/Xs+B+r2V1r2PymMK7/EOqh+n
+sd6v5ueJ/X78Zr3+wmVr/fxnrEPx1bML3j1Xe3r5Rprjsou0TlJ7Rv17QQ9
a/R8SX1eUNtnWvz7en1/lur/VL1F/feKnLwmXq3Qc0aXaVkeepCjvdPnFZVn
ZPwfaM4/ibcLNMYBomf/ivl9k8pZ+u5clc93+cx06puX1Pdj6NO7afq+S21z
VN+85v58t1oytUrPzeLHdI01Tc8/9N3v9WwUH14S7SNaLaMv6pspkVVkbID2
cqho2k582FJjbVExXzlHlKylb8Xv5un3EI29vZ6Vqt/f4jOA/I9Q28569lV7
RWP11phdKmdUzHfkd9cWf0P/F3SWvi36nlf5imhYrbY71ed9vb8m52jTGUMG
xor+x1ssy/dmHPb6q5rjO5rrVJULtc4b+vg8H90U3zT+gdI/s1Q/Sfw8RuVi
9btL/e9R+T96/2a7ZeueTgS2KO7WPB1t1iHwYKroa1V9XcV6Y2148liLZffd
wt8jo8N6WUaRmVPV3qnxBqr/raoPF2+G6VmDrkt/+l4rOhZo7mtKy9CJLd7X
vq2u7xB5/EzqHb3MA87v6FbTAH/Yk8F6OvX+26J5idZQVfmExt1cdEwVH36t
8b+p+Yer/+2cs5zB21TfPnqgVN+Gnt3Vb1/J2HV6N0blcO3RSNG5g8Z7U2N/
oc1jMf9jOcPomAujW77fcP0HDeupx8Kre0XjEV3ey7005hiNOUJj3lH1mb68
tBztpGdQi+e4IDRzvhdn3zkjs3r7LKCDfxW5ulH7dITKM1UexXnobV00Rb/3
0fMn/R6gcpnGX6L6033Mi8+q/kQf8+LkrGtxaL5e/YeoPFXlmD4elzFntFkP
Qgdnc2baJ1U87ymF380MnYsjM9DfrvU2tPbNtd5b1P8yvf9OxXt6b/q8Idks
9e1BhW0ge7EnZ0f9PtC847W/B4sP61q8l5NjQ9Cx79St6wvt3Qvd3t+H4VUf
26JT1L69xhmsZ2S3dTj6mX7nl9ZT55a2xZxp9mLvisuHCtuxtZnvJPXbKnZp
jPb7NdE9WuUoPUtVH6ny3orlZlTdcgFtyMmO4sNHar9eZ3MzjTlH635Q7Vvq
m0n69pLoiZXqf49o/Fvde9BRs/2hDs8/0rcf6unNb9HzXdFyhsrTNP6W6tem
8QeobbXGWtVunfiUnn6i/2DN1a5vD1I5Uf2mi6cHqvyx+q+I/n1cbRvU57d6
pjR8TiarPFn9Tle/T2uunfR7ifrvqPLndWOXm1X2Vt+jxePWDp9pdA5n/Bx9
97LaP1/4Pf3u0FyXileXq61shna1z9Pvn3R4DdCPruqlZwE8BH91Gzt9UnOv
0/v9GsZUjA+uGp5xrlH/fp22o5y3IZ2mC/nbRmvYRr83q7pve+Z9u93tO8YO
LtWYW2i8rbtdxyZynpAzZOxkjXORyvMz9pBgv1F6v7zbsnqX1rhBfV6tWu+j
/7v13cxur411IYuMiY4alzPLOeXcLstcA1W+pKe9l9cLH9br/V2tHueuwjiR
PmBFzgs0dPbx/rGPJ4rPcyte65dr1pXozCMbto3QD38e6jLfONef0ru+6jNN
5Qka73j0b4fPKGe1rbd19guxBdjQOX2MK36qMZ4XT29s9RrXRPee3uK9+pTq
qyq2/78WPe+kPl28uqvmcdY2PCf2cpieDRrvfT2/0JhHqt8szXF4aTszNrYJ
e4QcIAPgzKnBn9iUPWNbwZJjgpGeSTv2pVer26kvbTH+Gaf3z4gnT3cZa4Kz
JwQ7wW/4zr6Mrlk/oCfAX/Ojgy7V71dE8+4N8wu+jS2M9X8WXUffa9MfPbc+
Ngvd2IWdLyxP69LOHlB/tjDGXB/+HNVmPwO9DP55PxgDm7i4y7gWTP14bNmA
YLyjwXt9jAGQN37vlT0F04HtzorvsDQ8eS+6GN7+oPR+f680HVOinxut7kOd
/Xk+e/TT9IG2n+iblVrnnuLPihZj1KN6GVePy7xg14mqzy6sD3pkvtU4fnz6
7BXaVgeb0469wr95J3zcWLUeGtU0vh2bNT4oGqoa87CG8ezzGWcyuEjfTlF5
fNV79qL6fqu03rxQ5SEa62X12RV9WFq/TVR9bvgGHsYm7hY7i91YEZvHWlek
D+t7Vc8BOSOsHT9jssafob07tOkxV4Q/0Lh3+IlfAO7syH69mjFn52yCrbD7
Ldlf8AA25BFMp9bxrOipqc/9Ddv6OTXbf+QJWcK+046Nxzb0iw37fJvPBH7Y
qzoLr/w/3NMZDNfa6bHBFthS/LEh4fHY8Bl7gU8B9kOex0VngCWHdvvd2VWf
6+PFh6NE59aiYbrKL9aMHb4p3n+1Zhx6WcXy3qa5S/Ae+kz9n2u3j4SvBO4+
qts2CXuErCKT+AtHV4yRroqPhl5Af0DTbeEheIxxwGT4E2tCPz7I1IwzqWb9
d0lp/cfaGRNceWEw342iayEbp/ffqBqTPp7+8IGzc0W34w3o5bubtpG3N2wj
kW18xSP1/nA9b+n3SVXb8wnqe4FoO0djLBCtl+j9dt3eE+gHg8GHUyrWPegg
MOzD0Q/oyQfTp3/dvusrrKlm/+MMzXO82s5rszz1b7X8odv/GTwJrhwtOj6t
Pt/Td7+quf8vVda1znbRUlU5Uf0mVEzf/MQT0Ku/1xxbaS83b5rfr4fnfMf+
bojfj6yBn6EJ2o5q2s5h775fcSwEvxv7/oWq9cER6nNqzX7n2epzStU6+mC1
n1m1XzNT9etqbuf9l2q2LfNLz4mcM+/9OYNgWvy4PcPDr1R91n9c+pysjV9D
iUwNi92hf4+Mqd8OWteg0jj29fj182o+byPrxvJP5/ziO0MbNoW+D4Q/W0ZH
gg2Oz/6AK2b2sv94SWEch59+vfrN6jYuqXRY96B/0aPgxycz1+NayxfUtm23
1/px1ovuQkejczjjg2Lr3w3Wxma9qTH+lrE4Z43I9qR8i24Hs4wKbmH/F+ec
Hqe2Y7q9Js7fEzmD54hHL4r+XRqOKYA38Xdb0gcfBx+ROR/VuxvUZzeVp1WM
o5/Kut4MTr44doO1Y1PYB2J6rBmZgm/E0J7MWhhzIfEN5K5iLIRPix5A3ltC
A2O/2edf372ZufD70AXI795aw985yw3bio+jz/Fb+I7Y3EU1+2Nza7Z32DDs
1/dr3uOJdfs6t2dd2GjicEOia+m/OngHmQPnfLNmPf+70rStzLp6R8aQmWMq
1on4RltH/1/Zy/psTcYnloZsXRL/a3HwDLYWm7tXl/m3MLL318QniTNMbHed
s3lg6EdmVoZf8OrYyABtM+OL4m/ie4EzF4qWYXouajEumBwZQw8fEd3InGBs
5gBz7564Ef5RS7tjH8RLlyd+Cm3rg7vANRNrjmmdXXpPXwpt7wfP0Gdo5jku
ehs/5BOxI5zvtcGNA4PVOWunR2cu0riL1H9Bab+kLVj2BPGwS/VDGtaxXwtO
OC3fghOeKo3Vwey3q36rxrlV5YSGMdN4lU+0mX/QjM+Eb8YYxIfxwdCVMytu
Y0z8b+SYeALYEJ+Ec4ePSBs+MnSfEQwG7jgjtBFHxI/C9lyquf6r3bZ4ZtV8
/5x4eW3F8W9ixsSsbw6+xi6NjnzODj5FzvHDto5fxvrwBbDds4NxwOVzWhw/
nBY/bkFo2LbVNDHWnqLhWv3+SmkdR1/863HZB9ayX8U+H2Mu1pz3h19g5jOD
gQt9/w98VOx1u8dnrgMa9lX2bzjuxT7CX3w2ZOHvmr9de9pbZ6K16d+0/0Zz
7qxv/qJvRzTsAxHfx9fYLPGq23KW8AMZbytim+p/at14kJjsFwvzG7yKf4G+
HgDv1P+QLvuH6NhfdDoOhp2DT/AL3u7RtO5aVzXenBs8eXfpb+4sHXuF1/jA
YMRFiQWxf+zjueHhTalzZu9I7OixquPuz+r9vQ2339fw+Z0bfEusfk728YPI
BXx4pHQc86HSaz07692vZt2yZ824e25kctvIB/sIFp4dzI/ffl6n9cU/I689
cfF27y9yQix5RHTI1NSJLfPdnOiZuSmZi7FYA/Qvj109oLBNYT2s5cOqdSex
5Dlp5/uja87d/LbiverfbTmemzHpc1jNsdsH0BMa5y3R8XfVl7VbnncnntBu
PYsu5kwxJvuBz3VlcOnT7Y7/Euc9tOYzdIvGmV4zr/+o8jXR8Z/olZr3d7+c
kccq/vZTah+NzmyzXvlhw7bsmppjj9gjbAcxSXQIdpCcDBgGHAS/2Rt4Thx6
XmLx2E/sKHHjw8SDQ7u9PnJp5NSe0fh7N+37IsuzMw77RS7u2fDi4S7HMvhm
D/Fp906vZ8uq8TM4+q3YjcmFfRDmZt5ZFetBYpwn14yhHhZ/ti4TVyqtK9Ad
8OXEmvf5vNJxrxND/9iUpyaecHb8nZV1+1ffxR+tGbvdorYHEtcivrVP1fLz
9dL2GkwJ3ty3apovLh0H2jGxoMfTB8xJ3BPbe53o/3nFcaZLKtbPE3OW9686
jnJjad2GXUH3TVV9SrflF4yBvkPXnZk6fJ5Sc5zyydKxLTA4ORN0P+Og/++L
DgcfgimZ6wbwWdW5L3IFJ9Xcdhv8rBqv3l/aJzsqscSd65ab+VX/JsZG3PAu
/V6HDShtF9BdnGP8b/pdntgINhmcOahivQkWwc+YkXzNNrEp6KMJddu4j+ve
e2SA/R2avAZ0L+1yXJ5Y1SOpg0OOzZj4LGDXY1MHR4AtOGu7VIxj7izs0zIu
OIH88J8jq7yfkT74QvhsxA2373AMjtjPitDDGGC3NYn70DY8dPZLHBcbTV4H
+z2maR8SXxJd/ZMu23hs+Y7xMbFDf4weeKdqLAAfiLsSC+nBSar/LuMTBxhd
95yPVvxQZ5978pyhZ6+66fx1xb4N2Hpo6ZjB9snpUCJHyNPgtG8IJpkVGsBc
5PvAMOTfLok/i2+Pj9+DMbrtz6AriQ8SJ5ze9HnoyQtUHEOamT7kz8ijjWs4
f0YebUbT8SziWj8KtjouPsjkbmPKW4JjwDOPgWeapqGjajxMzhPbx36yr+jJ
j6IvoX9kcgezS/uyg7Pe/rHX+B3QfmPiA8ja0uSE0ENXdP9rP6/I3nE/gb2E
V4wJ9oInGzM3867PftMfnECfHQrr8hmhsxrfvCztf+BH4YNsk7OCDR+Rs8kZ
vaYSv6Fhn6l/6Ce2Af3YI+wZ7ZwXcg3IUN8W5xLwRU8vfbdiVnTvfskdc653
LT0ePij53w/bjWeI2Y9N3B4dv0fiTf9L7lP1hepf73Qd+7i+tK25seHcCTmU
fy/tH4yo2CYckzwaNqs1toMxL65ab6O/mR/sM0f93iudZyC/d37iLZ9sOmbM
t0ML+6j4qv/WcD5wj9ijLZJ3BttcWLFv1NV0DrG74pgyNgF54h3lutxbIBdF
H2K68Jl3yBsY5t3gGGwqc+CTgqHg6YTYxNFZF/mijzodZ14TmqDno9Lt91eN
VcB87OH+2Rvmgg//CC+w6cyNjbiptD5Hr0MLPIE3nJuRFfP70dLnD1xzb2md
d2tyCH2Ti9+UkyOesE98UHTazck93Vb32UK3booRkPvelBsBK2K/h+WuzudK
6/t+kWP6jqp47gEd9kfmZSzaGQ+ZRraXaq4hrLXLcQD6oBOwhdDKPl6dsm94
iL58OvofPqwJL35W2icgd1dNLrtWtw/AuexX2r/Bz8FG/qI0TgOvfRw79Wf8
hob3b1+VN5S29dh8aN8l6/plaYxPTIuYIf3Za/T+PuEnfgDYHv8Ce40fis3m
TLBf5JuJkc9KjAhfFJ/00IbveMBTzumPunxXA8zJfY3V0V13Vs0jzt/a+Dbv
qtyl23qF+0cb9HuN+r+v8jddzluQsyA/hL19J3Fd2om5vdQwln45ax2Vfds0
N/KJDlyc/sS6wJP48Izxm9wVIKaJLh9T9zlaFZqXpT8xI2zdhthTbA62Z3Xs
FHMwfqO0/ibvt7HbepV3xDsv63JMBb9/YuKc9EHHonvZh2Mi39xtmR5/rTV+
Yh+VH4QGdCZ+5wepo//Rm9j0g6I7qV/UtP4gN/VwzX1PahrPTwq2AQOBVYhL
jMldiOtrxs5LgknQ0+jrTTygzljos8OCzx/NfR7w2aIO+6TofPLq3HXgHH8x
56dv1XG+XRLrQ0bWhOeM8WjwFVif+d+u2KfBt+HcoVPRrehP2oaknTm3z7zI
7IjKv+I+lNgIzhTYkrMEXfhhyBB3MXZOfe/EuzbpnCmxBcROjsl5x6ehnTN0
dPaOPsjilfHzsKPoJr57IDk4bDExzKPTn3U8k7Xw/oHIPHadPSC2jwweFrnF
tj4SzLkkPg57fX7GwtbQ9nC+xddZlRwBuRnsCjJBLAPcD+ZHJrcLzjw39yIu
UPmjhvEMuOb53FF4sW4MSl4WbE3sizr3mQ5Nrurwpu0mY0LPlOTRBjeMS3cK
n5EJ6pyph+LXP1baji0MZliV/AhnmXMDreDqQd2JoRWe/4TQgH/5RvJSYErO
5/BgMPBNj41JfOwOldvX3T64bsy1bXBLJfgQfYpuA/cQG5kWbIYd3DMxh0U1
x3qI+cwrTRf0Ed/bqW567qk4Bkcs7ub4XMSViOWBjxZlvQfmbsb4pnOK5BZ3
a2S8wvfIuKtAvgesglwfGdnmTI2MPoXGadEhj9Yc43ykZj9hSWSG+47I2huJ
h3O/hH7ENj9MvXfqxJPBgYxPnXs1zEdeGr9nQvwd/L/7s66t4i+vK40T0Glg
BfwzzuBl8cUm5ltiFdgP9De6Df+E8wW+QW7xcYn14p+SVwNL9GDx6ITWYC2w
LTgYvQjmJU7BWWTuadk7cvL4uvi5xDg4f69XrJNGhYcjg1cYv3fGHxIde3D8
kQ3Rw9C5PLTtXxjDHpQ+6H54Cy8pN4a39J2atfQu3d6q8oXSNuGspu8MsYZJ
9eRpg2PPKh0HIB6AXePMHhAbB5bGZuETge+JAXKnmDrjEl98Lu1f63LehLuW
6Jk/5VvWAjYmBsFDO+MTy+y5y1d4vOcS1/1a6XUvTOyHGBAY5fym8dJAbFDV
sT5ifpuVxuVtVePQRrBoT5n6tKZtwoM134XiHlRL0/EV7hHi/3JHAp1DPo/v
6uEPMW3sJhjrsKZzxOSKuXMBbiTmMqXp3Bw5OnAcPh66nfuu8IV7jMQMiB1s
umdEnRgCsQfyNcSO0K3kYfEBrixNCznGQQ37yls0/H5+7iMN5J6E6tuqz9Wl
cRbxmB+WlgXyxthRdD1xDMZ7J5iNezrDcteIs4B/Cg3fKG0fyFFw53dEMBtx
480TOyYuhgzBH2w2d0ppA8dxb4bcObkRciTE7uDHlrlfxF2kAWkn/gCP1iTm
sCL10bkXN7Xp/WMuzgvlH1Jn3+jP3n2ptKyRlzuttJwR91qaO/DLsEEV419i
RVdWTAsxOXAoePTu3I3nrh55qLWpg+PJK01KvAJMT9s+Tdsl9A66grt39Plk
1X4k36BLj2s698K9gysqvq+3bdO5oYkZE0zdCN8oy9R3TztY+jNN/ya3D23c
NRyUEn8DfMT+sE/MAe0DQz9x1m91OT5K3/5p544++ulbdeemsMfYYmJE1J/F
v6i43LdpPcK5r4mf53ba7mD/z2l6/LOb/nbTd9hSfmNPJ3cZN4AZiHNw35oY
DLqYdmzsvonHEpclH4394v4Bcd7xwZbc0eQ+5Gulz9YZ0TvQTz6C78n/Usem
jGv6jBIfBSP0C/Y+tmndQx5+TuJcD8Y3wWYjK8gyMRz2h/dbpw9jH5K56NOV
/Bp9+c24n0i+krtCt9adQ+HuD74FvmJP/Cf8AF9z74Xf3BXfr2k/mLuB+P/4
edy/QObYN/Jd66vOrZBjQQbHRw7RyWXiWD+sWI64z4IfxroW5AxyNsldcoeI
O0jotRGdlh/kDZuCXkAXT889mZcb9kXwN5AD/g+Ajphb2g6DibHFX6/4LgR3
ItBJtMNPfJSNm3yZTudOWCd7DT7h/gEY5O2cHf5Pgq67qnQsg7jFRRXne/C5
Fzd8Hw4bvIfKIYnt7Bqfd0PoQb++HR1LnIU54TE6nztj6G7y3WCRHhzS5Xfw
BDlHxtlL5PGl6HzifNgGcp07ar5R+F9V525YG3kW8ip/iX3kfio6eHDpGMh5
Wfu5GRt54c74iPjOxGPAKpv+u0JJTJ4zxzfgInT5quhz9DR7sSkX8XzWS4zl
gMS+2G/08tXR+Uuzv+TJD4xO7rHFnZZX9Pqy2HHiHPsnVgONrJdzg23cGL+J
84g+50wiRyPSB/9uWezFtVXfWeLOO/8FIM9BbgMaBof/4GRoZk7u7IwMT5bV
bVfJG4Af6Q+GxC/CpyC28tnStojcLHSxT9y5YI9XZE+RhbfCH0r4Bs8uKm3r
uBfPfwzAJ9eV9plYA3aR+4XIzNiG7/mhLw5X+e3Suoo7U5xjzvMRsfnY+x67
32754Wz8NW3gOv6PAa+/XJrG19KH8Vakju/M3Wn8ZeLZxLvRFdgSdNLVFcfY
kVV8MWh8I7JBrBQMgK8Hv7nbgs6kbYdgA+4akvOY1PD9bOaaUfUdAnTHwtIy
SawQnQW25byMDC2vhp47k9v9VWlMytkEi5xVMe4jxwUeXB7ZOyj3yT/ddN/l
wYcX5m7kd0rzkTmwEfwXBf15n8r/Axk48Vk=
         "]], PolygonBox[CompressedData["

1:eJwll3mwl2MUx59776+79Vve54fSgrbrhjSUUpJlqAil1I2ElC2hooXG1r5p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         "]]}]}, 
     {RGBColor[0.7005028309634165, 0.7471753197051194, 0.9126146691033419], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFm3vclWO6x5/1rvew1nrXWs96luTQGMd2FKNIEfI2JCIqe1NDRSnFjBBt
mXE+tmfYs1EIRaY+Y9A4FEWEvWdPGEZOk1JMyrEcOjBbZH5fv+v97D+ez32v
+7kP133d1+F3Xfezdh89cei5DUmSjG5MkrzKHi1JspfqU3JJ8oTKjU1J8rjK
I6quX1dOkn+kSbJJ9Ta13avySz2Xq/29SpKsU9/dW5Okl+p3acL71LeP6rNU
X6D6V3r/Dz0bNP+jKk9S3/NV3645SWboWam51ra6fWe936RxraJpg2hbrTWq
6nOq1j2t6jEjVA4pJMngvPvMKCXJHXpm6l3XgsfuqfaL1W+w2nqIho+hQ+sc
qbalep/T86nWeqaeJGXVt2mdbzTfN03ew2UqB4ieYSoX6Vmn5zExbU3U1+dd
ron28ZrrDK11lsp7NVcPrT9R5VNNXmu59nu+1j5OfS6ouu/37F39G/RsbTK/
Xhf929R+q/oPTN3nnbL3VA6edFb/nNrvU31+0PRszvPc1+y16+L/Lqqfrf31
0rzD1e9/1OfPWrus+heac4H6T1Sfx+BDzfX79P4C/d6iOcTSpKfGPtLg+Zfq
XU31jRp7gp6B6t9XfS+ruX6e3neommeTNHir6kvU/m3I0S3NlquBqi9VfR/V
99PzouoL8m4/VvVFiXnes9l8Hqn6uGbTxRznxTzP65mk+rMqP1U5R88uonOC
9nyS6pdq3X+Izg6qv5UlyT2iaVbJ/XLiz44qR6nPb0o+lyM0z82NlpnjVRaL
mlvrD9FzYtlzDmZdjXlG66wpWxaRyb2CB+c3mifQ/jc9HZq8zuV6dlZ9nvpP
Vv2hkE3qyCE6MFX1MnKn50+q3y8+vKNyR537mLz7rNCzt87gc9H8ud69ovbu
qeneX+WlBfMCPnyrPbaq//6S48GaY32z5ZB1qrHWl2WfKWfbho6o/VW1/TQ1
f/up/C+ttbnZ8jJLvN2i+m6au2PRtH3W7HNg7HPq01tPk+pLRP+GinUfGzCk
6nNeqTlv0pwb1Od2tc9pMm3Q/Lpo+TpsxQ6pdfqtquUfu4Berwn9QyaxO9if
L/R7PXzBdqh8XO2fqf55zmfRIcYsbDb9F6r9TfGqoPZP1L5F9MzW7/NULzaZ
b100Txed6yta+xzx5OeM0fupouE2rdlBzx5qW1Tz2IUqCzEP/ZpbPfcLic+N
84Pnh0kWB4h3/ere097N3teX2u8Xet9X++2oNXdo8fyT1W+92vuo/W6Vn+o5
S/Tc3uJ+xybWN+zVl2EDsAXYk3rY6qzJ9HaMOW/Su7fV9rLGDmxxfWbOfGL+
tka3rYg+6GmD5n1E9RGpacsqlv2VIZPIXdZi/RokWh9l7+rbWc8axormTqqv
RBdS6yP1I7Dzmr8ztk71B+uW+8nqP1/tu6l+g9oHNbodXTilyfbtZ2r/Wv12
0/ovaM1bUst6B53FaJWd1O/bvO0HNEzSHDW9W6x3x2ids6qWD+zNSNV3UD2p
WFep76OfwwvW4W8S6zf2hG63lc2PsRr3y4rt2Rta/w29fD3kv0FrPYS/iXJe
i+3ba3r/R9XfwQfX3L5cczxecj/6DCn57OphQ6AJGi5sdB3a+qm9P7xQ27LU
NEALtodz7BDnf2/IADpA26Pi18SQj3WqD9Val0kmt9PvTo0u0SfeMQ7ZR59q
TdbRyTF+W8787RT0HK95dhe/KmF30CP0aZKeVM//qn+h0fxPWKdmm7RQPHwR
myO6v1P9zrJ5VFXbvq3W060V2+FeZduNFaFPyCf27Nz4jU1dGv59pugshS4f
J9oGlvwbvWTOPRpcssZh6n94o2m/ucF0QM82ldv0fq7aB2mtl1T+pck+kv3w
e6fEGAoshV/+XdV+ao7KRSr3a7HtYdzLep5uMD9eDp68HHNSP7DF84DH2MPi
Jvsj7CR4An7hC18KGujzVNB2kfh1AHiu4jkOCHoOL3pe5lyid49oTCftaRn4
Rc8qbILGHqc+/fV+ofjT1mI7cXXq+lWpdQ86sNVzY+xeOa8/J2i4Rv36qX/3
ivWAOraFPcyN/sjFsS1eBz7cGTzBFkED9gT7MzDq2CNsH3Y+C3nevtG2prXR
9MzUHg9vtp1rK3os6w4q+eyrGjM97xK5mF7yumnYRsZiS+e0+MzuSFwujHrP
im3UrrIbu1Zsl4qqz0Nn9Sxutmz3VnmI+t9Utg8/t2odBQuhp7PFnxFa4+zM
/OMMljbY7w8IXHRb1TbrKunHuIp1JVO9i/oc0uzfvw0c+ZfMa7DWzWXjQ+QW
+8u6RwWWAFe+GtgSm4Xt+oto6YXcBgbDd3Nm8C2verewzw+32K5h07aqX9fA
meh191bzcF/17x7r4rfB02BpsNrC8LnU24Kf2LoFJdPU1mRbBn8mVM2/h0Tb
Hmo/CJ+teSZV/H4H8aFcsb+ZKf4/XTaW6Kn+DyKjovVhlePr9hP1qvd4fYvp
by2Yz/CbeAeaoK0WtjtLjWGHx7kkqfHYa6nt9TUt5tNRMQe8Bc+CX7Hb+1fM
63u1/laNmav+r1R8/v2j/2GSz0OLxl5fVy07S9V355rlH118L/WZgJumqO/F
ejbo99iy94XvW56anr+lll/kAxk+KDUu60UM0WLewuMn9Psc/X5K5UnwR3Me
K/lZXzSeYGy/wH4vVBwHDQv7cHLJZ8GZYFfmhm0ZFjK8KnzBzS0+rxNLlo0P
Gq0fbUHDqSXLMLT2jvk477+WjTP7prYTi8OeYBfYN/ELPurSonHeND276Syn
6f2Ysn0zqnEI8xSMV1dg51S/MXwUvhM/hY3HT7XPQf1ujVuFncnZp/yq5jkv
VTlYT119binb7mJ/sfnX1W1H2Cttk6J9F/X9ccH+5OSaabhDY0eKH3eJ3jv1
vKl9jAqa0GNiQeLHrnn7n4dypgWawEWUq6OOXUYW0VPGMBacCb+hBX0kln2t
xfpKfLm8xTqN7LMX5BUMck3gkNU1z/9uzXH6jyMe/7Ho/KrF2Bj/Ch3wh7Oa
GHFB54r9y2Sd3U9qXuuCsvUe/ULf+3DuJeN75maNZyvW3ZMiFri+aNsCzT1U
fyPOjhK8jt+ernl3VP1fa44dwabYstcKjp+xb9tULiuYJ5SvRfvkouvgxb+r
fK/gWI58wrt6tk/Mt61hu96L9h/6aN2hZcdc37e6Di4Yqverow98zgf2vrxo
bA/Gf1l8+ZV48pLKgyP2fiweMC749qOCeTBc9cU1tz+t8oG8eUXOBJ+H7waP
Dct5PGO3au5vW4zdxuUdn4Dz0ftCwXYHn4BvQGdXVGzTm2qOOYgfj1f7H1Lj
5gdUfqi2vUJ/j615nhvL1inOBH7Or3vvAzRf15rl7byyebWx0TaBvMVJBecu
ODd8DfZ4+4LnOqjRfoDYn/oatZ9SsB41RV/sNnE47WBgymFRJ5ai/uecz2JI
rMWaQ6N+Zc15hCtUPlFyO+c1PDV95IFOqNnOY++Zb3jM/2LFmOCbiF32L9gn
nllzfYzKb/RsUn225tlT5V4FYw1yVAMaTUOtYhv7cN25KHJGyxPjl0GBYbB5
cwPvkWM5sOy8xLiIXbAxP5xVnNf4sBnM063g/BexZO+87SY28/uy6Shljp3J
GZGzGoU90nMAeDrsCPoCxiKmfi5nG4atxI6dWbadHVE21l3SaDxZKjm/gy/F
RjwR/rSj2vcput85OedppiX2LdSnJy6fi3byi89H+4Dwp2Ah4lriW/wM8ohc
/l283KNku4oMkaehHfzcpdWy93HF8sT7W4O3YGV8Cu+7RLz8Tmo70qzyhIrj
R+LI9niAGKFn2XaAs1hbs8wj+48GNoVXu4S9Zxz5JPJB9CcOA7vSr6FoeSOf
wZkMCZvzbmp8sopcpcpP9PyybAxCfXzeuKx36AK/6TcKnKwx16q+IrU/QU+Q
25Hhp8jjQcsJIUvsfUjYMWIpYiryWuRg5kR88VLYq7+qPCJ1zoTcz+OqT1D7
fJX1iKOJp5HxVyJHQ25yr7AzO9aMe8gFNhUsC7x7MzVmakydV9g3bDjYBFwA
vq0WjCd5N7vV+RTszv+lxkvgpj8FBkNO5gX2AwOCQcAi+Hpyw3sHHu0auRGw
K7SD18EeiwIXgY+wn1cWbIef1NirVH9HPLm64Dp2lfzH1VFfWXXOZW7q/GK3
iEmmFa3X1A+J2IB97V1zf8bBc3J26P61Rfse6PyPon0JtE4Iv43NGRH+HPqh
5cqgYXFgK/AxufSt4QuIsdoiziKn9kbe+7q2bH9Bv66iuQk91bsHNd8DBevv
f5aNlY8Tvb8t+zwG1RxLMx8Y4Ndln+sAta8Pvn+i8lDNuXPR6zHfH2LOpGzf
2aFoHDsuZO+MqJ+u5/qyMeuRmnNzyWPJuS0peS7y1+gb9KI77KM9b0GukNjj
ntR+H5nBpnG30Cl86KrQtb+nzocR+4F7iYfxrfhYcC7yA479XcRrs0O+wKu0
oxMPxr4uFc2b9G5ji/Ow2OjfV6yL2CZ82RVl46gjtK8zpEsTtJ/RKruVbLvo
9wI5x5xj5B6BbYgB0O+m0P+DyuZX35z9w6iw4WeGPSf/vCRnO407Gxk2+zNy
a0XrZ+fg+ekxT1vOdWKKaWX75qE14+gtgaXPFG199ByV83ojY07yQchWOz0n
BA3vBr7C5nwV83B2I4Nm+kzJG99g/8fFvpCHPkVjHt79pmidQgeIe8ZGH2zB
ssB1M8r2VdhgMBn2DewBrjwx8kXI0eaQpTHBL2gA44+JOvZwdNk87h58Ip4d
Eb4Pfj5etM3ibODZ2ODbyJhzROxjdNC5JdZl792Lzu8R8yLLm6IdvNCen7hR
8vB+wf7+44JxIfYHXPR+4JxPdDZrVf+4ZhvwUdgrcNGa6EPftVEnjsPu4+8W
VT3f0LrjEdZ8JOc5Pg4MOqJmPDGy5thot4iViEsoiU2+KxtvzNM8n8RY5h1c
cp6QfOHMsvcGJtqguT5Qub7mfDu6TZ4cnWjHDugQOUlyiy3CK4n41azyEq17
jJ7hOWMs+HZy5KluClvEPRvz47++L3gsOJ9Y4PvA/JMCX+4UOVjiHsZPK7kP
cRQ2Y1nh/+VrW4wlXp8Sskq/bRFf3FJ0HIt937PmfNVONcvz2NAxeMOdx+0h
D9ypoFM7ar4xoVOfqryhwfcXQ8i76t3Dan+n5vhnlcoL1X60nn/LOZ+NrLAn
7ve2z/+w5eRK8efXar9C5RtxF8I9SLns+qQG6yX3XujmUP2uE2PkTAs0nQqG
LDu+IM4gVr28ZHzBHMzLPO9HLpg8MLR30djrE/tB8vv4LO4w4S88w05/Hnc1
XYvWb3i6K2Wcb794Dx+OUH1tzH+x9nOF5tmp6nVY72y176f63Q2WYXL29Nkn
csLw4dzA09hUMDOYkdiS8x2GTur5MjH/4OPmxDqMDcW+HV003iNmeDR8D+0/
U/2A6H+Kyh4xz3UNPkvo3zMzBt5D5XZF4wZ8Dr4bbHFlYKJ9QrbA3fg11gBT
gaeIHdg/fJii+jPkjBLnfnmog/GwJ0vCXzIvOAZscEycE3OQl8IGvRoxN/YU
G0UeDx9ErIetnRVnd0XETTtWbcOYH3u1c+QtwJnM35r32eEPxxZNC/nslyKn
PSxiOmzRH6q+Lzwyta7NjnuyObEueIk46564q31avFugORdnls8X9fxLznqA
PlwsGs4qOR9HnEufM0OnDg2fytn/t8Yv1DzPZ/al1IktB+j9VD0nq89zevcE
975Z5ESLtvM3RB/kjTiVPsQW6NVrap8gGvqrvEhPv5xxBjJM3EPe6a2i+fVT
2ay+5OIz2xPygMRQvyxaP9EpbCw5IGIydI12bOnKzPOsyNzGGNqHBqYCz38S
GOxHNbclgfORW+7yuTMFe/GOOAgd7BN6OKJuPo6sm7cXhZ25seI486PUdhg9
PTL2DW5g7+ScpkfeaXT4P3woWAz8DaYl575f+Br2fXjsvW/ec8HLu6MPeS/O
mbNcHXioS+gvZ7o02rkH377oXOfhdfse+NI3eEt+de+ggbgYW0COixzWBRq/
ocH2Cn29LmRgathh6q1Rvz7k/JLYOzgPHzU5+HFJ2C5k4I3YC/fe4GAwMLQj
h9jVtuAdeGlUyDN7gcYZQSc2ibPimgyshT0A6xJDfhH2Acz/Q161ySX3EOTZ
2qKdOnKIDOKz1oU93RZt7J9YG3uB7wXHks8j74Td5/sC+AtvTxRvT1P9hLrz
Z8vCJ5LPwK51DExzUMTa3KkdFrEzcoP83CQ5OkXjR2uek+u+E9sS9yvkrpmf
2O/IunPNR9Wdk0APyG9gM56L3AFnDm3I9vF155QHqdyuaptG7p8+yDp3Vuja
8pLlgXslfD65083SpU16tyWzDpwfvCJ/gp3FvhI3oMu8W57ZF76dRf4jbxnu
Rj4scra3qJyXM93sn/KFOJfRcV4/YNGS+Q5+RgeQmcUN/l6HvA3fEZB7pQ93
iW2RS0X20QF04ouasdeXNcsZMRd2Hxu8KWI58kDsZ0v4jt4x/wsxz+p2ecxb
JsFk0AZOvkr7vFlzXZkZI4AVVib2k9C5MfEd2pS4myB/AM+xLdjj8SXH59xd
0GdM5n78Zq+n191nVN3fk2wf58VZvR3nxZnzm3PBV4CF8Bfcr+DPjpV8fVtz
jPGdyp0z82GnzD4TmQfD4L+4G2Bf2EXWQn7mVnz/8Vn0/0XOfhYsyh08ePSZ
zLh/Seb50CXmRPfBLmcnvpckdvx52HNsEfb5sbhH4ryIVblrBwcRr3BfTn6t
rW7fuKDqb+L4RofvKoi38nn7MnD0oLjH7B3fo0yNHNo5ocvkUblX4x4KfeQ3
OkkeaXzYTfg3O3IpfINETgx8xF0ad2oHpM5bcA67RFwAVgHbPxJ+BPxzQ+Ac
7CSxHnnVZ8I/Lgga4B18WRd8XRt8IwZ6PO7+hsZYcmHYz2LefqdP+HF8Pfj6
lJJjb2J0ZJT9c5fPnT7fGDA/c9+gdR/KHOvOU3lHg3UTLD0w7oL71G37wZqt
oaPzws4Q30wLXV4ffeAvd9bEG+Q/uDPj7uzEivWdvm8nvuvm7hnbMj18Hv6O
/b0buWl4uCRs+/rwzdh6+jI3vu+xnEvueohRiPuZ854G6yBY/ei6edK/7u+w
OobuDKg7p8U9KrJyXHzzgG9lXvR3aNBFfXrmu/PbMuNS9sVZox8dw7fOUv/p
se6MBscn8HNS+Lt+0R+9Qv/xaaPi7PhOku9r2OuIiu9gRmc+x0LEgJx5/8BR
zNc/5gQLk5siV3pMxbl+vp8qZ25vzRy3bYvYDQw+LHB496h/nrgdjE5YiO3A
LmOTn6vY33HfQhxKLptYFJ1D/tBr9oNdg7cHNhjzMw959O4xP+v0iDo6Nj7s
Kn0ZQ4zAGSCnnPHYzPdD4zKfM23EsORPekaetldgKOJ68srgwj1ifWKPjRGD
DI86Np06xzBR816nyrmZ8Q91MNjPM+cZf5E5B9Yr8kvs47vgGzwfHLk1Yuqn
Im9+Xeac5vWZ4xTyhvT998w5motVXp05Hr4m8/eT5LbIa2E/Poq4hO928MF7
h36PCTnpGbqAbQF7Hh0yQGwB9sImLwkbRB/8Hb4O/pAj/zjy5M9GH/RrYIPx
PTECJb/B8MTWyPCKxLmoAyP/c1fo1105x0zHBN7rEPl76OMOk7vMn9Q9DnwG
r8iX7xv5ImLlQtzvnhR3nT982xzfA22uGh+yB3JnrEsuBp3EN1wWd9yNkSdv
Sn0/wT1FS+o7cPqcmdmOXRCY7pXU6/P9HbRAE3n1DyPGIxb7OnAAcsJ9Me3E
feRxyOecVrNvXxxyta7VtHFn/VjcT5Fbm5X6jpTvvvGrB4dvPb3i/OinqbEB
/h4Mwt3xuXF/zN7YA5ibuAg+fRMYtf1uc2qcHefF94/EocS5f06d5+Z7kCdT
59T5RuaisBv4Du635oc+gu+4D0VWesZZc15g6AMih4lt7hnt0MLZDQm9mB/2
Gcy/KXA/ubTLgg/gZH6DJX6U+hvFB4OX3Pdw1/Nd2ApkMs08f1XlH1PzCp6R
cz4j7i24uyTvgG+8P3X771Pj43PiO405qe+Z+dY+H/cE/CbufjqwK3cF5K45
J+7RoJkc4Py4xxlds08lr43PIFdFfAIOnJD5noHv2cnn9Ym7+wlxV8v9HL/R
B77vnRfYFz8IftwS+Jb7TuKEL1L7r+mhX9iym8P3dgufOyNnX3przIP/wm7O
DN91d/hHZK13yNuM8O+MJW6+JeZ8ku+rxMNFmTFWe/4SvZ8R/Rl3R6xFXvz+
ou+nbo0++Djkn/xle54UGtp96F3hR8kVP1B0vni/8PvQuSH0CNt8Z/Rn7w9m
7v9A5jupXxd913N72H1sGnbhoMjPI793F31XMS1z/dbM58IZEEOwb/YP/8hP
s3dsQN/2GAMMmTnm75zZP2F7iUnhfbcYC9YmXgJvT4nYiRhnWsW5cr6LuT8z
r36fmVeMhZ/Ew++HzSSPNL3ofM7UzPUbVE7OvN+LMucKekWenG+HyfuQ88EG
cL7DIg7aEjgBnt8TPEQGDolvKaZHO/ikFr4ny9w+K+z8BzV/8/FhzZgOu4nN
5G6OGIf87bL43gkfDl+R6w0RK8EveIUsrAt7iL8ZFe84K/pydnzPmYYeYv/X
xv3TZ3EWxHr4lm0RawyNbya4uyDHtjnuzLCT2Egw6oYoyUVMjBiE8eRytkU+
Z1Lmu8MLM9vsdZHfJ5biXImlyMNh28iBn5f5m5vzM98Fro1vfvi/ArlU8nxv
V5wz4fsg7vq41yf25Y6IO/j2+3d8C3PiH6BnVeCRnwX+6R/7nhD+B50oRp75
4Mg1vx/3F+S0/wky/+wz
         "]], PolygonBox[CompressedData["
1:eJwlmHeUV9URx9/C7u+3v+VX3ltIaBbKopQgICJHQFh67wlIpIQiCkS6K5wE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         "]]}]}, 
     {RGBColor[0.7737900624999999, 0.85071925, 0.90903175], EdgeForm[None], 
      GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmgm4VeV1hjfce898zt7nKCCoT9MKKhBFBhGTgkOVQRqMQ0yjCGodEBlU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         "]], PolygonBox[CompressedData["
1:eJwtmHmQVNUVxt/QM9PdY3e/9xqU1YIUaCAmIoKKlGGz2EwiCZQkskNQwGIR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         "]]}]}, 
     {RGBColor[0.8407444374999999, 0.87304675, 0.87903625], EdgeForm[None], 
      GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXmQVNUVxrunZ+mZ7tevu4m4YZSEGJcqDRijkYCCiEQHUyXLGIyyiYos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         "]], PolygonBox[CompressedData["
1:eJwtlllslVUQxw90b+93v/tdZIsQWSqC0ahFZQsgtZStLQlQioAsVaKALUtb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         "]]}]}, 
     {RGBColor[0.9076988125000001, 0.8953742499999999, 0.84904075], EdgeForm[
      None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmFtwlVcVx/c5J0nJ5ZzvEBXHSZNQaIGOgQiFUdSn1miHCs4UiHUgHcc6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         "]], PolygonBox[CompressedData["
1:eJwlk8tLVHEUx49htxxm5t4ZyCij0pGZgla1qKBVRQU9FkZpVBAWpGWGlRgZ
VqA9cCBzMLKZ0KC/oEWrVi3aBDaaKS2cXlq0aFdkuz7fDtwD33PO9zx/99S3
XmzqXGJmO5Fq5EvKrFJjth7cGTebQn+LPokUEmajSbOzgdlH9GLCRXgO+Zxy
jrhn4IzAXYmcWGr2A7mcNuvH/xJ/drlZc2TWRY1N1JrHtkB8PZxszGwDUoF7
KzTbscwsX2V2E/wAWweNLpJvMuU5lCuHtIBb4ATwv5OzGVyGPwH/N/xV5K5D
MvQ2g20W3zBSrvEZNet9+j2Ffx313+M7FnnuNeRro9dxbAtwz8F5Avcp+gC5
fpL/G/FXI59dM/eAL1GvAf04ei38sYTP+hWZh5/Bdh7fPur1we1GPxj4jrSr
DDa+/z02AkrMtJ35XmArgguR96IehsFzxORivkPtchuyB7wXWcT3N+G1ZJOv
xExl85gG9APknCDfM/a9H7wi6b1rJ134b4fu20UPd8Af8I8H/oYXyNWH7bX5
m90A94b+dur5Onhz2nuvJmYLOIdtDFwFJxv6m+vtT2MrkLsj7rsvYbsL/1DS
Y0eQN+BH+F/hf44/j38rsjvmtj/k6o68V814BTxNTDHwnbbH/Q30FnpTva1y
Kncv8gu9gr8W3MN+H6q30HvVzBvBA2nfrWbuT3uMYk8ig+RqCv1fVM3Doc+g
WTTzUOg9q3ftvBF9JvJ/U//ELPgT9evwXcM2Su7ByLFuMB/5zen2dLOP8R8J
/XZ1A0dVL/Le9U/dA7+LvDfdxBR4NfXXxnxn07qHpO9eNzaU8BvQLYgj7j/0
npEs
         "]]}]}}, {{}, 
     TagBox[
      TooltipBox[
       {GrayLevel[0], Opacity[0.4], 
        LineBox[{3322, 4574, 3478, 4231, 4232, 4233, 3700, 3701, 3460, 4183, 
         4184, 4185, 3176, 3985, 3180, 4744, 3984, 3799, 3879, 3878, 3251, 
         3880, 3881, 3800, 3801, 3181, 3804, 3185, 4581, 3487, 4580, 3488, 
         3741, 3740, 4243, 4242, 4241, 3489, 4582, 3643}], 
        LineBox[{3332, 4576, 3481, 4234, 4235, 4236, 3736, 3737, 3483, 4577, 
         3482, 4578, 3182, 3986, 3925, 3926, 3924, 3928, 3927, 3976, 3922, 
         3923, 3795, 3796, 3177, 3983, 4643, 4644, 4563, 3474, 4562, 3475, 
         3733, 3732, 4216, 4215, 4214, 3607, 4723, 3640}], 
        LineBox[{3373, 4722, 3606, 4720, 3605, 4721, 3726, 3727, 3541, 4634, 
         3540, 4663, 3575, 3243, 3224, 4748, 3876, 3851, 3916, 3915, 3296, 
         3974, 3975, 3973, 4213, 4212, 3244, 3228, 4642, 3549, 4641, 3550, 
         3731, 3730, 3472, 4560, 3473, 4561, 3653}], 
        LineBox[{3378, 4635, 3543, 4309, 4310, 4311, 3618, 4128, 3619, 4734, 
         3577, 4664, 3576, 4665, 4741, 4740, 3997, 3966, 3967, 3965, 3969, 
         3968, 3289, 3963, 3964, 3962, 3996, 3995, 4111, 4658, 4659, 3663, 
         3662, 3787, 3572, 3723, 3722, 4307, 4306, 4305, 3536, 4633, 3650}]},
       "3"],
      Annotation[#, 3, "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], Opacity[0.4], 
        LineBox[{3321, 4572, 4573, 4229, 4230, 3250, 3699, 3458, 4548, 3459, 
         4549, 3582, 4771, 3583, 3401, 4413, 4415, 4414, 3331, 3767, 3330, 
         3680, 3610, 4125, 4791, 3479, 4575, 3480, 4077, 4455, 4019, 3429, 
         4017, 3428, 4018, 3486, 4079, 4783, 3337, 4374, 3338, 4423, 4424, 
         4422, 3405, 3588, 4773, 3587, 4591, 3495, 4251, 4252, 3259, 3745, 
         3260, 4254, 4253, 4593, 4592, 3645}], 
        LineBox[{3339, 4583, 4584, 4244, 4245, 3255, 3742, 3256, 4247, 4246, 
         3490, 4585, 3585, 4772, 3586, 3403, 4416, 4418, 4417, 3333, 3802, 
         3864, 3865, 4192, 4191, 4789, 3425, 4456, 3426, 4001, 3381, 3998, 
         3422, 3797, 3861, 3862, 4187, 4186, 4781, 3323, 4360, 3324, 4409, 
         4410, 4408, 3398, 3551, 4752, 3297, 4323, 3476, 4564, 4565, 4219, 
         3246, 3734, 3245, 4218, 4217, 4725, 4724, 3641}], 
        LineBox[{3372, 4718, 4719, 4715, 4717, 4716, 3721, 3286, 4304, 4632, 
         4631, 3535, 4350, 3316, 4763, 3571, 4657, 4209, 4405, 4404, 3371, 
         3960, 3370, 3961, 3539, 3850, 3849, 3848, 3455, 4066, 3666, 4069, 
         3457, 4067, 3456, 4068, 3548, 3860, 3859, 3858, 3377, 4406, 4407, 
         4210, 4211, 3601, 4778, 3600, 4640, 3547, 4321, 4322, 3295, 3729, 
         3471, 4557, 4559, 4558, 3652}], 
        LineBox[{3379, 4636, 4637, 4312, 4313, 3291, 4735, 3290, 3674, 3793, 
         3792, 3578, 3764, 3318, 4764, 3635, 3420, 4447, 4449, 4448, 3374, 
         3852, 4095, 4096, 3542, 3843, 3842, 3841, 3453, 4051, 3450, 4048, 
         3452, 3839, 4092, 4093, 3537, 3834, 3833, 3832, 3366, 4438, 4439, 
         4437, 3415, 3570, 4762, 3315, 4110, 3569, 4107, 4109, 4108, 3720, 
         3281, 4295, 4294, 4627, 4626, 3649}]},
       "2"],
      Annotation[#, 2, "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVzbsuhGEQBuBXKVlniYRKIaFyShQkWhUJHUFiaWxhUSkcShcgWmeisdUS
lcJFbKMTh4ZCpyEexZP5552Z7+8ulmfW6pJM811Iai3JYUOy3ZzssMt6Y7LB
Jj28yt5451H/7O7Fd7U1mXA75o09/WxT8iD7Na+X/agV/bzZAouUZPuyDrs1
b52ox4x451y94IyS+1VO7Zfpdftk/8rsklH7t+odVYrmS6ywTJeskzkKdo/8
c+j/X2bD6pTsQG3Xt3Hv7U/1g0l5n77CDVsMygbo59rtlzou/wP2iy+5
         "]], 
        LineBox[CompressedData["
1:eJwVz7suRHEUxeE1vcs5R4HQKCjUKlFQoSEZNSYKMQo60Ujc3kFPonIZhcsQ
72OGMN7Ap/hl7b32Xvt/zsTWfn2vlmQFVX+yWyVDA8kOrWiTHtH3vmRmMJlW
/xRJD79o6+t21rBcJqtuXPKvsG6/1A/zC9qy0+Ndq795L+o2nvGGV2yblbIV
CizJLKLpnVvzO9yghXs07H/SL3QxLjOGQ5lRmQ3EzhOt0U16bn72f1s/5zsW
7M7j0azL7+ADU/pJNx/8+4X6lHeCY4zoD2Rm6R+qsyrS
         "]], 
        LineBox[CompressedData["
1:eJwNzr0uA2AYxfFTlEh8L2xYLV3MOpgYSBqxWXoBNXR0CWhE7ILb8BFTEYkQ
EsEF1CYhabSV+A3/nOec5zx53/nqdqVWSLKO2dFkeCq5pucTyQUucTaWPIwk
S+NJydyV9fCHJv9l1zGfut10uzGZXPFl/WPZnKxu/tb9wR3f4ffc7dr/mtvy
G9pE3X7a/Qy68h4aujV6SNfk0XvCI3b0n+kLBlDEkV6/3qtdHy1gwb9K/Ik3
V3TeZW/YklXt2m5uvTFkHkQRi/yq7ofdgfletq/fkjXoJ12W/wNBGjIa
         "]], 
        LineBox[CompressedData["
1:eJwVz70uhFEUheGlQIOZ0dGIzOgnuIAxKKegZRqJlgY1iZZEJW7BlRj/0fn7
ZlwClUSI5yvevGvvs/c5ObNbu+s7Q0k6WBxPZiaTZy6qSR8DHOkdohhLNiaS
Bp6wiW5Zm6ljCtM4rSSr7jjhFT7mJle4ihpe1MNmC7mPd3xggDV3vvIbRjCK
c29v69/Kd7jBA+7R0e/xNX7lP5yZ/ynPvbPPDd7jOT7gJZ6vJW1e4E/zV/a+
+MJfm3LL3KP6Ul6W2+Ueena+uaX/D60SLh4=
         "]]},
       "1"],
      Annotation[#, 1, "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1FtMz2EYB/DXaVQqGZtjK4cacxhbTEVTCIUKuSLkHKIIM2eFYWyUyZmc
j5sbkfOFG9cOYePG5sLQcIPx+c/Fp6f3eb+/9/97n/4reX550cpWIYQkPzqo
w1uH0KI2qeujQihNCCEtLoSaziFMiw7hY9sQ+sWE8CE2hFsdQ+hkP4FY4olj
newr9TUveUMzJZ65Eh/CVS5ymUsscX6OZ8aRzQTGUyq/w3M72cp2trFMPt/+
FPIi78VUlsrX2T/CIWo5zA397+oPutGD7jzz/p/t/XSnUe42xBl/rEerG929
0gzGmsuEyCzMJFcttq5RN9lf4Iws2Wrn/GrvXOckms0jZwyz14/+JNOXPpFZ
ye+Vz+3kXC7rXSLPna5H3pUrXOMqpfoH5afI5nNXr5F8/QfqQ+5xnyYW6NfJ
z5CdzlO9JxTovzbrZl7wipe0lTkmH+f3WHawnX38do+h7hPVLoTJ5pPu3TM5
Kd/Xl+WYORw3jzq12XwK1XrrWjXJ/gm5DPl6tbd1pvkMct4v577Te+uz3zGT
Yo7qJcrXqkXWhTz27o/Y7Jl59uZH/t76BRySK3evA2qe9WTm2i9hg/xsdQ4T
9SexX26F/C41xzqbWfaLqZBvsHeekWRFvvNy0fa2qlmyY2jkDs/1Hnqmp/t0
da8zZrRFb4z8JrXF96HKHHLMY4O6zHzS1RTrEvWT/Y1yF+jisyrN95tzUp33
ybkP9NP8DUbw3n4v9Zqzq/QbqDGTXVSzh91kem6dup7B3nEIFbLnqNRbQwVV
rCVDfpW6mgGyA1kle5bleisoo5yVjJRfqC4iRTaVMtnT/I3MSr8jMdy0fi+f
7D5f2/gumM9ivVMsdp9G69vm8MVchrX+/7/nH08+lLo=
         "]]},
       "0"],
      Annotation[#, 0, "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1FdsjmEYxvFX1TiwWyWxWiItalcpKsQoEqO1RxwghAoSKzUjsVpdHIjR
2jsSWtqKLVSIxIFIOLcSoxKidSD4PXHw73Vf93Pd9zu+72vS4jU5qxtFUdTb
n2Yto6hd2yhqSuPoGfqJrmsRRQPaRFF/bObzMKFVFG2nO7AF27AVi/U3yafJ
DsZ+vQJk6ZfQUhSiGEVowDXXGSE7HBmI4zvpZ9L81lE0ihbQBGftkYTumK43
DVPRyf4ZuO/aee3cJ87JnEW9XVft+K7+gWtydfwLOguz8RAP8NT8HNoX9bIN
+IVb/Ew7Z2GKfTnmb+nfRq7rd+RX0A50JU2U3yYbiyZojGZoirUyx+04gWMo
RxlWmZnnfD7mYiEWYKN8pfPr4TlQEd4Z4p09d5aiTqbJNIX2oq89xyv3Np9f
xC+VXYI7rtGIj/DX+UB+nPt9I1+oHiLz00warafpwTvLlnnJ/6HjMQFF8pW4
jkGIsbMxYnGXvxc+DyzDArM9XW+iuSyctLeX3iZ1d/TAZdepMluNG7iJGoyV
O08vYJwd41Egewmnw/cUp3AOZzFa/gg9GmrZMdglexHd9Lo470q70kT6Qr8k
fLZ8nfqJ+/1GD+v1U+/FHuxGjV3VqMId+RiZ5vof3X8+/4Huo8/s3an/xJ4M
vVT1IdkvfK36c3incsV6teor9lWoE/Q6mx3JZ6KG/81vlhnGD8VB/gBWO5tu
JhtD9NORJ5dr/wY6KHy+mOx8EpbLn3B2EukYifVyX8O7c5Yq2yf8xvjmfLmZ
0vC8MkXqyXrv1Y/NfaAH9VLU/TxfFX8s/Mbli1GEcvm34bsWfm8yZXyf8C7Q
F0f1b5jrrU5WH7DvHf9I/Zamms0IM3QYjW/7/3/UP2xfnB8=
         "]]},
       RowBox[{"-", "1"}]],
      Annotation[#, -1, "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl099PzXEcx/FPNimrk5DNzxzGjfnxH7jAZhipLkQu2CpDHTbkwlzY3HCJ
iSszK0lMYfpxkorRDzZ0iemg6Nis/L7y+M7Fc8/P+/V+fz/f9+l04nsTxTUZ
IYQUYrkh7MoLIZfLuZFTsRBG8B771Z3yjc4P+aA6yQe4i1t4XO8LPmO2enV+
CGtQOSOEKmTK62eGMJV/y++YqZc3oDsnhJPy07Ineklzk5Zr1ruFZ/qn9M/o
9+uf5QHOljWYnc4lsq2yImzDPHWHfC7v4TgK3dVmPinL4i7+af8684/5qLqX
j3Af9/AvbjUbd15ubgmX8U7siFDnuvu6mRwu4EHZ02hvvLR7k/wVD6j70Wlm
1hRzzkN4rXfTzDC/UD+PcnfMMReTN3Iel0Xfk3fuRjmWRvvLF9sxjkOeS+C+
+Vq9K2aOR39TvbXcw4d5wjOLnAtRY74aLZ6Zr7fQMwu4mEuwHaXqb7ho5qsd
/5h/4NwhC5yBu7IBvavu7ufW6E506P31Xd5wbkKf3glZL5eaHcIg0u66Hf0P
yS/or3Aukm3y/i3YjAJ1Wv7d3j9wTz2mHsUnJNSP5Pu4m6v5o3zCeRLN6nfq
t3iDPPV6927Auug96g847/1j9si2b0qdyVmYhlrPtetddr6EdrPDPl8FV6ES
x8y0manTT7t3HNei34h6VH7OzIh6GVfIVumvzP//O/wHN6+Kbg==
         "]]},
       RowBox[{"-", "2"}]],
      Annotation[#, -2, "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl0jtPlEEUh/GxMpE7NWhoEFSinUThA0BphQ0oCCIiqBUKEdwlyMUSRay0
gN1lSZRoDFC5XFxCYvwSgoIRvFGIEfhtKJ48c/4z58zkzVvS2Hmp40gI4QWS
OSHczw3hHsoKQ1hXn+QvXM4b2SFs5Ycwrf5doMf6Jbqd78FX+SrXoBan9ZzC
MWdG80J4gnpcQQMWzLvOrbiGFjTjKSL6oqjAprln+Bt3c7HZx80s4gTH8c97
3tn/Y72DGXvb6k9ch8uZHiT1n+B5e3t65nifz8nPYtzdUe/66cwP3FK3YwR3
cBcduI1OPMeQ8/l602bl8Qon9Max7C1LWMQHea79LHkOL6vfy1NYwKQ8hiV5
lv1FzuZB83fkEd7mLVS7twofZRf4Ir7Lx3hYz0P5M+sH3G72TbThsZn9zkUx
o36NV5iV//cdjspX+JE6zQPcK+vDW+u/sje8yz1mx9Cq/wauuq8JjUjJz3Ml
Pustznwn7+qST2DNjFL1FP8qOPz3DgAg+GMt
         "]]},
       RowBox[{"-", "3"}]],
      Annotation[#, -3, "Tooltip"]& ], {}, {}}}],
  AspectRatio->1,
  Frame->True,
  FrameLabel->{
    FormBox[
    "\"\\!\\(\\*SubscriptBox[\\(k\\), \\(x\\)]\\)\"", TraditionalForm], 
    FormBox[
    "\"\\!\\(\\*SubscriptBox[\\(k\\), \\(y\\)]\\)\"", TraditionalForm]},
  FrameTicks->{{{
      NCache[-Pi, -3.141592653589793], 
      FormBox[
       RowBox[{"-", "\[Pi]"}], TraditionalForm]}, {
      NCache[Rational[-1, 2] Pi, -1.5707963267948966`], 
      FormBox[
       RowBox[{"-", 
         FractionBox["\[Pi]", "2"]}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {
      NCache[Rational[1, 2] Pi, 1.5707963267948966`], 
      FormBox[
       FractionBox["\[Pi]", "2"], TraditionalForm]}, {
      NCache[Pi, 3.141592653589793], 
      FormBox["\[Pi]", TraditionalForm]}}, {{
      NCache[-Pi, -3.141592653589793], 
      FormBox[
       RowBox[{"-", "\[Pi]"}], TraditionalForm]}, {
      NCache[Rational[-1, 2] Pi, -1.5707963267948966`], 
      FormBox[
       RowBox[{"-", 
         FractionBox["\[Pi]", "2"]}], TraditionalForm]}, {0, 
      FormBox["0", TraditionalForm]}, {
      NCache[Rational[1, 2] Pi, 1.5707963267948966`], 
      FormBox[
       FractionBox["\[Pi]", "2"], TraditionalForm]}, {
      NCache[Pi, 3.141592653589793], 
      FormBox["\[Pi]", TraditionalForm]}}},
  PlotRange->
   NCache[{{-Pi, Pi}, {-Pi, Pi}}, {{-3.141592653589793, 
    3.141592653589793}, {-3.141592653589793, 3.141592653589793}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.6036930100783863`*^9, 3.6036930408832607`*^9}, 
   3.603693201247554*^9, 3.6036932551432533`*^9, 3.603693287881331*^9, {
   3.6036933651562653`*^9, 3.603693379271288*^9}, {3.603693411824589*^9, 
   3.603693417017581*^9}, {3.60369381980022*^9, 3.603693832337619*^9}, {
   3.604372727053968*^9, 3.604372747249778*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<tightBinding3D.pdf\>\"", ",", "tightBinding3D"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{"\"\<tightBindingContour.pdf\>\"", ",", "tightBindingContour"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.603693290438525*^9, 3.6036933278694*^9}, {
  3.6036933742679167`*^9, 3.60369337622892*^9}}]
},
WindowSize->{740, 867},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 191, 4, 27, "Input"],
Cell[CellGroupData[{
Cell[773, 28, 1639, 42, 53, "Input"],
Cell[2415, 72, 170255, 2813, 297, 93340, 1552, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[172707, 2890, 1478, 40, 53, "Input"],
Cell[174188, 2932, 102563, 1736, 386, "Output"]
}, Open  ]],
Cell[276766, 4671, 412, 10, 43, "Input"]
}
]
*)

(* End of internal cache information *)
